unit AsmDefs;

interface

uses SysUtils,classes,StdCtrls,ComCtrls,PlusMemo,PlusGutter;

Const
  NumberOfEditItems= 100;
  NumberOfMacros=256;
  ProjectFileStart=4;
  NumberOfMaps=100;
  MAX_EXPR_VAR = 20;
  MAX_EXPR_FUNC = 8;
  MAX_EXPR_STACK = 100;

  CodeSegment=0;
  DataSegment=1;
  XDataSegment=2;
  BitSegment=3;
  IDataSegment=4;
  NumberOfMnemonics = 189;

  Ms: array[0..NumberOfMnemonics-1] of string =                                 //ss [7]
  ('.CALL','.CALLZ','.JMP','.JMPCC','.JMPCS','.JMPEQ','.JMPNE','.LDB','.LDL',
   '.LDLI','.LDW','.LDWI','.LPM','.POP','.POPBA','.POPBB','.POPLA','.POPLB','.POPWA','.POPWB',
   '.PUSH','.PUSHBA','.PUSHBB','.PUSHLA','.PUSHLB','.PUSHWA','.PUSHWB','.PUSHZ',
   '.STB','.STL','.STW',
   'ABS','ADC','ADD','ADIW','AND','ANDI','ASR','BCLR','BLD','BRBC',
   'BRBS','BRCC','BRCS','BREQ','BRGE','BRHC','BRHS','BRID','BRIE',
   'BRLO','BRLT','BRMI','BRNE','BRPL','BRSH','BRTC','BRTS','BRVC',
   'BRVS','BSET','BST','CALL','CBI','CBR','CLC','CLH',
   'CLI','CLN','CLR','CLS','CLT','CLV','CLZ','CODE','CODESP','COFF_FE','COFF_FN','COFF_SM','COFF_VR','COM','CONST',
   'CP','CPC','CPI','CPSE','DATA','DB','DCA','DEC','DEF','DEFREG','DL','DS','DVAR','DW','E2DATA','ELPM',
   'END','ENDIF','EOR','EQU','EXLPM','EXT','EXTERN','FILE','FMUL','FMULS','FMULSU','GLOBAL','ICALL','IFFALSE',
   'IFREF','IFTRUE','IJMP','IMPORT','IN','INC','INCLUDE','JMP',
   'LD','LDD','LDI','LDS','LIBRARY','LINE','LINK','LLCHAR','LOAD','LPM','LSL','LSR','MACRO','MEMERR',
   'MOV','MOVW','MUL','MULS','MULSU','NEG','NOP','OR','ORG','ORI','OUT','POP','PUBLIC','PUSH',
   'RCALL','REGADD','REGEND','REGNOT','REGUSE','REPORT','RET','RETI','RJMP','ROL','ROR','RUNEND','SBC',
   'SBCI','SBI','SBIC','SBIS','SBIW','SBR','SBRC','SBRS','SEC',
   'SEH','SEI','SEN','SER','SES','SET','SEV','SEZ','SLEEP','SPM',
   'ST','STD','STS','SUB','SUBI','SWAP','TRIM','TST','WDR');

type
   ECompileError= class(Exception);
   TBuffer= array[0..256*1024] of byte;
   TEditItem = record
      Used:      boolean;
      Filename:  string;    //ss   [128];
      Editor:    TPlusMemo;
      Gutter:    TPlusGutter;
      TabSheet:  TTabSheet;
      ASMLine,
      PASLine:   longint;
      end;

  PProcedureCall = ^TProcedureCall;
  TProcedureCall = procedure;

  Optype = (operation, funct, pushvar, pushnum,eos);
  RPN_Rec = record
              Operatype : Optype;
              Index, Priority : INTEGER;
              Value : REAL;
            end;
//  string4 = string[4];
  TFType = (SourceFile,OtherFile,EncryptedFile);

  Var_Vector = array [1..MAX_EXPR_VAR] of real;
  RPN_Array = array [1..MAX_EXPR_STACK] of RPN_Rec;

  TSpaceTerminator = (spSpaceIsTerminator, spSpaceNotTerminator);
  TLabelType = (ltInternal, ltExternal);

var
   EditList: Array [0..NumberOfEditItems-1] of TEditItem;

   MsList,
   OpLines,
   Project,
   LinkProject,
   Includes,
   MacroArguments,
   MacroCall,
   Global,
   RunWhenDoneFiles,
   AssemblerSource,
   InfoList,
   ReferenceList,
   PointerForwards,
   {SFRs,}
   SourceFiles,
   ALabels,
   RegsUsed: TStringList;


  ProjectChanged,
  FirstActivation,
  Comma,
  Error,
  Quotes,
  EndIt,
  CurrentFileIsInclude,
  LineHasNoLabel,
  InsideMacro,
  ValueIsExternal,
  ValueIsAbsolute,
  ValueIsRelocatable,
  MacroComma,
  ExpandingMacro,
  Number,
  ExpressionSpecialCharacter,
  ValueIsExpression,
  AddTheLabel,
  ValueIsEquate,
  NoExternals,
  FindIfEnd,
  CanReplace,
  ExpressionHasRelocatables,
  ExpressionContainsDollar,
  HasFarCall,
  NextCharIsCntrl,
  Found,
  doReplaceAll,
  AutoIndent,
  INIAutoIndent,
  WriteSymbolFile,
  Tiny,
  LowStructures,
  SmallStack,
  SwapBytes,
  NoConst,
  COFFEnabled,
  OBJEnabled: boolean;

  EHeight,EWidth,ETop,ELeft,LinePointer,Pass,
  MacroCount,CurrentMacro,
  ExpressionPointer,Segment,
  RelativeBranch,ActiveIFStatements,FindLine,FindPosition,
  FindLength,LastLinePointer,LastLocalLabelRef,CurrentE2Map,
  CurrentCodeMap,CurrentDataMap,LastLabelPointer,CurrentABSMap,CurrentConstMap,
  LastLabelInserted,OffsetType,CodeAtPhase,StartPhase,NumberOfCodeMaps,
  NumberOfDataMaps,NumberOfABSMaps,NumberOfE2Maps,NumberOfConstMaps,
  If_SkipLevel: word;

  LinkFileNumber,
  RelocationCode,
  Wim,
  CloneMode,
  CloneIndex: byte;

  LastLabel,
  CItem:  string;                                                                //ss short
  IncludeFileName,
  MacroItem,
  MacroLine,
  MacroArgument: string;                                                         //ss short
  Expression,                                                                    //ss short
  OriginalLine: string;                                                          //ss short

//  IndexItem: string[128];
  AssemblyPointer,LastDWord,BufferPointer,Dollar,SearchPosition,SearchLine,
  DataSize,CodeSize,ExeSize,XDataSize,BitSize,
  LastLabelReference,CharPos,LastLoadAddress,offset,LastValue,
  CodeAssemblyPointerAtSOF,DataAssemblyPointerAtSOF,IncludeLineNumber,
  ConstAssemblyPointerAtSOF,E2AssemblyPointerAtSOF,MacroPointer,
  BufferSize,LineNumber: LongInt;


  Macro: Array[0..NumberOfMacros-1] of TStringList;
  Buffer: ^TBuffer;
  CurrentFile,ErrorString,LinkerString: string;
  Data,DataMarker: Word;
  Code,CodeMarker: word;
  DataLoad,CodeLoad,ABSLoad,BuildLabel: longint;
  CodeMap,DataMap,ABSMap,E2Map,ConstMap:
                     array[0..NumberOfMaps] of record
                       fromADR,toADR: longInt;
                       Kind: byte;
                     end;
  SymFile: TextFile;
//  BuildComment: string;                                                          //ss short
  AsmFilePath: string;    //aa
  DeviceCode: string;                                                            //ss [20];
  ErrorStr: string;
  
implementation

end.
