unit BlockA;

interface

uses SysUtils,AsmDefs,PascalDefs,AsmPas, StringConversion;

procedure BLOCK( FSYS:SYMSET; ISFUN:boolean; LEVEL:integer; var StubProcedure: Boolean;
                 FuncExit: word; var DSize: word );
procedure ENTERARRAY( TP: TYPES; L,H: INTEGER );
function StringArray(X: word): boolean;
function ArrayOfStrings(X: word; var Rx: word): boolean;

implementation

uses Compiler,PasSym,Init;

type
  xxx= record
          bval: byte;
          wval: word;
       end;

const
  cxxx: array[0..1] of xxx =
        ((bval:0; wval:0),(bval:0; wval:0));

procedure ENTERARRAY( TP: TYPES; L,H: longint );
begin
  if L > H then CError(27);
  if ( L > $FFFF ) OR ( H > $FFFF ) then CError(27);
  if ArrayTableIndex = SizeOfArrayBlock then FATAL(4) else
  begin
    inc(ArrayTableIndex);
    with ArrayTable[ArrayTableIndex] do begin
      INXTYP := TP;
      LOW := L;
      HIGH := H
    end;
  end;
end; { ENTERARRAY }

function StringType(X: Item): boolean;
begin
  result:=false;
  if X.TYP=Arrays then
    if ArrayTable[X.Ref].ElTyp=CHARS then Result:=true;
end;

function StringArray(X: word): boolean;
begin
  result:=false;
  with IdentifierTable[x] do
  begin
    if TYP=ARRAYS then
    if ArrayTable[REF].ELTYP=CHARS then result:=true;
  end;
end;

function ArrayOfStrings(X: word; var Rx: word): boolean;
var
  R: word;
label 1;
begin
  result:=false;
  R:=IdentifierTable[x].Ref;
  rx:=R;
  if IdentifierTable[x].TYP=ARRAYS then
  begin
1:
    if ArrayTable[R].ELTYP=CHARS then
    begin
      result:=true;
      exit;
    end else
    if ArrayTable[R].ElTyp=ARRAYS then
    begin
      R:=ArrayTable[R].ElRef;
      Rx:=R;
      goto 1;
    end;
  end;
end;

procedure BLOCK( FSYS:SYMSET; ISFUN:boolean; LEVEL:integer; var StubProcedure: Boolean;
                 FuncExit: word; var DSize: word );

type CONREC = record
                TP: Types;
                case integer of
                0: (I: longint);
                1: (R: Single);
              end;

var DataAllocationIndex  : INTEGER;   (* data allocation index     *)
    ProcedureIDTableIndex : INTEGER;   (* T-index of this procedure *)
    ProcedureBlockIndex : INTEGER;   (* B-index of this procedure *)
    X,Ip: INTEGER;
    InitialStack,FP,PN: word;
    FirstParameter,NumberOfParameters,ix,btix,AbsoluteValue,
    CurrentAssignmentTarget,i,np,FrameSize,ExtraOffset,LocalVarSize,VarFrag,
    jmpx: word;
    IsAbsoluteProcedure,DereferenceLeft,
    DereferenceRight: boolean;

{==============================================================================}

function IDName(ix: word): string;                                               //ss short

   begin
   result := IdentifierNames[IdentifierTable[ix].NameLookup];
   end;

function IsWith(var ID: word): boolean;
var
  p,n: word;
begin
  result:=false;
  if NumberOfWiths=0 then exit;
  n:=NumberOfWiths;
  while n>0 do
  begin
    p:=WithInfo[n-1].ID+1;
    while (IdentifierTable[p].Field) and (p<=IDTableIndex) do
    begin
      if IdentifierNames[IdentifierTable[p].NameLookup]=Identifier then
      begin
        ID:=p;
        StartRecording;
        ASM109(n-1,IdentifierTable[p].ADR);
        WithIsActive:=true;
        result:=true;
        exit;
      end;
      inc(p);
    end;
    dec(n);
  end;
end;

function ConstantAddress(I: word; var w: word): boolean;
begin
  w:=0;
  result:=false;
  repeat
    with IdentifierTable[i] do
    begin
      if IsAbsolute=1 then
      begin
        w:=Address; result:=true; exit;
      end else
      if IsAbsolute=2 then
      begin
        I:=address;
      end else exit;
    end;
  until false;
end;

procedure Convert(X,Y: Item; I: word; Tis,DerefLeftPtr: boolean);  {X=target, Y=source}
begin
  If ((X.TYP<=Lints) and (Y.TYP<=Lints))then
  begin
    if IdentifierTable[I].Normal and not DerefLeftPtr then
    begin
      if Tis then Asm3(X.TYP) else ASM38(X.TYP,Y.TYP,I);
    end else
        ASM38x(X.TYP,I);
    exit;
  end;
  if ((X.TYP=CHARS) and (Y.TYP=BYTES)) or ((X.TYP=BYTES) and (Y.TYP=CHARS)) then
  begin
    if IdentifierTable[I].Normal and not DerefLeftPtr then
    begin
      if Tis then Asm3(X.TYP) else ASM38(X.TYP,Y.TYP,I);
    end else
      ASM38x(X.TYP,I);
    exit;
  end;
  if ((X.TYP=INTS) and (Y.TYP=CHARS)) or ((X.TYP=CHARS) and (Y.TYP=INTS)) then
  begin
    if IdentifierTable[I].Normal and not DerefLeftPtr then
    begin
      if Tis then Asm3(X.TYP) else ASM38(X.TYP,Y.TYP,I);
    end else
      ASM38x(X.TYP,I);
    exit;
  end;
  if (X.TYP=ARRAYS) and (Y.TYP=Chars) then
    if (ArrayTable[X.REF].ElTyp=Chars) then
  begin
    Asm105; {convert char on stack to string[1]}
    if TIS then ASM38xx(X,I) else
      if IdentifierTable[I].IsPointer then
        ASM38x(X.TYP,I) else ASM38(X.TYP,Y.TYP,I);
    exit;
  end;
  if (X.TYP<=INTS) and (Y.PTR) then
  begin {should be trying to assign a string pointer to an int}
    if IdentifierTable[I].Normal then
      ASM38(X.TYP,Y.TYP,I) else
        ASM38x(X.TYP,I);
    exit;
  end;
  if (X.TYP<>NOTYP) AND (Y.TYP<>NOTYP) then CERROR(46);
end;

{==============================================================================}

procedure EnterForward(S: String; x: word);                                      //ss short

   var  XL: longint;
        I: word;

   begin
   XL := X;
   I := Forwards.Count;
   if I >= NumberOfForwardDeclarations then
      CError(110);
   ForwardDeclaration[I].BlockTableIndex := BlockTableIndex;
   ForwardDeclaration[I].FirstParameter := FirstParameter;
   ForwardDeclaration[I].NumberOfParameters := NumberOfParameters;
   ForwardDeclaration[I].CurrentProcedureIndex := CurrentProcedureIndex;
   Forwards.AddObject(S, pointer(XL));
   end;

{==============================================================================}

function IsForward(S: string; var X: word) : boolean;                            //ss short

   var I: integer;
       XL: longint;

   begin
   result := false;
   I := Forwards.IndexOf(S);
   if I < 0 then
      exit;
   result := true;
   XL := longInt(Forwards.Objects[I]);
   X := XL;
   end;

{==============================================================================}

function GetForward(S: string; var X,BT,P,NP,CP: word) : boolean;                //ss short

   var  I: integer;
        XL: longint;

   begin
   result := false;
   I := Forwards.IndexOf(S);
   if I < 0 then
      exit;
   result := true;
   XL := longInt(Forwards.Objects[I]);
   X := XL;
   with ForwardDeclaration[I] do
      begin
      BT := BlockTableIndex;
      P := FirstParameter;
      NP := NumberOfParameters;
      CP := CurrentProcedureIndex;
      end;
   end;

{==============================================================================}

procedure EnterBlock;

   begin
   if BlockTableIndex = SizeOfBlockTable then
      Fatal(2)
   else
      begin
      BlockTableIndex := BlockTableIndex+1;
      BlockTable[BlockTableIndex].Last := 0;
      BlockTable[BlockTableIndex].LastPar := 0;
      end;
   end; { ENTERBLOCK }

{==============================================================================}

procedure Skip(FSYS: SYMSET; N: integer);

   begin
   CError(N);
   SkipFlag := TRUE;
   while not (LastSymbol in FSYS) do
      GetNextSymbol;
   if Skipflag then
   EndSkip;
   end; { SKIP }

{==============================================================================}

procedure Test(S1,S2: SYMSET; N: integer);

   begin
   if not (LastSymbol in S1) then
      Skip(S1 + S2, N);
   end; { TEST }

{==============================================================================}

function GetIdentifierLocation( var Identifier: string; ErrorIfnotFound, ErrorIfE2Var: boolean): integer;

   var  I,J: Integer;
        HASHID: word;

   label X1;

   begin
//   StrToShort (Identifier, Str);
   HashID := GetHashID (Identifier);
//   length (Identifier);
//   HASHID := HASHID or (ord (Identifier[1]) shl 8);
//   move (Str, HASHID, 2);
   I := Level;
   repeat
      J := BlockTable[Display[I]].Last;
x1:
      while (J <> 0) and (IdentifierTable[J].HashID <> HashID) do
         J := IdentifierTable[J].Link;
      if (J <> 0) and (IdentifierNames[IdentifierTable[J].NameLookup] <> Identifier) then
         begin
         J := IdentifierTable[J].Link;
         goto x1;
         end;

      I := I-1;
      until (I < 0) OR (J <> 0);

   if (J = 0) and ErrorIfNotFound then
      CError(0);
   GetIdentifierLocation := J;
   if (J <> 0) then
      if ErrorIfE2Var then
         begin
         if IdentifierTable[J].E2Var then
            CError(112);
         end;
   end; { GetIdentifierLocation }

procedure TESTSEMICOLON;
begin
  if LastSymbol = SEMICOLON then GetNextSymbol else CError(14);
  TEST([IDENT]+BLOCKBEGSYS+[IMPLEMENTATIONSY], FSYS, 6)
end; { TESTSEMICOLON }

function VarFinish(var v: word) : boolean;
var
  I: Integer;
label DoAbs;
begin
  result:=false;
  v:=0;
  if LastSymbol = SEMICOLON then GetNextSymbol else
  begin
    if LastSymbol=ABSOLUTESY then goto DoAbs;
    CError(14);
    if LastSymbol IN [COMMA,COLON] then GetNextSymbol
  end;
  if LastSymbol = GLOBALSY then
  begin
    if UnitSystem and InterfaceSection then CError(128);
    result:=true; GetNextSymbol; v:=1;
    if LastSymbol = SEMICOLON then GetNextSymbol else
    begin
      CError(14);
      if LastSymbol IN [COMMA,COLON] then GetNextSymbol
    end;
  end else
  if LastSymbol = EXTERNALSY then
  begin
    result:=true; v:=2; GetNextSymbol;
    if LastSymbol = SEMICOLON then GetNextSymbol else
    begin
      CError(14);
      if LastSymbol IN [COMMA,COLON] then GetNextSymbol
    end;
  end else
  if LastSymbol = ABSOLUTESY then
  begin
DoAbs:
    //if DynamicVars then CError(118);
    result:=true; v:=4; GetNextSymbol;
    if LastSymbol in [BYTECON,INTCON,WORDCON] then
    begin
      AbsoluteValue:=IntegerNumeric; GetNextSymbol;
    end else
    if LastSymbol = IDENT then
    begin
      v:=8; GetNextSymbol;
      I := GetIdentifierLocation (Identifier, true, true);
      if I>0 then AbsoluteValue:=I;
    end else if LastSymbol <> LINTCON then CError(44) else CError(61);
    if LastSymbol = SEMICOLON then GetNextSymbol else
    begin
      CError(14);
      if LastSymbol IN [COMMA,COLON] then GetNextSymbol
    end;
    if LastSymbol = GLOBALSY then
    begin
      if UnitSystem and InterfaceSection then CError(128);
      v:=v or $10;
      GetNextSymbol;
      if LastSymbol = SEMICOLON then GetNextSymbol else
      begin
        CError(14);
        if LastSymbol IN [COMMA,COLON] then GetNextSymbol
      end;
    end;
  end;
  TEST([IDENT]+BLOCKBEGSYS+[ImplementationSY], FSYS, 6)
end; { TESTSEMICOLON }

function ConstFinish(var v: word) : boolean;

begin
  result:=false;
  v:=0;
  if LastSymbol = SEMICOLON then GetNextSymbol else
  begin
    CError(14);
    if LastSymbol IN [COMMA,COLON] then GetNextSymbol
  end;
  if LastSymbol = GLOBALSY then
  begin
    if UnitSystem and InterfaceSection then CError(128);
    result:=true; GetNextSymbol; v:=1;
    if LastSymbol = SEMICOLON then GetNextSymbol else
    begin
      CError(14);
      if LastSymbol IN [COMMA,COLON] then GetNextSymbol
    end;
  end;
end;

{==============================================================================}

procedure EnterNewIdentifier( Identifier: string; K: POBJECT );             //ss short IdentifierNames = TStringList

   var  J,L: integer;

   begin
   if IdTableIndex = SizeOfIdentifierTable then
      FATAL(1)
   else
      begin
      inc(NumberOfParameters);
      J := BlockTable[DISPLAY[LEVEL]].LAST;
      L := J;
      while (J <> 0) and (IdentifierNames[IdentifierTable[J].NameLookup] <> Identifier) do
         begin
         J:= IdentifierTable[J].Link;
         end;

      if J <> 0 then
         CError(1)
      else
         begin
         inc(IdTableIndex);
         with IdentifierTable[IdTableIndex] do
            begin
            NameLookup := IdentifierNames.Count;
            IdentifierNames.Add(Identifier);
//mov        move(Identifier,HASHID,2);
            HASHID := GetHashId (Identifier);
//            StrToShort (Identifier, Str);
//            move (Str, HASHID, 2);
            LINK := L;
            OBJ  := K;
            TYP  := NOTYP;
            REF  := 0;
            LEV  := LEVEL;
            ADR  := 0;
            Size := 0;
            if K=TVariable then
               begin
               if Level > 1 then
                  IsDynamic:=DynamicVars
               else
                  IsDynamic:=false;
               end;

            IsAbsolute := NotAbsolute;
            Address := 0;
            Ptr := 0;
            Field := false;
            Extern := false;
            Global := false;
            IsPointer := false;
            Block := CurrentProcedureIndex;
            TypedConstant := false;
            if SharedData then
               begin
               SharedWith := ShareDataWith;
               end
            else
               SharedWith := 0;

            if (K = TVariable) or (K = TFunc) then
               begin
               ResetShare := NextVarResetsShare;
               NextVarResetsShare := false;
               end;

            E2Var:=false;
            end;
         end;

      BlockTable[DISPLAY[LEVEL]].LAST := IdTableIndex;
      end;
   end; { EnterNewIdentifier }

{==============================================================================}

procedure EnterVariable;

   begin
   if LastSymbol = IDENT then
      begin
      if Level <= 2 then
         IntFileAdd(Identifier);
      EnterNewIdentifier(Identifier, TVARIABLE);
      GetNextSymbol;
      end
   else
      CError(2);
   end; { EnterVariable }

{==============================================================================}

procedure Constant(FSYS: SYMSET; var C: CONREC);

   var  X, SIGN: integer;
        SX: string;                                                                    //ss [20];

   label  StrAdd, EnterFromChar;

   begin
   C.TP := NOTYP;
   C.I  := 0;
   Test(CONSTBEGSYS, FSYS, 50);
   if LastSymbol in CONSTBEGSYS then
      begin
      if LastSymbol = CHARCON then
         begin
         C.TP := CHARS;
         C.I  := IntegerNumeric;
         if Level = 1 then
            IntFileAdd('#' + IntToStr(C.I));
         GetNextSymbol;
         end
      else
         begin
         SIGN := 1;
         if LastSymbol IN [PLUS,MINUS] then
            begin
            if LastSymbol = MINUS then
               SIGN := -1;
            if Level = 1 then
               IntFileAdd('-');
            GetNextSymbol;
            end;

         if LastSymbol = IDENT then
            begin
            if Level = 1 then
               IntFileAdd(Identifier);
            X := GetIdentifierLocation(Identifier, true, true);
            if IdentifierTable[X].Obj <> TCONSTANT then
               CError(25);
            C.TP := IdentifierTable[X].Typ;
            case IdentifierTable[X].Typ of
               BOOLS,
               BYTES,
               SINTS,
               CHARS,
               WORDS,
               INTS,
               TRIPPLETS,
               LINTS,
               SINGLES:
                  begin
                  IntegerNumeric := IdentifierTable[X].Value;
                  case IdentifierTable[X].Typ of
                     BOOLS:
                        LastSymbol := BOOLCON;
                     BYTES:
                        LastSymbol := BYTECON;
                     CHARS:
                        LastSymbol := CHARCON;
                     INTS,
                     SINTS:
                        LastSymbol := INTCON;
                     WORDS:
                        LastSymbol := WORDCON;
                     LINTS,
                     TRIPPLETS:
                        LastSymbol := LINTCON;
                     SINGLES:
                        LastSymbol := SINGLECON;
                     end;
                  end;

               CSTRINGS:
                  begin
                  StringContent := StringConstants[IdentifierTable[X].Value];
                  LastSymbol := STRINGCON;
                  end;
               end;
            end;

         case LastSymbol of
            CHARCON:
               begin
               C.TP := CHARS;
               C.I := IntegerNumeric;
               GetNextSymbol;
               if LastSymbol = PLUS then
                  begin
                  C.TP := CSTRINGS;
                  C.I := StringConstants.Count;
                  StringContent := char(IntegerNumeric);
                  StringConstants.Add(StringContent);
                  goto EnterFromChar;
                  end;

               if Level = 1 then
                  IntFileAdd('#' + IntToStr(C.I));
               end;

            BOOLCON:
               begin
               C.TP := BOOLS;
               C.I := IntegerNumeric;
               GetNextSymbol
               end;

            BYTECON:
               begin
               C.TP := BYTES;
               C.I := SIGN*IntegerNumeric;
               if Level = 1 then
                  IntFileAdd(IntToStr(C.I));
               GetNextSymbol
               end;

            INTCON:
               begin
               C.TP := INTS;
               C.I := SIGN * IntegerNumeric;
               if Level = 1 then
                  IntFileAdd(IntToStr(C.I));
               GetNextSymbol
               end;

            WORDCON:
               begin
               C.TP := WORDS;
               C.I := SIGN * IntegerNumeric;
               if Level = 1 then
                  IntFileAdd(IntToStr(C.I));
               GetNextSymbol
               end;

            SINGLECON:
               begin
               C.TP := Singles;
               C.R  := SIGN * SingleNumeric;
               if Level = 1 then
                  begin
                  str(C.R, SX);
                  IntFileAdd(SX);
                  end;
               GetNextSymbol;
               end;

            LINTCON:
               begin
               C.TP := LINTS;
               C.I := SIGN * IntegerNumeric;
               if Level = 1 then
                  IntFileAdd(IntToStr(C.I));
               GetNextSymbol;
               end;

            STRINGCON:
               begin
               C.TP:=CSTRINGS;
               C.I:=StringConstants.Count;
               StringConstants.Add(StringContent);
               if Level = 1 then
                  IntFileAdd('''' + StringContent + '''');
StrADD:        GetNextSymbol;
EnterFromChar: if LastSymbol = PLUS then
                  begin
                  if Level=1 then
                     IntFileAdd('+');
                  GetNextSymbol;
                  if LastSymbol = CHARCON then
                     begin
                     if Level = 1 then
                        IntFileAdd('#' + IntToStr(IntegerNumeric));
                     StringConstants[C.I] := StringConstants[C.I] + chr(IntegerNumeric);
                     end
                  else if LastSymbol = STRINGCON then
                     begin
                     if Level=1 then
                        IntFileAdd('''' + StringContent + '''');
                     StringConstants[C.I] := StringConstants[C.I] + StringContent;
                     end
                  else if LastSymbol = IDENT then
                     begin
                     X := GetIdentifierLocation(Identifier, true, true);
                     if IdentifierTable[X].Obj <> TCONSTANT then
                        CError(25);
                     if IdentifierTable[X].Typ = CSTRINGS then
                        begin
                        if Level = 1 then
                           IntFileAdd('''' + StringConstants[IdentifierTable[X].value] + '''');
                        StringConstants[C.I]:= StringConstants[C.I] + StringConstants[IdentifierTable[X].Value];
                        end
                     else if IdentifierTable[X].Typ = CHARS then
                        begin
                        if Level = 1 then
                           IntFileAdd('''' + chr(IdentifierTable[X].value) + '''');
                        StringConstants[C.I] := StringConstants[C.I] + chr(IdentifierTable[X].Value);
                        end;
                     end;
                  goto StrADD;
                  end;
               end
            else
               SKIP(FSYS, 50);
            end;
         end;

      TEST(FSYS, [], 6);
      end;
   end; { CONSTANT }

 procedure GetTypeInfo( FSYS : SYMSET;
                        var TP : TYPES;
                        var RF, SZ, SZ2 : word;
                        var PT: word;
                        var IP: boolean;
                        Passive: boolean);
 var X: INTEGER;
     ELTP: TYPES; ELRF: word;
     ELSZ,ELSZ2, OFFSET, T0,T1: word;
     PTx: word;
     XL: longint;
     dd,PointerType: boolean;

   procedure ARRAYGetTypeInfo(var AREF,ARSZ: word);
   var ELTP: TYPES;
       LOW, HIGH: CONREC;
       ELRF, ELSZ: word;
       ELIP: boolean;
   begin
     CONSTANT([COLON,RBRACK,RPARENT,OFSY]+FSYS, LOW);
     if LOW.TP = BYTES then LOW.TP:=INTS;
     if LastSymbol = COLON then GetNextSymbol else CError(13);
     if level=1 then IntFileAdd('..');
     CONSTANT([RBRACK,COMMA,RPARENT,OFSY]+FSYS, HIGH);
     {if HIGH.TP = BYTES then HIGH.TP:=WORDS;
     if LOW.TP = BYTES then LOW.TP:=WORDS;
     if (HIGH.TP <> LOW.TP) then CError(27);}
     ENTERARRAY(WORDS, LOW.I, HIGH.I);
     AREF := ArrayTableIndex;
     Elip:=false;
     if LastSymbol = COMMA then
     begin
       if level=1 then IntFileAdd(',');
       GetNextSymbol;
       ELTP := ARRAYS;
       ARRAYGetTypeInfo(ELRF,ELSZ)
     end else
     begin
       if LastSymbol = RBRACK then
       begin
         GetNextSymbol;
         if level=1 then IntFileAdd(']');
       end else CError(12);
       if LastSymbol = OFSY then
       begin
         GetNextSymbol;
         if level=1 then IntFileAdd(' of ');
       end else CError(8);
       GetTypeInfo(FSYS,ELTP,ELRF,ELSZ,ELSZ2,PTx,ELIP,false);
     end;
     with ArrayTable[AREF] do
     begin
       if ELIP then ARSZ:=(HIGH-LOW+1)*2 else ARSZ:=(HIGH-LOW+1)*ELSZ;
       SIZE := ARSZ;
       ELTYP := ELTP;
       ELREF := ELRF;
       if ELIP then ELSIZE:=2 else ELSIZE:=ELSZ;
       ElSizeIfPtr := ELSZ2;
       IDREF := PTx;
       IsArrayOfPointers:=ELIP;
     end;
   end; { ARRAYTYP }

{==============================================================================}

procedure StringGetTypeInfo(var AREF,ARSZ: word);

   var LOW: CONREC;
       ELRF: INTEGER;

   begin
   Constant([RBRACK,RPARENT]+FSYS, LOW);
   if Level = 1 then
      begin
      IntFileAdd(']');
      end;
   GetNextSymbol;
   if LOW.TP = BYTES then
      LOW.TP:=INTS;
   EnterArray(LOW.TP,0,LOW.I);
   AREF := ArrayTableIndex;
   ARSZ := LOW.I+1;
   with ArrayTable[AREF] do
      begin
      SIZE := ARSZ;
      ELTYP := CHARS;
      ELREF := ELRF;
      ELSIZE:= 1;
      IDREF := 0; {PTx}
      IsArrayOfPointers:=false;
      end;
   end; { STRINGTYP }

   begin { GetTypeInfo }
   TP := NOTYP;
   RF := 0;
   SZ := 0;
   IP := false;
   TEST(TYPEBEGSYS, FSYS, 10);
   if LastSymbol in TYPEBEGSYS then
      begin
      if LastSymbol = CARET then
         begin
         if level = 1 then
            IntFileAdd('^');
         PointerType:=true;
         GetNextSymbol;
         end
      else
         PointerType:=false;

      if LastSymbol = IDENT then
         begin
         if level = 1 then
            IntFileAdd(Identifier);
         X := GetIdentifierLocation(Identifier, false, true);
         if passive and (x=0) then
            CError(0);
         if X <> 0 then
            begin
            with IdentifierTable[X] do
               if OBJ <> TTYPE then
                   CError(29)
               else
                  begin
                  TP := TYP;
                  RF := REF;
                  SZ := SIZE;
                  if TP = NOTYP then
                     CError(30);
                  PT := X;
                  IP := PointerType or IsPointer;
                  if IP then
                     SZ := 2;
                  if PointerType and not IsPointer then
                     SZ2 :=size
                  else
                     SZ2:=SizeIfPointer;

                  if ref=$FFFF then {pointer to a type not yet defined, identifier for}
                     begin             {this type exists allready}
                     XL := IDTableIndex;
                     PointerForwards.addObject(Identifier, pointer(XL));
                     SZ:=2;
                     end;
                  end;
            end
         else
            begin {pointer to a type not yet defined}
            if not pointerType then
               CError(0);
            XL := IDTableIndex;
            PointerForwards.addObject(Identifier, pointer(XL));
            TP := words;
            RF := $FFFF; {defered}
            SZ := 2;
            PT := X;
            IP := true;
            SZ2 := 0;
            end;

         if not passive then
            GetNextSymbol;
      end
   else
      if LastSymbol = ARRAYSY then
         begin
         GetNextSymbol;

         if LastSymbol = LBRACK then
            GetNextSymbol
         else
            CError(11);

         if Level = 1 then
            IntFileAdd('Array[');
         TP := ARRAYS;
         PTX := PT;
         ArrayGetTypeInfo(RF, SZ)
        end
      else if LastSymbol = STRINGSY then
         begin
         IP := PointerType;
         GetNextSymbol;

         if LastSymbol = LBRACK then
            GetNextSymbol
         else
            CError(11);

         if Level = 1 then
            IntFileAdd('String[');
         TP := ARRAYS;
         StringGetTypeInfo(RF,SZ);
         PT := 0;
         if IP then
            begin
            SZ2 := SZ;
            SZ := 2;
            end;
         if SZ > MaxStringSize then
            MaxStringSize := SZ;
         end
      else if LastSymbol = RECORDSY then
         begin { RECORDS }
         if Level = 1 then
            begin
            IntFileAdd('Record');
            IntFileAdd('');
            end;
         GetNextSymbol;
         EnterBlock;
         TP := RECORDS;
         RF := BlockTableIndex;
         if Level = MaximumLevel then
            FATAL(5);
         Level := Level + 1;
         Display[Level] := BlockTableIndex;
         Offset := 0;
         while not (LastSymbol in FSYS-[SEMICOLON,COMMA,IDENT]+[ENDSY]) do
            begin
            if LastSymbol = IDENT then
               begin   (* field section *)
               T0 := IdTableIndex;
               EnterVariable;
               while LastSymbol = COMMA do
                  begin
                  if Level=2 then
                     begin
                     IntFileAdd(',');
                     IntFileAdd('');
                     end;
                  GetNextSymbol;
                  EnterVariable;
                  end;

               if LastSymbol = COLON then
                  GetNextSymbol
               else
                  CError(5);

               if Level = 2 then
                  IntFileAdd(':' + Identifier);
               T1 := IdTableIndex;
               GetTypeInfo(FSYS+[SEMICOLON,ENDSY,COMMA,IDENT],ELTP,ELRF,ELSZ,SZ2,PTx,dd,false);
               while T0 < T1 do
                  begin
                  T0 := T0+1;
                  with IdentifierTable[T0] do
                     begin
                     TYP := ELTP;
                     REF := ELRF;
                     NORMAL := TRUE;
                     ADR := OFFSET;
                     Size := ELSZ;
                     Field := true;
                     PTR := PTX; //xxxx
                     OFFSET := OFFSET + ELSZ;
                     dd := PointerType or dd;
                     if IP then
                        begin
                        SZ2 := SZ;
                        SZ := 2;
                        end;
                     IsPointer := dd;
                     end;
                  end;
               end;

            if LastSymbol <> ENDSY then
               begin
               if LastSymbol = SEMICOLON then
                  GetNextSymbol
               else
                  CError(14);
               if Level = 2 then
                  IntFileAdd(';');
               Test([IDENT,ENDSY,SEMICOLON], FSYS, 6);
               end;
            end;

         if Level = 2 then
            begin
            IntFileAdd('end');
            end;

         BlockTable[RF].VSIZE := OFFSET;
         SZ := OFFSET;
         BlockTable[RF].PSIZE := 0;
         GetNextSymbol;
         Level := Level-1;
         end;

      if not Passive then
         TEST(FSYS, [], 6);
      end;
   end; { TYP }

   procedure PARAMETERLIST(var np: word);     (* formal parameter list *)
   var TP            :   TYPES;
       RF, SZ, SZ2, X, T0 : INTEGER;
       VALPAR,ParameterIsPointer: BOOLEAN;
   begin
     np:=0;
     if (level=2) and (LastSymbol=LPARENT) then IntFileAdd('(');
     GetNextSymbol;
     TP := NOTYP;
     RF := 0;
     SZ := 0;
     TEST([IDENT, VARSY], FSYS+[RPARENT], 7);
     while LastSymbol in [IDENT,VARSY] do
     begin
       if LastSymbol <> VARSY then VALPAR := TRUE else
       begin
         if level=2 then IntFileAdd('var ');
         GetNextSymbol;
         VALPAR := FALSE
       end;
       T0 := IdTableIndex;
       ENTERVARIABLE;
       while LastSymbol = COMMA do
       begin
         if level=2 then IntFileAdd(',');
         GetNextSymbol;
         ENTERVARIABLE;
       end;
       if LastSymbol = COLON then
       begin
         if level=2 then IntFileAdd(':');
         ParameterIsPointer:=false;
         GetNextSymbol;
         if LastSymbol <> IDENT then CError(2) else
         begin
           if level=2 then IntFileAdd(Identifier);
           X := GetIdentifierLocation(Identifier,true,true);
           GetNextSymbol;
           if X <> 0 then with IdentifierTable[X] do
             if OBJ <> TTYPE then CError(29) else
             begin
               TP := TYP;
               RF := REF;
               ParameterIsPointer:=IsPointer;
               if VALPAR then SZ := ADR else SZ := 1;
               if IsPointer then SZ2:=IdentifierTable[x].SizeIfPointer else SZ2:=IdentifierTable[x].Size;
             end;
           end;
           TEST([SEMICOLON,RPARENT], [COMMA,IDENT]+FSYS, 14)
         end else CError(5);
         while T0 < IdTableIndex do
         begin
           inc(np);
           T0 := T0+1;
           with IdentifierTable[T0] do
           begin
             TYP := TP;
             REF := RF;
             NORMAL := VALPAR;
             ADR := DataAllocationIndex;
             LEV := LEVEL;
             Size := SZ;
             if ParameterIsPointer then
               ptr:=IdentifierTable[x].ptr else ptr:=x;
             SizeIfPointer:=SZ2;
             DataAllocationIndex := DataAllocationIndex + SZ;
             IsPointer:=ParameterIsPointer;
             if Normal then FrameSize:=FrameSize+size else FrameSize:=FrameSize+2;
             StackOffset:=FrameSize;
             TShareSize:=TShareSize+Size;
             if SharedWith>0 then
             begin
               if IdentifierTable[SharedWith].typ=TShare then
                 if IdentifierTable[SharedWith].size<TShareSize then
                   IdentifierTable[SharedWith].size:=TShareSize;
             end;
             if CoffEnabled and Normal then
             begin
               if TYP in [BYTES, SINTS, WORDS, INTS, TRIPPLETS, LINTS, BOOLS, CHARS] then
               begin
                 if not IsDynamic and not E2Var then ASMVardef(T0);
               end;
             end;
{             if isDynamic then
               AsmOutput.Add(LevelID(T0)+#9+'DVAR '+IntToStr(StackOffset)+','+IntToStr(Level));
}           end
         end;
         if LastSymbol <> RPARENT then
         begin
           if LastSymbol = SEMICOLON then
           begin
             GetNextSymbol;
             if level=2 then IntFileAdd(';');
           end else CError(14);
           TEST([IDENT,VARSY], [RPARENT]+FSYS, 6)
         end
       end; { while }
     if LastSymbol = RPARENT then
     begin
       if level=2 then IntFileAdd(')');
       GetNextSymbol;
       TEST( [ SEMICOLON, COLON, ABSOLUTESY ], FSYS, 6);
       if level=2 then
       case LastSymbol of
       SEMICOLON: IntFileAdd(';');
       COLON: IntFileAdd(':');
       end;
     end else CError(4)
   end; { PARAMETERLIST }

   procedure CheckParamList(FirstParameter,NumberOfparameters: word);
   (* parameter list compare for forward declared functions/procedures *)
   var TP :   TYPES;
       RF, SZ, SZ2, X, T0 : INTEGER;
       PP,NP,TN: word;
       VALPAR,ParameterIsPointer: BOOLEAN;
   begin
     inc(Firstparameter);
     PP:=FirstParameter;
     NP:=0;
     GetNextSymbol;
     TP := NOTYP;
     RF := 0;
     SZ := 0;
     TEST([IDENT, VARSY], FSYS+[RPARENT], 7);
     while LastSymbol in [IDENT,VARSY] do
     begin
       if LastSymbol <> VARSY then VALPAR := TRUE else
       begin
         GetNextSymbol;
         VALPAR := FALSE
       end;
       T0 := PP;
       TN := PP;
       if LastSymbol=IDENT then
       begin
         if Identifier <> IDName(TN) then
            CError(127);
         inc(TN);
         GetNextSymbol;
       end;
       while LastSymbol = COMMA do
       begin
         GetNextSymbol;
         if LastSymbol=IDENT then
         begin
           if Identifier <> IDName(TN) then
              CError(127);
           inc(TN);
         end;
         GetNextSymbol;
       end;
       if LastSymbol = COLON then
       begin
         ParameterIsPointer:=false;
         GetNextSymbol;
         if LastSymbol <> IDENT then CError(2) else
         begin
           X := GetIdentifierLocation(Identifier,true,true);
           GetNextSymbol;
           if X <> 0 then
             with IdentifierTable[X] do
             begin
               if OBJ <> TTYPE then CError(29) else
               begin
                 TP := TYP;
                 RF := REF;
                 ParameterIsPointer:=IsPointer;
                 if VALPAR then SZ := ADR else SZ := 2;
                 SZ2:=IdentifierTable[x].Size;
               end;
             end;
           TEST([SEMICOLON,RPARENT], [COMMA,IDENT]+FSYS, 14);
         end;
       end else CError(5);
       while T0 < TN do
       begin
         inc(NP);
         with IdentifierTable[T0] do
         begin
           if TYP <> TP then CError(127);
           if REF <> RF then CError(127);
           if NORMAL <> VALPAR then CError(127);
         end;
         T0 := T0+1;
       end;
       if LastSymbol <> RPARENT then
       begin
         if LastSymbol = SEMICOLON then
         begin
           GetNextSymbol;
         end else
         begin
           CError(14);
         end;
         TEST([IDENT,VARSY], [RPARENT]+FSYS, 6)
       end;
       PP:=T0;
     end; { while }
     if LastSymbol = RPARENT then
     begin
       GetNextSymbol;
       TEST( [ SEMICOLON, COLON, ABSOLUTESY ], FSYS, 6);
     end else CError(4)
   end; { PARAMETERLIST }

   procedure EnterConstants(ID: word; CharsForString: boolean; NextRef: word);
   var
     ix,T,IDX,R,Ref: word;
     NeedParent: boolean;
     Sign: Integer;
   begin
     IDX:=ID;
      GetNextSymbol;
     Sign:=1;
     if LastSymbol=MINUS then
     begin
       Sign:=-1;
       GetNextSymbol;
     end;
     if LastSymbol=IDENT then
     begin
       ID:=GetIdentifierLocation(Identifier,true,true);
       if IdentifierTable[ID].OBJ=TConstant then
       begin
         Case IdentifierTable[ID].TYP of
         BYTES,SINTS,CHARS,WORDS,INTS,TRIPPLETS,LINTS,SINGLES:
         begin
           IntegerNumeric:=IdentifierTable[ID].Value;
           case IdentifierTable[ID].TYP of
           BYTES: LastSymbol:=BYTECON;
           CHARS: LastSymbol:=CHARCON;
           INTS,SINTS: LastSymbol:=INTCON;
           WORDS: LastSymbol:=WORDCON;
           LINTS,TRIPPLETS: LastSymbol:=LINTCON;
           SINGLES: LastSymbol:=SINGLECON;
           end;
         end;
         CSTRINGS:
         begin
           StringContent:=StringConstants[IdentifierTable[ID].Value];
           LastSymbol:=STRINGCON;
         end;
         end;
       end else
       if IdentifierTable[ID].OBJ=TFunc then
       begin
         if (identifier='@') or (identifier='ADDR') then
         begin
           if not ((IdentifierTable[IDX].TYP in [Words,Ints]) or
             IdentifierTable[IDX].IsPointer) then CError(97);
            if Identifier='ADDR' then NeedParent:=true else NeedParent:=false;
           if NeedParent then
           begin
             getnextsymbol;
             if lastsymbol<>LPARENT then CERROR(9);
           end;
           getnextsymbol;
           if LastSymbol=IDENT then
           begin
             ID := GetIdentifierLocation(Identifier,true,true);
             if ID <> 0 then AsmADDRRef(ID) else CError(25);
             if NeedParent then
             begin
               getnextsymbol;
               if lastsymbol<>RPARENT then CERROR(4);
             end;
             exit;
           end else CError(25);
         end else CError(25);
       end else CError(25);
     end;
     case IdentifierTable[ID].TYP of
       BOOLS:
       begin
         if IdentifierTable[ID].Obj=TConstant then
         begin
           if IdentifierTable[ID].value=0 then
             ASMConst(IdentifierTable[IDX].Size,0) else
             ASMConst(IdentifierTable[IDX].Size,1);
         end else
         begin
           if Identifier='FALSE' then ASMConst(IdentifierTable[IDX].Size,0) else
           if Identifier='TRUE' then ASMConst(IdentifierTable[IDX].Size,1) else CError(76);
         end;
       end;
       CHARS:
       begin
         if CharsForString then
         begin
           if LastSymbol = CHARCON then StringAssembly:=StringAssembly+char(IntegerNumeric) else CError(77);
         end else
         begin
           if LastSymbol = CHARCON  then
             AsmConst(IdentifierTable[IDX].Size,IntegerNumeric) else CError(77);
         end;
       end;
       BYTES:
       begin
         if LastSymbol in [BYTECON,CHARCON] then
           AsmConst(IdentifierTable[IDX].Size,IntegerNumeric) else CError(77);
       end;
       INTS,SINTS:
       begin
         if LastSymbol in [BYTECON,CHARCON,INTCON,WORDCON] then
           AsmConst(IdentifierTable[IDX].Size,Sign*IntegerNumeric) else CError(77);
       end;
       WORDS:
       begin
         if LastSymbol in [BYTECON,CHARCON,INTCON,WORDCON] then
           AsmConst(IdentifierTable[IDX].Size,IntegerNumeric) else CError(77);
       end;
       LINTS,TRIPPLETS:
       begin
         if LastSymbol in [BYTECON,CHARCON,INTCON,WORDCON,LINTCON] then
           AsmConst(IdentifierTable[IDX].Size,Sign*IntegerNumeric) else CError(77);
       end;
       SINGLES:
       begin
         if LastSymbol in [SINGLECON] then
         begin
           SingleNumeric:=Sign*SingleNumeric; ConvertZ80Single(SingleNumeric,IntegerNumeric);
           AsmConst(IdentifierTable[IDX].Size,IntegerNumeric);
         end else CError(77);
       end;
       CSTRINGS:
       begin
         if LastSymbol = STRINGCON then
           StringAssembly:=StringAssembly+StringContent else CError(77);
       end;
       RECORDS:
       begin
         if LastSymbol<>LPARENT then CError(9);
         ix:=id+1;
         if not IdentifierTable[ix].field then ix:=IdentifierTable[ix-1].ptr+1;
         while (IdentifierTable[ix].field) and (ix<IDTableIndex) do
         begin
           GetNextSymbol;
           if LastSymbol=IDENT then
           begin
             if IDName(ix) = identifier then
             begin
               GetNextSymbol;
               if LastSymbol=COLON then
               begin
                 EnterConstants(ix,StringArray(ix),0);
                 GetNextSymbol;
                 if StringArray(ix) then
                 begin
                   while LastSymbol=PLUS do
                   begin
                     EnterConstants(IX,true,0);
                     GetNextSymbol;
                   end;
                   if IdentifierTable[IX].Size=1 then
                   begin
                     AT0('DB '+IntToStr(length(StringAssembly)));
                     AsmStringConst(StringAssembly,length(StringAssembly));
                   end else
                   begin
                     if length(StringAssembly)>IdentifierTable[IX].Size-1 then
                       AT0('DB '+IntToStr(IdentifierTable[IX].Size-1)) else
                       AT0('DB '+IntToStr(length(StringAssembly)));
                     
                     AsmStringConst(StringAssembly,IdentifierTable[IX].Size-1);
                   end;
                   StringAssembly:='';
                 end;
               end else CError(5);
             end else CError(79);
           end else CError(2);
           inc(ix);
           {GetNextSymbol;}
           if IdentifierTable[ix].field then
             if LastSymbol<>Semicolon then CError(14);
         end;
         if LastSymbol<>RPARENT then CError(4);
       end;
       ARRAYS:
       begin
         if StringArray(IDX) then
         begin
           if (LastSymbol = STRINGCON) or (LastSymbol = CHARCON) then
             StringAssembly:=StringAssembly+StringContent else CError(77);
           {if IdentifierTable[ID].Size=1 then
           begin
             AT0('DB '+IntToStr(length(StringAssembly)));
             InsertStringAsDB(StringAssembly,255);
           end else
           begin
             if length(StringAssembly)+1>IdentifierTable[ID].Size then
                 AT0('DB '+IntToStr(IdentifierTable[ID].Size-1)) else
                 AT0('DB '+IntToStr(length(StringAssembly)));
             InsertStringAsDB(StringAssembly,IdentifierTable[ID].Size-1);
           end;
           StringAssembly:='';}
         end else
         if ArrayOfStrings(IDX,R) then
         begin
           if lastSymbol<>LPARENT then CError(9);
           if NextRef=0 then
           begin
             ref:=IdentifierTable[ID].ref;
           end else ref:=NextRef;
           NextRef:=0;
           ix:=ArrayTable[ref].Low;
           if (ArrayTable[ref].Eltyp=Arrays) and
            (ArrayTable[ArrayTable[ref].ElRef].Eltyp=Arrays) then
           begin
             T:=ID; NextRef:=ArrayTable[ref].ElRef;
           end else T:=ArrayTable[ref].IDREF;
           while ix<=ArrayTable[Ref].High do
           begin
             if NextRef>0 then
             begin
               EnterConstants(T,false,NextRef);
             end else
             begin
               GetNextSymbol;
               if (lastSymbol = STRINGCON) or (lastSymbol = CharCon) then
               begin
                 if length(StringContent)+1>ArrayTable[r].Size then
                   AT0('DB '+IntToStr(ArrayTable[r].Size-1)) else
                   AT0('DB '+IntToStr(length(StringContent)));
                 InsertStringAsDB(StringContent,ArrayTable[r].Size-1);
               end else CError(38);
             end;
             getnextSymbol;
             if ix<ArrayTable[Ref].High then
             begin
               if LastSymbol<>COMMA then CError(78);
               //getnextSymbol;
             end;
             inc(ix);
           end;
           if LastSymbol<>RPARENT then CError(4);
         end else
         begin
           begin
             if LastSymbol<>LPARENT then CError(9);
             if NextRef=0 then ref:=IdentifierTable[ID].ref else ref:=NextRef;
             ix:=ArrayTable[ref].Low;
             NextRef:=0;
             if ArrayTable[ref].Eltyp<>Arrays then
               T:=ArrayTable[ref].IDREF else
             begin
               T:=ID; NextRef:=ArrayTable[ref].ElRef;
             end;
             while ix<=ArrayTable[Ref].High do
             begin
               EnterConstants(T,false,NextRef);
               inc(ix);
               GetNextSymbol;
               if ix<=ArrayTable[Ref].High then
                 if LastSymbol<>COMMA then CError(78);
             end;
             if LastSymbol<>RPARENT then CError(4);
           end;
         end;
       end;
     end;
   end;

   procedure TypedConstant(ConstantIX: word);
   var
     PT: word;
     TP: Types;
     RF,SZ,SZ2,v: word;
     IP: boolean;
   begin
     {if Caret then CError(75);}
     GetNextSymbol;
     PT:=ConstantIX;
     GetTypeInfo( [EQL,IDENT,SEMICOLON] + FSYS, TP, RF, SZ, SZ2, PT, IP, false );
     with IdentifierTable[ConstantIX] do
     begin
       TYP := TP;
       REF := RF;
       LEV := LEVEL;
       ADR := DataAllocationIndex;
       Size := SZ;
       NORMAL := TRUE;
       TypedConstant := true;
       Ptr := PT;
       IsPointer:=IP;
       DataAllocationIndex := DataAllocationIndex + SZ;
     end;
     if LastSymbol=SEMICOLON then
     begin
       if UnitSystem and InterfaceSection then
       begin
         GetNextSymbol;
         if LastSymbol=ExternalSY then
         begin
           IdentifierTable[ConstantIX].Extern:=true;
           GetNextSymbol;
           if LastSymbol<>SEMICOLON then CError(14);
           GetNextSymbol;
           exit;
         end else CError(6);
       end else
       if not UnitSystem and InsideUsesClause then
       begin
         GetNextSymbol;
         if LastSymbol=ExternalSY then
         begin
           IdentifierTable[ConstantIX].Extern:=true;
           GetNextSymbol;
           if LastSymbol<>SEMICOLON then CError(14);
           GetNextSymbol;
           exit;
         end else CError(6);
       end else CError(6);
     end;
     StringAssembly:=''; //in case of string constant;
     EnterConstants(ConstantIX,StringArray(ConstantIX),0);
     GetNextSymbol;
     if StringArray(ConstantIX) then
     begin
       while LastSymbol=PLUS do
       begin
         EnterConstants(ConstantIX,true,0);
         GetNextSymbol;
       end;
       if IdentifierTable[ConstantIX].Size=1 then
       begin
         AT0('DB '+IntToStr(length(StringAssembly)));

         AsmStringConst(StringAssembly,length(StringAssembly));
       end else
       begin
         if length(StringAssembly)>IdentifierTable[ConstantIX].Size-1 then
           AT0('DB '+IntToStr(IdentifierTable[ConstantIX].Size-1)) else
           AT0('DB '+IntToStr(length(StringAssembly)));

         AsmStringConst(StringAssembly,IdentifierTable[ConstantIX].Size-1);
       end;
     end;
     if UnitSystem and InterfaceSection and (level=1) and
       not InsideUsesClause then
         IdentifierTable[ConstantIX].Global:=true;
     if ConstFinish(v) then {global keyword found}
     begin
       if v=1 then IdentifierTable[ConstantIX].Global:=true;
     end;
   end;

{==============================================================================}

procedure ConstDeclaration(E2Const: boolean);

   var  C: CONREC;
        ConstantIX: word;
        ConstantID: string;                                                         //ss short

   begin
   InsideConstantDeclaration := true;
   GetNextSymbol;
   Test( [IDENT], BLOCKBEGSYS, 2);
   while LastSymbol = IDENT do
      begin
      ConstantID := Identifier;
      GetNextSymbol;
      if LastSymbol = EQL then
         begin
         if level=1 then
            IntFileAdd(ConstantID + '=');
         GetNextSymbol;
         EnterNewIdentifier( ConstantID, TCONSTANT );
         CONSTANT( [SEMICOLON,COMMA,IDENT]+FSYS, C );
         IdentifierTable[IdTableIndex].TYP := C.TP;
         IdentifierTable[IdTableIndex].Value := C.I;
         IdentifierTable[IdTableIndex].ADR := C.I;
         IdentifierTable[IdTableIndex].REF := 0;
         TESTSEMICOLON;
         if level=1 then
            begin
            IntFileAdd(';');
            IntFileAdd('');
            end;
         end
      else if LastSymbol = COLON then
         begin
         if level=1 then
            IntFileAdd(Identifier+':');
         ConstantIX := IDTableIndex+1;
         EnterNewIdentifier(Identifier,TVARIABLE);
         if E2CONST then
            AT0('E2DATA')
         else if not NoConst then
            AT0('CONST');
         IdentifierTable[ConstantIX].E2Var := E2Const;
         IdentifierTable[ConstantIX].IsDynamic := false; //can never be alocated on the stack
         if not InsideUsesClause then
            begin
            AO(LevelID(ConstantIX) + ':');
            TypedConstant(ConstantIX);
            if Level = 1 then
               begin
               IntFileAdd(';External;');
               IntFileAdd('');
               end;
            end
         else
            begin
            TypedConstant(ConstantIX);
            end;

         if E2CONST then
            AT0('CODE')
         else if not NoConst then
            AT0('CODE');
         end
      else
         begin
         CError(16);
         end;
      end;
   InsideConstantDeclaration:=false;
   end; { CONSTDECLARATION }



   procedure TYPEDECLARATION;
   var TP        :   TYPES;
       RF, SZ, T1, SZ2: word;
       PT,SV,PC : word;
       XL : Longint;
       IP: boolean;
       PSymbol: Symbol;

   begin
     GetNextSymbol;
     TEST( [IDENT], BLOCKBEGSYS, 2);
     PointerForwards.clear;
     while LastSymbol = IDENT do
     begin
       if level=1 then IntFileAdd(Identifier+'=');
       EnterNewIdentifier( Identifier, TTYPE );
       T1 := IdTableIndex;
       GetNextSymbol;
       if LastSymbol = EQL then GetNextSymbol else CError(16);
       if LastSymbol = LParent then {new scalar type}
       begin
         if level=1 then IntFileAdd('(');
         GetNextSymbol;
         SV:=0;
         while LastSymbol=IDENT do
         begin
           if level=1 then IntFileAdd(Identifier);
           EnterNewIdentifier( Identifier, TCONSTANT );
           GetNextSymbol;
           IdentifierTable[IdTableIndex].TYP := BYTES;
           IdentifierTable[IdTableIndex].REF := 0;
           IdentifierTable[IdTableIndex].ADR := SV;
           IdentifierTable[IdTableIndex].Value := SV;
           inc(SV);
           if not (LastSymbol in [COMMA,RPARENT]) then CERROR(4);
           if LastSymbol=COMMA then
           begin
             if level=1 then IntFileAdd(',');
             GetNextSymbol;
           end else if level=1 then IntFileAdd(')');
         end;
         GetnextSymbol;
         if LastSymbol<>SEMICOLON then CError(14);
         if level=1 then IntFileAdd(';');
       TP:=BYTES; RF:=0; SZ:=1; PT:=0; IP:=false;
       end else
       begin
         GetTypeInfo([SEMICOLON,COMMA,IDENT]+FSYS, TP, RF, SZ, SZ2, PT, IP, false);
         if level=1 then IntFileAdd(';');
       end;
       with IdentifierTable[T1] do
       begin
         TYP := TP;
         REF := RF;
         ADR := SZ;
         Size :=SZ;
         Ptr := PT;
         IsPointer:=IP;
         SizeIfPointer:=SZ2;
       end;
       TESTSEMICOLON;
       if level=1 then IntFileAdd('');
     end;
     if PointerForwards.Count>0 then
     begin
       PSymbol:=LastSymbol;
       PC:=PointerForwards.Count;
       i:=0;
       while PC>0 do
       begin
         Identifier:=PointerForwards[i];
         LastSymbol:=IDENT;
         GetTypeInfo([SEMICOLON,COMMA,IDENT]+FSYS, TP, RF, SZ, SZ2, PT, IP, true);
         XL:=longint(PointerForwards.Objects[i]);
         with IdentifierTable[XL] do
         begin
           TYP := TP;
           REF := RF;
           {ADR := SZ;}
           Size := SZ;
           Ptr := PT;
           IsPointer:=true;
           SizeIfPointer:=SZ;
         end;
         inc(i); dec(PC);
       end;
       LastSymbol:=PSymbol;
     end;
   end; { TYPEDECLARATION }

   procedure LabelDeclaration;
   var T0, T1, TX: Integer;

   begin
     GetNextSymbol;
     while LastSymbol = IDENT do
     begin
       T0 := IdTableIndex;
       ENTERVARIABLE;
       while LastSymbol = COMMA do
       begin
         GetNextSymbol;
         ENTERVARIABLE;
       end;
       T1 := IdTableIndex;
       TX := T0;
       while TX < T1 do begin
         TX := TX+1;
         with IdentifierTable[TX] do begin
           TYP := Labels;
           OBJ := TLabels;
           REF := ProcedureBlockIndex;
           LEV := LEVEL;
           ADR := 0;
           Size := 0;
           NORMAL := TRUE;
         end;
       end;
     end;
     TESTSEMICOLON;
   end;

   procedure VARDECLARTION(E2variable: boolean);
   var T0, T1, TX, RF, SZ, SZ2, v : word;
       TP : TYPES;
       IP : boolean;
       PT : word;
   begin
     GetNextSymbol;
     while LastSymbol = IDENT do
     begin
       T0 := IdTableIndex;
       ENTERVARIABLE;
       while LastSymbol = COMMA do
       begin
        if level=1 then begin IntFileAdd(','); IntFileAdd(''); end;
          GetNextSymbol;
         ENTERVARIABLE;
       end;
       if LastSymbol = COLON then
       begin
         GetNextSymbol;
         if level=1 then IntFileAdd(':');
       end else CError(5);
       T1 := IdTableIndex;
       TX := T0;
       GetTypeInfo( [SEMICOLON,COMMA,ABSOLUTESY,IDENT]+FSYS, TP, RF, SZ, SZ2, PT, IP, false );
       if level=1 then begin IntFileAdd(';External;'); IntFileAdd(''); end;
       while TX < T1 do begin
         TX := TX+1;
         with IdentifierTable[TX] do begin
           TYP := TP;
           REF := RF;
           LEV := LEVEL;
           ADR := DataAllocationIndex;
           Size := SZ;
           SizeIfPointer := SZ2;
           Ptr := PT;
           Normal :=true;
           IsPointer :=IP;
           DataAllocationIndex := DataAllocationIndex + SZ;
           FrameSize:=FrameSize+Size;
           StackOffset:=FrameSize;
           LocalVarSize:=LocalVarSize+Size;
           E2Var:=E2Variable;
           TShareSize:=TShareSize+size;
           if SharedWith>0 then
           begin
             if IdentifierTable[SharedWith].typ=TShare then
               if IdentifierTable[SharedWith].size<TShareSize then
                 IdentifierTable[SharedWith].size:=TShareSize;
           end;
           if UnitSystem and InterfaceSection and (level=1) and
             not InsideUsesClause then Global:=true;
           if CoffEnabled then
           begin
             if TYP in [BYTES, SINTS, WORDS, INTS, TRIPPLETS, LINTS, BOOLS, CHARS] then
             begin
               if not IsDynamic and not E2Var then ASMVardef(TX);
             end;
           end;
{           if isDynamic then
             AsmOutput.Add(LevelID(TX)+#9+'DVAR '+IntToStr(StackOffset)+','+IntToStr(Level));
}         end;
       end;
       if VarFinish(v) then {global or Ext or ABS keyword found}
       begin
         TX := T0;
         while TX < T1 do
         begin
           TX := TX+1;
           case v of
           1,$14,$18:
           begin
             IdentifierTable[TX].Global:=true;
             if v>=$10 then
             begin
               IdentifierTable[TX].IsAbsolute:=(v and $F) div 4;
               IdentifierTable[TX].Address:=AbsoluteValue;
             end;
           end;
           2: IdentifierTable[TX].Extern:=true;
           4,8:
           begin
             if v=8 then
             begin
               if IdentifierTable[AbsoluteValue].IsDynamic then
               begin
                 IdentifierTable[TX].IsDynamic:=true;
                 IdentifierTable[TX].StackOffset:=IdentifierTable[AbsoluteValue].StackOffset;
                 IdentifierTable[TX].Lev:=IdentifierTable[AbsoluteValue].Lev;
                 if DynamicVars then
                   FrameSize:=FrameSize-IdentifierTable[TX].Size;
               end else
               begin
                 IdentifierTable[TX].IsDynamic:=false;
                 if DynamicVars then
                   FrameSize:=FrameSize-IdentifierTable[TX].Size;
               end;
             end else
             if v=4 then
             begin
               IdentifierTable[TX].IsDynamic:=false;
               if DynamicVars then
                 FrameSize:=FrameSize-IdentifierTable[TX].Size;
             end;
             IdentifierTable[TX].IsAbsolute:=v div 4; //1 or 2
             IdentifierTable[TX].Address:=AbsoluteValue;
           end;
           end;
         end;
       end;
     end;
   end; { VARDECLARTION }

   procedure PROCDECLARATION;
   var
     ISFUN,IsStubProcedure,ProcShare: BOOLEAN;
     FuncID,FLE,PreviousProcedureIndex,DSize: word;
   begin
     ISFUN := ( LastSymbol = FUNCSY );
     ParserOptimizer:=false;
     NumberOfWiths:=0;
     GetNextSymbol;
     if LastSymbol=ShareSY then
     begin
       if DynamicVars then CError(122);
       if level<>1 then CError(120);
       if SharedData then CError(121);
       GetNextSymbol;
       if LastSymbol<>IDENT then CError(2);
       i:=GetIdentifierLocation(Identifier,true,true);
       if IdentifierTable[i].Obj=TVariable then
       begin
         if IdentifierTable[i].Typ<>TSHARE then CError(126);
       end else CError(126);
       GetNextSymbol;
       SharedData:=true;
       ProcShare:=true;
       ShareDataWith:=i;
       NextVarResetsShare:=true;
     end else ProcShare:=false;
     PreviousProcedureIndex:=CurrentProcedureIndex;
     if LastSymbol <> IDENT then CError(2);
     if IsForward(Identifier,FuncID) then
     begin
       GetNextSymbol;
       CurrentProcedureIndex:=FuncID;
       ParserOptimizer:=true;
       block( [SEMICOLON]+FSYS, ISFUN, LEVEL+1, IsStubProcedure, IdentifierTable[FuncID].value, DSize );
       if ProcShare then
       begin
         ShareDataWith:=0;
         SharedData:=false;
       end;
     end else
     begin
       if level=1 then
         if ISFUN then IntFileAdd('Function '+Identifier) else IntFileAdd('Procedure '+Identifier);
       MakeNewLabel(FLE);
       if ISFUN then
       begin
         //MakeNewLabel(FLE);
         EnterNewIdentifier( Identifier, TFunc )
       end else EnterNewIdentifier( Identifier, TProcs );
       IdentifierTable[IdTableIndex].NORMAL := TRUE;
       IdentifierTable[IdTableIndex].Value := FLE; {use for storing exit label}
       funcID:=IdTableIndex;
       CurrentProcedureIndex:=IDTableIndex;
       GetNextSymbol;
       ParserOptimizer:=true;
       block( [SEMICOLON]+FSYS, ISFUN, LEVEL+1, IsStubProcedure, FLE, DSize );
       if ProcShare then
       begin
         ShareDataWith:=0;
         SharedData:=false;
       end;  
     end;
     CurrentProcedureIndex:=PreviousProcedureIndex;
     if not IsStubProcedure then
     begin
       if IsFUN or DynamicVars then
       begin
         if DynamicVars then Asm501(DSize,funcID);
         AO('@@'+IntToStr(IdentifierTable[funcID].value)+':');
         if IsFun then
         begin
           if DynamicVars then
           begin
             //AT0('ijmp');
           end else
           begin
             //AT0('pop R31');
             //AT0('pop R30');
             ASM1F(funcID);
             AsmRet;
             //AT0('ijmp');
           end;
         end else
         begin
           if DynamicVars then {AT0('ijmp')} else AsmRet;
         end;
       end else
       begin
         if (pos('reti',AsmOutput[AsmOutput.count-1])=0) and
        (pos('reti',AsmOutput[AsmOutput.count-2])=0) and
        (pos('reti',AsmOutput[AsmOutput.count-3])=0) then ASMRet;
       end;
     end;
     if not IsStubProcedure then
       if LastSymbol = SEMICOLON then GetNextSymbol else CError(14 );
   end; { procedure DECLARATION }

   procedure IncDec(CVT: Types; LVI:word; X:ITEM; FDir: byte; IsAddress,FromFor: boolean);

   begin
     if not IsAddress then //if array or record address on stack
     begin
       if FromFor then
       begin
         if ((IdentifierTable[LVI].NORMAL) and not (IdentifierTable[LVI].IsPointer)) then
           Asm0(LVI) else Asm1(IdentifierTable[LVI].Typ,LVI);
       end;
       AsmGetBaseaddressZ; //needs Itemlocation to be setup beforehand
       AsmIncDec(X,FDir,LVI);
       exit;
     end else
     begin
       Asm34x(X);
       AsmIncDec(X,FDir,LVI);
       exit;
     end;
{     d38:=false;
     case CVT of
       bytes: if FDir=0 then d38:=Asm52B(true) else d38:=Asm53B(true);
       INTS,WORDS : if FDir=0 then Asm52 else Asm53;
       LINTS: if FDir=0 then Asm52L else Asm53L;
     end;
     if not d38 then Asm38(CVT,CVT,LVI); }
   end;

(*---------------------------------------------------------STATEMENT--*)
{==============================================================================}

procedure Statement(FSYS: SYMSET; BreakLabel,ContinueLabel: word );

   var  I : word;
        X : ITEM;
        TIS: Boolean;
        XEXP,YEXP: types;

   label 1;

      procedure Expression( FSYS : SYMSET; var X: ITEM ); forward;

      procedure CallProcedure( FSYS: SYMSET; I: INTEGER ); forward;

{====================}

      procedure Selector(FSYS: SYMSET; var V: ITEM; var ID: word; Left: boolean);

         var  X: ITEM;
              A,J: INTEGER;

         begin  (* LastSymbol IN [LPARENT, LBRACK, PERIOD] *)
         repeat
            if LastSymbol = PERIOD then
               begin
               GetNextSymbol;        (* field selector *)
               if LastSymbol <> IDENT then
                  CError(2)
               else
                  begin
                  if V.TYP <> RECORDS then
                     CError(31)
                  else
                     begin (* search field identifier *)
                     J := BlockTable[V.REF].LAST;
                     while (J <> 0) and (IDName(J) <> Identifier) do
                        J := IdentifierTable[J].Link;
                     if J = 0 then
                        CError(0);
                     V.TYP := IdentifierTable[J].TYP;
                     V.REF := IdentifierTable[J].REF;
                     V.PTR := (not IdentifierTable[J].Normal) or IdentifierTable[J].IsPointer;
                     A := IdentifierTable[J].ADR;
                     ID := J;
                     Asm9(A);
                     end;

                  GetNextSymbol;
                  if V.PTR and (LastSymbol=CARET) then
                     begin
                     GetNextSymbol;
                     ASMDeref;
                     end;
                  end;
               end
            else
               begin  (* array selector *)
               if LastSymbol <> LBRACK then
                  CError(11);

               repeat
                  GetNextSymbol;
                  Expression(FSYS+[COMMA, RBRACK], X);
                  if V.TYP = ARRAYS then
                     begin
                     A := V.REF;
                     if X.TYP > Lints then
                        CError(26)
                     else
                        Asm21(A, X.TYP);
                     V.TYP := ArrayTable[A].ELTYP;
                     V.REF := ArrayTable[A].ELREF;
                     V.Ptr := ArrayTable[A].IsArrayOfPointers;
                     ID := ArrayTable[A].IDREF;
                     end
                  else
                     CError(108);
                  until LastSymbol <> COMMA;

               if LastSymbol = RBRACK then
                  GetNextSymbol
               else
                  CError(12);
               if V.PTR and (LastSymbol=CARET) then
                  begin
                  GetNextSymbol;
                  AsmDeref;
                  end;
               end;
            until not ( LastSymbol IN [ LBRACK, LPARENT, PERIOD ] );
       {TEST( FSYS, [], 6 );}
         end; { SELECTOR }

     procedure IdentAddress(Full,RecordAll,ProcAllowed,E2Allowed: boolean; var X: Item; var ID: word);
     var
       I: word;
       HasCARET: boolean;
     begin
       HasCaret:=false;
       if LastSymbol<>IDENT then CError(0) else
       begin
         I := GetIdentifierLocation(Identifier,true,not E2Allowed);
         IdentLocation:=IdentifierTable[I].TypedConstant;
         ID:=IdentifierTable[I].ptr; //pointer to type
         GetNextSymbol;
         if I <> 0 then
           if IdentifierTable[I].OBJ <> TVARIABLE then
           if ProcAllowed then
           begin
             if not (IdentifierTable[I].OBJ in [TPROCS,TFUNC]) then CError(37);
           end else CError(37);
         begin
           X.TYP:=IdentifierTable[I].TYP;
           X.REF:=IdentifierTable[I].REF;
           if LastSymbol=CARET then
           begin
             GetNextSymbol;
             HasCaret:=true;
           end;
           if ProcAllowed and
             (IdentifierTable[I].OBJ in [TPROCS,TFUNC]) then
             begin
               Asm0Proc(I);
               IdentLocation:=true; //allways in code
               exit;
             end;
           StartRecording;
           if ((IdentifierTable[I].NORMAL) and not (HasCaret)) and not (IdentifierTable[I].IsPointer) then
             Asm0(I) else
             if IdentifierTable[I].IsPointer and not HasCaret then
             begin
               Asm0(I);
               X.Typ:=words;
             end else
             begin
               Asm1(IdentifierTable[I].Typ,I);
               if IdentifierTable[I].IsPointer then
                 if PointerBend=CodeMem then IdentLocation:=true else IdentLocation:=false;
             end;
           if Full then
             if LastSymbol in [LBRACK,LPARENT,PERIOD] then
             begin
               if IdentifierTable[I].IsPointer and not HasCaret then CError(70);
               SELECTOR(FSYS+[RPARENT],X,ID,false);
               if recordAll then
               begin
                 if RecordingStartSize=CodeSize then
                   AsmGetBaseAddress;
               end;
               if not RecordAll then StopRecording(false);
             end;
           if RecordAll then StopRecording(true);
         end;
       end;
     end;

     procedure CallProcedure( FSYS: SYMSET; I: INTEGER );
     var
       X,Y: Item;
       LASTP,CP,STPAtStart: Integer;
       DereferenceProcArg,Tis: boolean;
       D,K: word;

     label 1,2;

        procedure DereferenceTarget;
        begin
          NextPointerIsCode:=false;
          if LastSymbol=CARET then
          begin
            DereferenceProcArg:=true;
            GetNextSymbol;
            if PointerBend=CodeMem then NextPointerIsCode:=true;
          end else
          begin
            Y.TYP := WORDS;
            Y.PTR := false;
          end;
        end;

     begin
       STPAtStart:=STP;
       if InitialStack<InitialStack+IdentifierTable[I].StackUse+2 then
       begin
         IdentifierTable[ProcedureIDTableIndex].StackUse:=
           InitialStack+IdentifierTable[I].StackUse+2;
       end;
       CallParameters:=true;
       LASTP := BlockTable[IdentifierTable[I].PROCREF].LASTPAR;
       CP := I;
       if IdentifierTable[I].obj=TFunc then
       begin
         if IdentifierTable[I].IsDynamic then
           Asm502(IdentifierTable[I].size,'function return value');
       end;
       if LastSymbol = LPARENT then (* actual parameter list *)
       begin
       repeat
         GetNextSymbol;
         if CP >= LASTP then CError(39) else
         begin
           CP := CP+1;
           Y.TYP := IdentifierTable[CP].TYP;
           Y.REF := IdentifierTable[CP].REF;
           Y.PTR := IdentifierTable[CP].IsPointer;
           DereferenceProcArg:=false;
           If Y.PTR then DereferenceTarget;
           if IdentifierTable[CP].NORMAL then
           begin  (*  value parameter *)
             if Dynamicvars then
             if Y.TYP=arrays then
               if (ArrayTable[Y.REF].ElTyp=Chars) then
               begin
                 Asm502(IdentifierTable[CP].size,';string argument');
               end;
             EXPRESSION( FSYS+[COMMA,COLON,RPARENT], X );
             if (X.PTR and (not DereferenceRight)) and not Y.PTR then CError(73);
             if ((X.TYP<=LInts) and (Y.TYP<=LInts)) or
               (X.TYP=Y.TYP) or ((X.TYP=CHARS) and (Y.TYP=bytes)) or ((X.TYP=BYTES) and (Y.TYP=CHARS)) then
             begin
               if (X.TYP=ARRAYS) then
                 if (ArrayTable[X.REF].ElTyp=Chars) and
                   (ArrayTable[IdentifierTable[CP].Ref].ElTyp=Chars) then goto 2;
               if (X.TYP=CHARS) and (Y.TYP=CHARS) then goto 2;
               if (X.TYP=CHARS) and (Y.TYP=bytes) then goto 2;
               if (X.TYP=bytes) and (Y.TYP=CHARS) then goto 2;
               if (X.TYP>LINTS) and (Y.TYP>LINTS) then
                 if X.REF <> IdentifierTable[CP].REF then CError(36); {actual vs formal error}
2:
               if IdentifierTable[CP].IsDynamic then
                 ASM38D(Y.TYP,X.TYP,CP,FrameSize) else ASM38(Y.TYP,X.TYP,CP);
             end else
             begin
               if (Y.TYP=ARRAYS) and (ArrayTable[Y.REF].ElTyp=CHARS)
                 and (X.TYP=CHARS) then
               begin
                 ASM105; {convert char to string}
                 if IdentifierTable[CP].IsDynamic then
                   ASM38D(Y.TYP,Y.TYP,CP,FrameSize) else ASM38(Y.TYP,Y.TYP,CP);
               end else
               begin
                 if (X.TYP=CSTRINGS) and (Y.TYP=ARRAYS) then
                 begin
                   if (ArrayTable[Y.REF].ElTyp=CHARS) then
                   begin
                     if IdentifierTable[CP].IsDynamic then
                       ASM38D(Y.TYP,Y.TYP,CP,FrameSize) else ASM38(Y.TYP,Y.TYP,CP);
                   end else CError(36);
                 end else CError(36);
               end;
             end;
           end else
           begin  (* variable parameter or pointer - with or without var*)
             if LastSymbol <> IDENT then CError(2) else
             begin
               Tis:=false;
               if not IsWith(K) then K := GetIdentifierLocation(Identifier,true,true) else Tis:=true;
               GetNextSymbol;
               if K <> 0 then
               begin
                 if IdentifierTable[K].OBJ <> TVARIABLE then CError(37);
                 X.TYP := IdentifierTable[K].TYP;
                 X.REF := IdentifierTable[K].REF;
                 StartRecording;
                 if not Tis then
                   if IdentifierTable[K].NORMAL then Asm0(K) else
                     Asm1(IdentifierTable[K].Typ,K);
                 if LastSymbol IN [ LBRACK, LPARENT, PERIOD ] then
                 begin
                   SELECTOR(FSYS+[COMMA,COLON,RPARENT], X, D,true);
                   StopRecording(false);
                 end;
                 if IdentifierTable[CP].IsDynamic then
                   ASM38D(Words,Words,CP,FrameSize) else ASM38SP(CP);
                 if (X.TYP=ARRAYS) and (IdentifierTable[CP].TYP=ARRAYS) then
                 if (ArrayTable[X.Ref].ElTyp=Chars) and
                    (ArrayTable[IdentifierTable[CP].Ref].ElTyp=Chars) then goto 1;
                 if ( X.TYP<>IdentifierTable[CP].TYP ) OR ( X.REF<>IdentifierTable[CP].REF )
                   then CError(36);
1:
               end;
             end;
           end;
         end;
         TEST( [COMMA,RPARENT], FSYS, 6 );
       until LastSymbol <> COMMA;
       if LastSymbol = RPARENT then GetNextSymbol else CError(4);
       end;
       if CP < LASTP then CError(39); (* too few actual parameters *)
       with IdentifierTable[I] do
       begin
         Asm303(HashIfGlobal(I)+'@'+LevelID(I));
         AT0('.call @'+LevelID(I));
         if IdentifierTable[I].obj=TFunc then
         begin
           STP:=STPAtStart;
           PushItem(0,0,IDTypesToSTTypes(IdentifierTable[I].Typ),STOnStack,false);
           if not IdentifierTable[I].IsDynamic then Asm1Fx(I) else
           begin
             if IdentifierTable[I].Typ=Arrays then
             if ArrayTable[IdentifierTable[I].Ref].ElTyp=CHARS then
             begin
               Asm1Fy;
             end;
           end;
         end;
       end;
       CallParameters:=false;
     end; { CallProcedure }

     function RESULTTYPE( A,B : TYPES ): TYPES;
     begin
     result := NOTYP;
       if A=SINGLES then if B<>SINGLES then CError(114);
       if B=SINGLES then if A<>SINGLES then CError(114);
       if ( A > SINGLES ) OR ( B > SINGLES ) then
       begin
         if A=CStrings then A:=Arrays;
         if B=CStrings then A:=Arrays;
         if (A=Arrays) or (B=Arrays) then
         begin
           ResultType:=Arrays;
         end else
         if (A=CHARS) and (B=CHARS) then
           ResultType:=ARRAYS else
           begin
             CError(33);
           end;
       end else
       begin
         if A>=B then ResultType:=A else
           if B>=A then ResultType:=B;
       end;
     end; { RESULTTYPE }

(*---------------------------------------------------EXPRESSION-----*)
{==============================================================================}

procedure Expression (* FSYS: SYMSET; var X: ITEM *) ;
      (*
         Note: dynamic variables for Y have been used due to the
               constraints imposed upon local variables in recursion.
      *)

   type ITEMptr = ^ITEM;   (* static > dynamic : SCHOENING *)

   var Y: ITEMptr;
       OP : SYMBOL;

{====================}

      procedure SimpleExpression(FSYS: SYMSET; var X: ITEM );

         var Y  : ITEMptr;
             OP : SYMBOL;
             Temp,LTYP: Types;

{==========}

         procedure Term(FSYS: SYMSET; var X: ITEM );

            var Y  : ITEMptr;
                OP : SYMBOL;

{==========}

            procedure Factor(FSYS: SYMSET; var X: ITEM);

               var  F: integer;
                    SourceIsOnStack,
                    NoDeref,Negation: boolean;
                    D,I: word;

               label 1;

{==========}

               procedure StandardFunctions(N: integer);

                  var  TS: TypeSet;
                       XI,ID,V: word;
                       DereferenceID: boolean;
                       AP: LongInt;
                       S: string;                                                       //ss short

                  label SkipTypeCheck;

{==========}

                     procedure DereferenceIdentifier;

                        begin
                        NextPointerIsCode := false;
                        if LastSymbol = CARET then
                           begin
                           DereferenceID := true;
                           GetNextSymbol;
                           if PointerBend=CodeMem then
                              NextPointerIsCode := true;
                           end
                        else
                           begin
                           X.TYP := WORDS;
                           X.PTR := false;
                           end;
                        end;

                  begin (*STANDARD FUNCTION NO. N*)
                  if N <> 24 then{@ operator}
                     if LastSymbol = LPARENT then
                        GetNextSymbol
                     else
                        CError(9);
                  if (N < 17) or (N = 19) then
                     begin
                     Expression(FSYS+[RPARENT], X);
                     case N of
{ABS}                   0: if X.TYP = SINGLES then
                               TS:=[SINGLES]
                            else
                               TS := [BYTES,SINTS,INTS,WORDS,TRIPPLETS,LINTS];
{SQR}
                        2: begin
                            CError(81);
                            {TS := [INTS,Singles];
                            IdentifierTable[I].TYP := X.TYP;
                            if X.TYP = Singles then N := N+1}
                            end;

{ ODD, CHR    }         4,5: TS := [CHARS,SINTS,TRIPPLETS,LINTS,INTS,WORDS,BYTES];

{ ORD         }         6: TS := [BOOLS,CHARS,BYTES,SINTS,INTS,WORDS,TRIPPLETS,LINTS];

{ SUCC,  PRED }         7,8: begin
                             TS := [LINTS,SINTS,TRIPPLETS,WORDS,INTS,BOOLS,CHARS,BYTES];
                             IdentifierTable[I].TYP := X.TYP
                             end;

{ ROUND,TRUNC }         9,10,11,12,13,14,15,16:
{ SIN,COS,... }            begin
                           CError(81);
                           {TS := [INTS,Singles];
                           if X.TYP = INTS then EMIT1(26,0)}
                           end;

{ RANDOM      }         19: begin
                            CError(81);
                           {TS := [INTS];
                            IdentifierTable[I].TYP := X.TYP;}
                            end;
                        end; (* case *)

                     if X.TYP in TS then
                        begin
                        Asm8(X.TYP, N);
                        if N = 6 then
                           if X.TYP = CHARS then
                              X.TYP := BYTES;
                        if N in [0,6,7,8] then
                           goto SkipTypeCheck; {type returned=type entered}
                        end
                     else if X.TYP <> NOTYP then
                        CError(48);
                     end
                  else
                     case N of
                        20: {SizeOf}
                           begin
                           if LastSymbol = IDENT then
                              begin
                              XI := GetIdentifierLocation(Identifier,true,true);
                              if IdentifierTable[xi].OBJ = TVariable then
                                 Asm150(IdentifierTable[xi].size)
                              else
                                 CError(37);
                              GetNextSymbol;
                              end
                           else
                              CError(2);
                           end;

                        21: {INP}
                           begin
                           if LastSymbol = IDENT then
                              begin
                              XI := GetIdentifierLocation(Identifier,true,true);
                              with IdentifierTable[XI] do
                                 begin
                                 if OBJ = TVariable then
                                    begin
                                    if ConstantAddress(I,V) then
                                       Asm170(V)
                                    else
                                       CError(95);
                                    end;
                                 end;
                              end
                           else
                              begin
                              if LastSymbol = BYTECON then
                                 begin
                                 Asm170(IntegerNumeric);
                                 end
                              else
                                 CError(100);
                              end;
                           GetNextSymbol;
                           end;

                        22: {E2Read}
                           begin
                           if LastSymbol = IDENT then
                              begin
                              S := Identifier;
                              IdentAddress(true,false,false,true,X,ID);
                              Identifier := S;
                              I := GetIdentifierLocation(Identifier,true,false);
                              if not IdentifierTable[I].E2Var then
                                 CError(99);
                              if not (IdentifierTable[I].typ in [CHARS, BYTES, WORDS, INTS, LINTS, ARRAYS]) then
                                 CError(98);
                              if IdentifierTable[I].typ = ARRAYS then
                                 begin
                                 if (ArrayTable[IdentifierTable[I].Ref].ElTyp<>Chars) then
                                    Cerror(98);
                                 Asm165a;
                                 end
                              else
                                 Asm165(IdentifierTable[I].Size,IdentifierTable[I].Typ);
                              goto SkipTypeCheck;
                              end
                           else
                              CError(2);
                           end;

                        23,24: {addr}
                           begin
                           if LastSymbol = IDENT then
                              IdentAddress(true, false, true, true, X, ID)
                           else
                              CError(2);
                           Asm100;
                           end;

                        25: {length(string)}
                           begin
                           if LastSymbol = IDENT then
                              IdentAddress(true, false, false, false, X, ID)
                           else
                              CError(2);

                           if X.TYP <> ARRAYS then
                              CError(38)
                           else
                              Asm157;
                           X.TYP := BYTES;
                           end;

                        26: {string copy function}
                           begin
                           if LastSymbol = IDENT then
                              IdentAddress(true, false, false, false, X, ID)
                           else
                              CError(2);

                           if LastSymbol <> COMMA then
                              CError(78);
                           GetNextSymbol;
                           Expression(FSYS+[COMMA], X );
                           if X.TYP>=LINTS then
                              CError(44);
                           if LastSymbol <> COMMA then
                              CError(78);
                           GetNextSymbol;
                           Expression(FSYS+[RPARENT], X );
                           if X.TYP >= LINTS then
                              CError(44);
                           Asm158;
                           X.TYP := ARRAYS;
                           X.REF := 1;
                           end;

                        27,28: {intToStr and intToHex}
                           begin
                           Expression(FSYS+[RPARENT,COMMA], X );
                           if X.TYP > LINTS then
                              CError(44);

                           if N = 27 then
                              Asm159(X)
                           else
                              Asm159H(X);

                           if N = 28 then
                              begin
                              if LastSymbol = COMMA then
                                 begin
                                 GetNextSymbol;
                                 AP := AsmOutput.Count;
                                 Expression(FSYS+[RPARENT], X);
                                 if X.TYP > LINTS then
                                    CError(44);
                      //while AsmOutput.Count>ap do
                        //AsmOutput.Delete(AsmOutput.Count-1);
                                 dec(STP);
                                 end;
                              end
                        else if LastSymbol = COMMA then
                           CError(4);
                        end;

                29: {StrToInt}
                begin
                  EXPRESSION( FSYS+[RPARENT], X);
                  if X.TYP=ARRAYS then
                  begin
                    if ArrayTable[X.REF].ElTyp=CHARS then ASM120 else CError(38);
                  end else CError(38);
                end;
                30: {StrToIntDef}
                begin
                  EXPRESSION( FSYS+[COMMA], X);
                  if X.TYP=ARRAYS then
                  begin
                    if ArrayTable[X.REF].ElTyp=CHARS then
                    begin
                      GetNextSymbol;
                      EXPRESSION( FSYS+[RPARENT], X);
                      if X.TYP>LINTS then CError(44);
                      ASM121;
                    end else CError(38);
                  end else CError(38);
                end;
                31: {lo()}
                begin
                  Expression( FSYS+[RPARENT], X);
                  if not (X.TYP in [WORDS,INTS,SINTS,BYTES,CHARS]) then CError(43);
                  ASM122;
                end;
                32: {hi()}
                begin
                  Expression( FSYS+[RPARENT], X);
                  if not (X.TYP in [WORDS,INTS,BYTES,SINTS,CHARS]) then CError(43);
                  ASM123;
                end;
                33: {loWord()}
                begin
                  Expression( FSYS+[RPARENT], X);
                  if X.TYP<>LINTS then CError(104);
                  ASM124;
                end;
                34: {HiWord()}
                begin
                  Expression( FSYS+[RPARENT], X);
                  if X.TYP<>LINTS then CError(104);
                  ASM125;
                end;
                35: {UpCase}
                begin
                  Expression( FSYS+[RPARENT], X);
                  if X.TYP<>CHARS then CError(113);
                  ASM126;
                end;
                36: {POS}
                begin
                  EXPRESSION( FSYS+[COMMA], X );
                  if LastSymbol<>COMMA then CError(78);
                  if not StringType(X) then
                  begin
                    if X.TYP<>Chars then CError(38);
                    ASM105; {convert char on stack to string[1]}
                  end;
                  getNextSymbol;
                  if LastSymbol=IDENT then IdentAddress(true, false, false, false, X, ID) else CError(2);
                  if not StringType(X) then CError(38);
                  ASM106; {push "1" onto stack}
                  ASM107; {POSN function}
                end;
                37: {POSN}
                begin
                  EXPRESSION( FSYS+[COMMA], X );
                  if LastSymbol<>COMMA then CError(78);
                  if not StringType(X) then
                  begin
                    if X.TYP<>Chars then CError(38);
                    ASM105; {convert char on stack to string[1]}
                  end;
                  getNextSymbol;
                  if LastSymbol=IDENT then IdentAddress(true, false, false, false, X, ID) else CError(2);
                  if not StringType(X) then CError(38);
                  getNextSymbol;
                  Expression( FSYS+[RPARENT], X);
                  if not (X.TYP in [BYTES,WORDS,INTS]) then CError(43);
                  ASM107; {POSN function}
                end;
                39,40: {AsInt,AsWord}
                begin
                  EXPRESSION( FSYS+[RPARENT], X );
                  if not (X.TYP in [CHARS,BYTES,SINTS,INTS,WORDS,TRIPPLETS,LINTS]) then CError(83);
                  Asm180;
                end;
                41: {AsByte}
                begin
                  EXPRESSION( FSYS+[RPARENT], X );
                  if not (X.TYP in [CHARS,BYTES,SINTS,INTS,WORDS,TRIPPLETS,LINTS]) then CError(83);
                  Asm181;
                end;
                42: {AsLongInt}
                begin
                  EXPRESSION( FSYS+[RPARENT], X );
                  if not (X.TYP in [CHARS,BYTES,SINTS,INTS,WORDS,TRIPPLETS,LINTS]) then CError(83);
                  Asm182;
                end;
                43: {Swap_Word}
                begin
                  EXPRESSION( FSYS+[RPARENT], X );
                  if not (X.TYP in [CHARS,BYTES,SINTS,INTS,WORDS,TRIPPLETS,LINTS]) then CError(83);
                  Asm183;
                end;
                44: {Swap_Longint}
                begin
                  EXPRESSION( FSYS+[RPARENT], X );
                  if not (X.TYP in [CHARS,BYTES,SINTS,INTS,WORDS,TRIPPLETS,LINTS]) then CError(83);
                  Asm184;
                end;
                45: {Swap}
                begin
                  EXPRESSION( FSYS+[RPARENT], X );
                  if not (X.TYP in [CHARS,BYTES,SINTS,INTS,WORDS,TRIPPLETS,LINTS]) then CError(83);
                  Asm185;
                end;
                46,47: {IOBIT}
                begin
                  if LastSymbol=IDENT then
                  begin
                    xI:=GetIdentifierLocation(Identifier,true,true);
                    with IdentifierTable[xI] do
                    begin
                      if OBJ=TVariable then
                      begin
                        if ConstantAddress(xI,V) then
                          ASM171(V) else CError(95);
                      end;
                    end;
                  end else
                  begin
                    if LastSymbol=BYTECON then
                    begin
                      ASM171(IntegerNumeric);
                    end else CError(100);
                  end;
                  GetNextSymbol;
                  if LastSymbol<>COMMA then CError(78);
                  GetNextSymbol;
                  if LastSymbol=IDENT then
                  begin
                    xI:=GetIdentifierLocation(Identifier,true,true);
                    with IdentifierTable[xI] do
                    begin
                      if OBJ=TConstant then
                      begin
                        if IsAbsolute=1 then
                          ASM171c(value) else CError(95);
                      end;
                    end;
                  end else
                  begin
                    if LastSymbol=BYTECON then
                    begin
                      ASM171c(IntegerNumeric);
                    end else CError(119);
                  end;
                  GetNextSymbol;
                  if n=46 then ASM175 else ASM176;
                end;
                52: {ExtendToInteger}
                begin
                  EXPRESSION( FSYS+[RPARENT], X );
                  if not (X.TYP in [SINTS]) then CError(84);
                  Asm404;
                end;
                53: {ExtendToLongint}
                begin
                  EXPRESSION( FSYS+[RPARENT], X );
                  if not (X.TYP in [SINTS,INTS]) then CError(84);
                  if X.TYP=SINTS then Asm405(1) else Asm405(0);
                end;
                54,55: {BITLOW,BITHI}
                begin
                  if LastSymbol=IDENT then IdentAddress(true, false, false, false, X, ID) else CError(2);
                  if LastSymbol<>COMMA then CError(78);
                  getNextSymbol;
                  EXPRESSION( FSYS+[RParent], X );
                  if n=54 then ASM175R else ASM176R;
                end;
                end;
                X.TYP := IdentifierTable[I].TYP;
                X.REF := IdentifierTable[I].REF;
SkipTypeCheck:
                if N<>24 then{@ operator}
                  if LastSymbol = RPARENT then GetNextSymbol else CError(4)
              end; (* StandardFunctions *)

              procedure DereferenceSource(var X: ITEM);
              begin
                NextPointerIsCode:=false;
                if LastSymbol=CARET then
                begin
                  DereferenceRight:=true;
                  GetNextSymbol;
                  if PointerBend=CodeMem then NextPointerIsCode:=true;
                end else
                begin
                  X.TYP := WORDS;
                  X.PTR := false;
                end;
              end;

              procedure SourceTypeCast;
              begin
                if LastSymbol<>LParent then CError(9);
                TCast.TYP := IdentifierTable[I].TYP;
                TCast.REF := IdentifierTable[I].REF;
                TCast.PTR := IdentifierTable[I].IsPointer;
                TCastTypeSize:=IdentifierTable[I].Size;
                GetNextSymbol;
              end;

            var
              OX: ITEM;
                
            begin (* FACTOR *)
              X.TYP := NOTYP;
              X.REF := 0;
              TEST(FACBEGSYS, FSYS, 58);
              while LastSymbol in FACBEGSYS do
              begin {   Identifier   }
                Negation:=false;
                if LastSymbol in [PLUS,MINUS] then
                begin
                  if LastSymbol=MINUS then Negation:=true;
                  GetNextSymbol;
                end;
                if LastSymbol = IDENT then
                begin
1:
                  SourceIsOnStack:=false;
                  if IsWith(I) then SourceIsOnStack:=true else
                    I:=GetIdentifierLocation(Identifier,true,true);
                  GetNextSymbol;
                  with IdentifierTable[I] do
                  case OBJ of
                  TCONSTANT: begin
                               if TCast.TYP<>NOTYP then CError(107);
                               X.TYP := TYP;
                               X.REF := 0;
                               if TYP=CSTRINGS then
                                 StringContent:=StringConstants[value];
                               Asm24(value,X.TYP);
                             end;
                  TVARIABLE: begin
                               X.TYP := TYP;
                               X.REF := REF;
                               X.PTR := IsPointer;
                               DereferenceRight:=false;
                               D:=I;
                               If X.PTR then DereferenceSource(X);
                               if LastSymbol in [LBRACK,LPARENT,PERIOD] then
                               begin
                                 NoDeref:=false;
                                 if NORMAL then F := 0 else F := 1;
                                 if IsPointer and DereferenceRight then F:=1;
                                 StartRecording;
                                 if not SourceIsOnStack then
                                   if f=0 then ASM0(I) else ASM1(typ,I);
                                 if IsPointer and not X.PTR then CError(70);
                                 OX:=X;
                                 SELECTOR(FSYS,X,D,false);
                                 {if not NoDeref then
                                 begin
                                   DereferenceRight:=false;
                                   If X.PTR then DereferenceSource(X);
                                   if DereferenceRight then ASMDeref;
                                 end;}
                                 DereferenceRight:=false;
                                 StopRecording(false);
                                 if TCast.Typ<>NOTYP then
                                 begin
                                   X:=TCast;
                                   if not AllowAnyCast then
                                     if TCastTypeSize<>IdentifierTable[D].Size then CError(106);
                                   if LastSymbol<>RParent then CError(4);
                                   GetNextSymbol;
                                   TCast.Typ:=NOTYP;
                                 end;
                                 Asm34(X,OX);
                               end else
                               begin
                                 if TCast.Typ<>NOTYP then
                                 begin
                                   X:=TCast;
                                   if not AllowAnyCast then
                                     if TCastTypeSize<>IdentifierTable[D].Size then CError(106);
                                   if LastSymbol<>RParent then CError(4);
                                   GetNextSymbol;
                                   TCast.Typ:=NOTYP;
                                 end;
                                 if SourceIsOnStack then
                                 begin
                                   if DereferenceRight then ASMDeref;
                                   Asm34(X,X);
                                 end else
                                 begin
                                   if DereferenceRight then F:=2 else
                                     if NORMAL then F := 1 else F := 2;
                                   if f=1 then ASM1(typ,I) else ASM2(X.Typ,I);
                                 end;
                               end;
                             end;
                  TType: begin
                           //GetNextSymbol;
                           SourceTypeCast;
                           goto 1;
                         end;
                  TProcs: CError(44);
                  TFunc : begin
                            if TCast.TYP<>NOTYP then CError(107);
                            X.TYP := TYP;
                            X.REF := REF;
                            X.PTR := IsPointer;
                            if TYP=CSTRINGS then
                            if IdentifierTable[CurrentAssignmentTarget].IsPointer and not DereferenceLeft then
                            begin
                              if not((X.TYP=CSTRINGS) and X.PTR and (LastSymbol<>CARET)) then CError(59);
                            end;
                            DereferenceRight:=false;
                            If X.PTR then DereferenceSource(X);
                            if LEV <> 0 then CallProcedure(FSYS, I) else StandardFunctions(ADR);
                            if DereferenceRight then
                              if X.TYP=ARRAYS then
                                if ArrayTable[X.REF].ElTyp=CHARS then ASM108;
                            ADRCacheValid:=false;
                            FirstADRCache:=true;
                          end;
                  end; (*CASE,WITH*)
                  if negation then ASM60(X.TYP);
                end else
                if LastSymbol in [CHARCON,BYTECON,WORDCON,INTCON,LINTCON,SINGLECON,STRINGCON] then
                begin
                  case LastSymbol of
                  CHARCON: X.TYP := CHARS;
                  BYTECON: X.TYP := BYTES;
                  INTCON:  X.TYP := INTS;
                  WORDCON: X.TYP := WORDS;
                  LINTCON: X.TYP := LINTS;
                  SINGLECON: X.TYP := SINGLES;
                  STRINGCON: X.TYP := CSTRINGS;
                  end;
                  Asm24(IntegerNumeric,X.TYP);
                  if X.TYP=CSTRINGS then
                  begin
                    X.TYP:=ARRAYS; X.REF:=1;
                  end else X.REF := 0;
                  GetNextSymbol;
                  if negation then ASM60(X.TYP);
                end else
{   (   }       if LastSymbol = LPARENT then
                begin
                  GetNextSymbol;
                  EXPRESSION(FSYS+[RPARENT], X);
                  if LastSymbol = RPARENT then GetNextSymbol else CError(4);
                  if negation then ASM60(X.TYP);
                end else
{  NOT  }       if LastSymbol = NOTSY then
                begin
                  GetNextSymbol;
                  FACTOR(FSYS,X);
                  case X.TYP of
                  BOOLS: ASM35;
                  SINTS: ASM35C;
                  INTS,WORDS: ASM35A;
                  LINTS: ASM35B;
                  else CError(33) end;
                  if negation then ASM60(X.TYP);
                end else CError(20);
                TEST(FSYS, FACBEGSYS, 6);
                if LastSymbol in [Plus,Minus] then exit;
              end (*while*)
            end; (*FACTOR*)

          begin (*TERM*)
            new( Y );
            FACTOR(FSYS+[TIMES,RDIV,IDIV,IMOD,ANDSY,SHLSY,SHRSY,RRSY,RLSY,PLUS,MINUS], X);
            while LastSymbol in [TIMES,RDIV,IDIV,IMOD,ANDSY,SHLSY,SHRSY,RRSY,RLSY] do
            begin
                OP := LastSymbol;
                GetNextSymbol;
                FACTOR(FSYS+[TIMES,RDIV,IDIV,IMOD,ANDSY,SHRSY,SHLSY,RRSY,RLSY,PLUS,MINUS], Y^ );
{  *  }         if OP = TIMES then begin
                  X.TYP := RESULTTYPE(X.TYP, Y^.TYP);
                  case X.TYP of
                    NOTYP: ;
                    WORDS : Asm57(0,X.TYP,Y^.TYP); {unsigned multiply}
                    INTS,SINTS : Asm57(1,X.TYP,Y^.TYP); {signed multiply}
                    BYTES : begin
                              Asm57b;
                              if HasMult then X.TYP:=Words;
                            end;  
                    LINTS,TRIPPLETS : Asm57L(X.TYP,Y^.TYP);
                    Singles: Asm57Single;
                  end
                end else
{  /  }         if OP = RDIV then
                begin
                  X.TYP := RESULTTYPE(X.TYP, Y^.TYP);
                  if X.TYP=SINGLES then Asm58Single;
                end else
{ AND }         if OP = ANDSY then
                begin
                  X.TYP := RESULTTYPE(X.TYP, Y^.TYP);
                  case X.TYP of
                    INTS,WORDS : Asm56(OP);
                    BYTES,BOOLS,SINTS : Asm56b(OP);
                    LINTS,TRIPPLETS : Asm56L(OP);
                    Singles: CError(80);
                  end;
                end else
{ DIV,MOD }     if (OP = IDIV) or (OP = RDIV) then
                begin
                  LTYP:=X.TYP;
                  X.TYP := RESULTTYPE(X.TYP, Y^.TYP);
                  case X.TYP of
                    WORDS : Asm58(0,X.TYP,Y^.TYP);
                    INTS,SINTS : Asm58(1,LTYP,Y^.TYP);
                    BYTES : Asm58b;
                    LINTS,TRIPPLETS : Asm58L(LTYP,Y^.TYP);
                    Singles: CError(80);
                  end;
                end else
                if OP = IMOD then
                begin
                  LTYP:=X.TYP;
                  X.TYP := RESULTTYPE(X.TYP, Y^.TYP);
                  case X.TYP of
                    //INTS,SINTS: Asm59S(X.TYP,Y^.TYP);
                    WORDS,INTS,SINTS : Asm59;
                    BYTES : Asm59;
                    LINTS,TRIPPLETS : Asm59L(LTYP,Y^.TYP);
                    Singles: CError(80);
                  end;
                end else
                if (OP=SHLSY) or (OP=SHRSY) or (OP=RRSY) or (OP=RLSY) then
                begin
                  X.TYP := RESULTTYPE(X.TYP, Y^.TYP);
                  case X.TYP of
                    INTS,WORDS : Asm56(OP);
                    BYTES,BOOLS,SINTS : Asm56b(OP);
                    LINTS,TRIPPLETS : Asm56L(OP);
                    Singles: CError(80);
                  end;
                end;
              end;
            dispose( Y );
          end (*TERM*) ;

        begin (*SIMPLEEXPRESSION*)
          new( Y );
          TERM( FSYS+[ PLUS,MINUS,ORSY,XORSY], X );
          while LastSymbol in [PLUS,MINUS,ORSY,XORSY] do
          begin
            OP := LastSymbol;
            GetNextSymbol;
            TERM(FSYS+[PLUS,MINUS,ORSY,XORSY], Y^);
{OR,XOR}
            if OP in [ORSY,XORSY] then
            begin
              X.TYP := RESULTTYPE(X.TYP, Y^.TYP);
              case X.TYP of
                INTS,WORDS : Asm56(OP);
                BYTES,BOOLS,SINTS : Asm56b(OP);
                LINTS,TRIPPLETS : Asm56L(OP);
                Singles: CError(80);
              end;
            end else
            begin
              Temp:=X.TYP;
              X.TYP := RESULTTYPE(X.TYP, Y^.TYP);
              if X.TYP=CSTRINGS then X.TYP:=ARRAYS;
              if Y^.TYP=CSTRINGS then Y^.TYP:=ARRAYS;
              case X.TYP of
                NOTYP: ;
                bytes,SINTS: if OP = PLUS then Asm52B(false) else Asm53B(false);
                INTS,WORDS : if OP = PLUS then Asm52 else Asm53;
                LINTS,TRIPPLETS: if OP = PLUS then Asm52L else Asm53L;
                SINGLES: if OP = PLUS then Asm52Single else Asm53Single;
                ARRAYS: if OP = PLUS then
                begin
                  {note: order of the following statement is critical}
                  if (Temp=Chars) and (Y^.Typ=Arrays) then Asm52Sca else
                  if (Temp=Chars) and (Y^.Typ=CHARS) then Asm52CC else
                  if (Y^.Typ=ARRAYS) then Asm52S else
                  if (Y^.Typ=CHARS) or (Y^.Typ=Bytes) then Asm52Sac;
                  X.REF:=1;
                end;
              end;
            end;
          end;
          dispose( Y );
        end; (* SIMPLEEXPRESSION *)

        procedure ConstantSet;
        var
          HIGH,LOW: CONREC;
          I,J,K: integer;
          ItemTAB: array [1..MaximumCases] of record
                     ValHigh,ValLow: integer;
                     LC  : word;
                   end;
          ItemTable,Labels: array[1..MaximumCases] of word;
          Temp: boolean;
          lb: word;

          procedure SetItem;
          begin
            temp:=DoubleDot;
            CONSTANT(FSYS+[COMMA,COLON,RBRACK], LOW);
            if LOW.TP <> CHARS then DoubleDot:=temp;
            if (LOW.TP <> BYTES) and (LOW.TP <> CHARS) then CError(62);
            HIGH:=LOW;
            if (LastSymbol = COLON) and DoubleDot then
            begin
              GetNextSymbol;
              CONSTANT(FSYS+[COMMA,COLON,RBRACK], HIGH);
              if HIGH.TP <> LOW.TP then CError(63);
              if (HIGH.TP <> BYTES) and (HIGH.TP <> CHARS) then CError(62);
            end;
            if I = MaximumCases then FATAL(6) else
            begin
              I := I+1;
              K := 0;
              ItemTAB[I].ValLow := LOW.I;
              ItemTAB[I].ValHigh := HIGH.I;
              PeekNextLabel(Labels[J+1]);
              Itemtable[I]:=labels[J+1];
            end;
          end;

        begin
          I := 0;
          J := 0;
          if LastSymbol<>LBRACK then CError(11);
          GetNextSymbol;
          SetItem;
          while LastSymbol = COMMA do
          begin
            GetNextSymbol;
            SetItem;
          end;
          if LastSymbol<>RBRACK then CError(12);
          getNextSymbol;
          Asm161(lb);
          if not NoConst then AT0('CONST');
          AO('@@'+IntToStr(lb)+':');
          AT0('DB '+IntToStr(I));
          for K := 1 to I do
          begin
            AT0('DB '+IntToStr(ItemTab[K].valLow)+','+IntToStr(ItemTab[K].valhigh));
          end;
          if not NoConst then AT0('CODE');
        end;

      begin (*EXPRESSION*)
        new( Y ); X.PTR:=false;
        AsmLineNumber;
        SIMPLEEXPRESSION(FSYS+[EQL,NEQ,LSS,LEQ,GTR,GEQ,INSY], X);
        if LastSymbol in [EQL,NEQ,LSS,LEQ,GTR,GEQ,INSY] then
        begin
          OP := LastSymbol;
          GetNextSymbol;
          if OP <> INSY then
          begin
            SIMPLEEXPRESSION(FSYS, Y^ );
            XEXP:=X.TYP; YEXP:=Y^.TYP;
           if (X.TYP=CHARS) and (Y^.TYP=BYTES) or
              (X.TYP=BYTES) and (Y^.TYP=CHARS) then
            begin
              X.TYP:=BYTES; Y^.TYP:=BYTES;
            end else
            begin
              if (X.TYP<=LINTS) and (Y^.TYP<=LINTS) then
                if X.TYP>Y^.TYP then Y^.TYP:=X.TYP else
                if Y^.TYP>X.TYP then X.TYP:=Y^.TYP;
            end;
            if (X.TYP in [NOTYP,SINTS,TRIPPLETS,WORDS,INTS,LINTS,SINGLES,BOOLS,CHARS,BYTES,ARRAYS]) and
              (X.TYP = Y^.TYP) then
            begin
              case X.TYP of
              Bytes,bools,chars:
              begin
                case OP of
                  EQL : begin ASM45b; end;
                  NEQ : begin ASM46b; end;
                  LSS : begin ASM47b; end;
                  LEQ : begin ASM48b; end;
                  GTR : begin ASM49b; end;
                  GEQ : begin ASM50b; end;
                end;
              end;
              WORDS:
              begin
                case OP of
                  EQL : begin ASM45; end;
                  NEQ : begin ASM46; end;
                  LSS : begin ASM47; end;
                  LEQ : begin ASM48; end;
                  GTR : begin ASM49; end;
                  GEQ : begin ASM50; end;
                end;
              end;
              INTS,SINTS:
              begin
                case OP of
                  EQL : begin ASM45; end;
                  NEQ : begin ASM46; end;
                  LSS : begin ASM47I(XEXP,YEXP); end;
                  LEQ : begin ASM48I(XEXP,YEXP); end;
                  GTR : begin ASM49I(XEXP,YEXP); end;
                  GEQ : begin ASM50I(XEXP,YEXP); end;
                end;
              end;
              LINTS,TRIPPLETS:
              begin
                case OP of
                  EQL : begin ASM45L; end;
                  NEQ : begin ASM46L; end;
                  LSS : begin ASM47L(XEXP,YEXP); end;
                  LEQ : begin ASM48L(XEXP,YEXP); end;
                  GTR : begin ASM49L(XEXP,YEXP); end;
                  GEQ : begin ASM50L(XEXP,YEXP); end;
                end;
              end;
              SINGLES:
              begin
                case OP of
                  EQL : begin ASM45L; end;
                  NEQ : begin ASM46L; end;
                  LSS : begin ASM47SI; end;
                  LEQ : begin ASM48SI; end;
                  GTR : begin ASM49SI; end;
                  GEQ : begin ASM50SI; end;
                end;
              end;
              ARRAYS: {this can only be string arrays}
              begin
                case OP of
                  EQL : begin ASM45S; end;
                  NEQ : begin ASM46S; end;
                  LSS : begin ASM47S; end;
                  LEQ : begin ASM48S; end;
                  GTR : begin ASM49S; end;
                  GEQ : begin ASM50S; end;
                end;
              end;
              end;
            end else
            begin
              CError(115);
            end;
          end else
          begin
            ConstantSet;
          end;
          X.TYP := BOOLS;
        end;
        dispose( Y );
      end (*EXPRESSION*) ;

{==============================================================================}

      procedure Assignment(I,LV,AD: integer; TargetIsOnStack: boolean; TX: SYMSET);

         var  X,Y: ITEM;
              ID: word;

{==========}

         procedure DereferenceTarget;

            begin
            NextPointerIsCode := false;
            if LastSymbol = CARET then
               begin
               DereferenceLeft := true;
               GetNextSymbol;
               if PointerBend = CodeMem then
                  NextPointerIsCode := true;
               end
            else
               begin
               X.TYP := WORDS;
               X.PTR := false;
               end;
            end;

{==========}

         begin
         CurrentAssignmentTarget := I;
         X.TYP := IdentifierTable[I].TYP;
         X.REF := IdentifierTable[I].REF;
         X.PTR := IdentifierTable[I].IsPointer;
         ID := I;
         DereferenceLeft := false;
         if X.PTR then
            DereferenceTarget;

         if TargetIsOnStack and DereferenceLeft then
            begin
            AsmDeref;
            DereferenceLeft := false;
            end;

         if LastSymbol in [LBRACK,LPARENT,PERIOD] then
            begin
            StartRecording;
            if IdentifierTable[i].IsPointer and not X.PTR then
               CError(70);
            if not TargetIsOnStack then
               if IdentifierTable[I].Normal and not DereferenceLeft then
                  Asm0(I)
               else
                  Asm1(X.TYP, I);

            Selector([BECOMES,EQL]+FSYS, X, ID, true);
          {DereferenceLeft:=false;
          if X.PTR then DereferenceTarget;
          if DereferenceLeft then ASMderef;}
            TargetIsOnStack := true;
            WithIsActive := false;
            StopRecording(false);
            end;

         if TCast.Typ <> NOTYP then
            begin
            X := TCast;
            if not AllowAnyCast then
               if TCastTypeSize<>IdentifierTable[ID].Size then
                  CError(106);
            if LastSymbol <> RParent then
               CError(4);
            GetNextSymbol;
            TCast.Typ := NOTYP;
            end;

         if LastSymbol = BECOMES then
            GetNextSymbol
         else
            CError(51);
         Expression(FSYS+TX, Y);
         if Y.TYP=CSTRINGS then
            begin
            Y.TYP := ARRAYS;
            Y.REF := 1;
            Y.PTR := false;
            end;

         if X.TYP = Y.TYP then
            begin
            if not (X.TYP in StandardTypes) then
               begin
               if not (StringType(X) and (StringType(Y))) then
                  if X.REF <> Y.REF then
                     CError(46);
               end;

            if TargetIsOnStack then
               Asm38xx(X,ID)
            else if IdentifierTable[I].Normal and not DereferenceLeft then
               Asm38(X.TYP, Y. TYP,I)
            else
               ASM38x(X. TYP, I);
            end
         else
            begin
            with IdentifierTable[I] do
               begin
               if IsPointer and (not DereferenceLeft and not TargetIsOnStack) then
                  begin
              {if Y.TYP>INTS then CError(73);}
                  X.TYP := INTS;
                  Asm38(X.TYP, Y.TYP, I);
                  end
               else
                  Convert(X, Y, I, TargetIsOnStack, DereferenceLeft and X.Ptr);
               end;
            end;
         end; { ASSIGNMENT }

      procedure COMPOUNDSTMNT;
      begin
        GetNextSymbol;
        STATEMENT([SEMICOLON,endSY]+FSYS,BreakLabel,ContinueLabel);
        while LastSymbol in [SEMICOLON]+STATBEGSYS do
        begin
          if LastSymbol = SEMICOLON then GetNextSymbol else CError(14);
          STATEMENT([SEMICOLON,endSY]+FSYS,BreakLabel,ContinueLabel)
        end;
        if LastSymbol = EndSy then GetNextSymbol else CError(57);
      end; { CompoundStatement }

      procedure IFSTATEMENT;    {modified for asm}
      var X: ITEM;
          LabelID1,LabelID2: word;
      begin
        GetNextSymbol;
        EXPRESSION(FSYS+[thenSY,DOSY], X);
        if NOT (X.TYP in [BOOLS,NOTYP]) then CError(17);
        ASMJpZero(MakeNewLabel(LabelID1));
        if LastSymbol = thenSY then GetNextSymbol else
        begin
          CError(52);
          if LastSymbol = DOSY then GetNextSymbol;
        end;
        STATEMENT(FSYS+[elseSY],BreakLabel,ContinueLabel);
        if LastSymbol = elseSY then
        begin
          GetNextSymbol;
          AT0('.jmp '+MakeNewLabel(LabelID2));
          AO('@@'+IntToStr(LabelID1)+':');
          STATEMENT(FSYS+[endsy],BreakLabel,ContinueLabel);
          AO('@@'+IntToStr(LabelID2)+':');
        end else AO('@@'+IntToStr(LabelID1)+':');
      end;  { IFSTATEMENT }

      procedure CASESTATEMENT;
      var
        X: ITEM;
        HIGH,LOW: CONREC;
        I,J,K: integer;
        CASETAB: array [1..MaximumCases] of record
                   ValHigh,ValLow: integer;
                   LC  : word
                 end;
        CaseTable,Labels: array[1..MaximumCases] of word;
        LabelID1,LabelID2,lb: word;
        Temp,JumpTable: boolean;
        b: byte;

      label mixed;

        procedure CASELABEL;
        var
          K: integer;
        begin
          temp:=DoubleDot;
          CONSTANT(FSYS+[COMMA,COLON], LOW);
          {if LOW.TP <> CHARS then}
          if not DoubleDot then DoubleDot:=temp;
          if (LOW.TP <> BYTES) and (LOW.TP <> CHARS) then CError(62);
          HIGH:=LOW;
          if (LastSymbol = COLON) and DoubleDot then
          begin
            InsideConstantDeclaration:=true;
            GetNextSymbol;
            InsideConstantDeclaration:=false;
            CONSTANT(FSYS+[COMMA,COLON], HIGH);
            if HIGH.TP <> LOW.TP then CError(63);
            if (HIGH.TP <> BYTES) and (HIGH.TP <> CHARS) then CError(62);
          end;
          if I = MaximumCases then FATAL(6) else
          begin
            I := I+1;
            K := 0;
            CASETAB[I].ValLow := LOW.I;
            CASETAB[I].ValHigh := HIGH.I;
            CASETAB[I].LC := ProgramLocationCounter;
            PeekNextLabel(Labels[J+1]);
            Casetable[I]:=labels[J+1];
          end;
        end; (*CASELABEL*)

        procedure ONECASE;
        begin
          if LastSymbol in CONSTBEGSYS then
          begin
            CASELABEL;
            while LastSymbol = COMMA do
            begin
              InsideConstantDeclaration:=true;
              GetNextSymbol;
              InsideConstantDeclaration:=false;
              CASELABEL
            end;
            if LastSymbol = COLON then GetNextSymbol else CError(5);
            AO(MakeNewLabel(labels[J+1])+':');
            STATEMENT([SEMICOLON,ENDSY,ELSESY]+FSYS,0,0);
            J := J + 1;
            AT0('.jmp @@'+IntToStr(LabelID2));
          end
        end (*ONECASE*) ;

      begin
        GetNextSymbol;
        I := 0;
        J := 0;
        MakeNewLabel(LabelID2);
        EXPRESSION(FSYS+[OFSY,COMMA,COLON], X);
        if NOT (X.TYP in [INTS,BYTES,BOOLS,WORDS,CHARS,NOTYP]) then CError(23);
        Asm110; {pop value from stack}
        AT0('.jmp '+MakeNewLabel(LabelID1));
        if LastSymbol = OFSY then
        begin
          InsideConstantDeclaration:=true;
          GetNextSymbol;
          InsideConstantDeclaration:=false;
        end else CError(8);
        ONECASE;
        while LastSymbol = SEMICOLON do
        begin
          InsideConstantDeclaration:=true;
          GetNextSymbol;
          InsideConstantDeclaration:=false;
          ONECASE
        end;
        JumpTable:=false;
        if (I>1) and (I<128) then
        if CaseTab[1].valLow=CaseTab[1].valHigh then
        begin
          b:=CaseTab[1].valLow;
          for K := 2 to I do
          begin
            if CaseTab[K].valLow<>CaseTab[K].ValHigh then goto mixed;
            if CaseTab[k].ValLow<>b+pred(K) then goto mixed;
          end;
          JumpTable:=true;
        end;
mixed:
        AO('@@'+IntToStr(LabelID1)+':');
        if JumpTable then
        begin
          Asm111(lb);
          if not NoConst then AT0('CONST');
          AO('@@'+IntToStr(lb)+':');
          AT0('DB '+IntToStr(I)+','+IntToStr(b));
          for K:=1 to I do
            AT0('DCA @@'+IntToStr(CaseTable[K]));
          if not NoConst then AT0('CODE');
        end else
        begin
          Asm104(lb);
          if not NoConst then AT0('CONST');
          AO('@@'+IntToStr(lb)+':');
          AT0('DB '+IntToStr(I));
          for K := 1 to I do
          begin
            AT0('DB '+IntToStr(CaseTab[K].valLow)+','+IntToStr(CaseTab[K].valhigh));
            AT0('DCA @@'+IntToStr(CaseTable[K]));
          end;
          if not NoConst then AT0('CODE');
        end;
        if LastSymbol = ELSESY then
        begin
          GetNextSymbol;
          STATEMENT([SEMICOLON,ENDSY]+FSYS,0,0);
          If LastSymbol=SEMICOLON then GetNextSymbol;
        end;
        AO('@@'+IntToStr(labelID2)+':');
        if LastSymbol = ENDSY then GetNextSymbol else CError(57)
      end (*CASESTATEMENT*) ;

      procedure repeatSTATEMENT; {asm finished}
      var
        X: ITEM;
        LC1: integer;
        LabelID1,LabelID2: word;
      begin
        LC1 := ProgramLocationCounter;
        AO(MakeNewLabel(LabelID1)+':');
        MakeNewLabel(LabelID2);
        GetNextSymbol; STATEMENT([SEMICOLON,UNTILSY]+FSYS,LabelID2,LabelID1);
        while LastSymbol in [SEMICOLON]+STATBEGSYS do
        begin
          if LastSymbol = SEMICOLON then GetNextSymbol else CError(14);
          STATEMENT([SEMICOLON,UNTILSY]+FSYS,LabelID2,LabelID1)
        end;
        if LastSymbol = UNTILSY then begin
          GetNextSymbol; EXPRESSION(FSYS, X);
          if NOT (X.TYP in [BOOLS,NOTYP]) then CError(17);
          ASMJpZero('@@'+IntToStr(LabelID1));
        end else CError(53);
        AO('@@'+IntToStr(LabelID2)+':');
      end (*repeatSTATEMENT*) ;

      procedure whileSTATEMENT; {asm finished}
      var
        X: ITEM;
        LC1,LC2: integer;
        LabelID1,LabelID2: word;
      begin
        GetNextSymbol;
        LC1 := ProgramLocationCounter;
        AO(MakeNewLabel(LabelID1)+':');
        EXPRESSION(FSYS+[DOSY], X);
        if NOT (X.TYP in [BOOLS,NOTYP]) then CError(17);
        LC2 := ProgramLocationCounter;
        ASMJpZero(MakeNewLabel(LabelID2));
        if LastSymbol = DOSY then GetNextSymbol else CError(54);
        STATEMENT(FSYS,LabelID2,LabelID1);
        AT0('.jmp @@'+IntToStr(LabelID1));
        AO('@@'+IntToStr(LabelID2)+':');
      end; (* WHILESTATEMENT *)

      procedure GotoStatement;
      begin
        GetNextSymbol;
        if LastSymbol = IDENT then
        begin
          I := GetIdentifierLocation(Identifier,true,true);
          GetNextSymbol;
          if IdentifierTable[I].OBJ<>TLabels then CError(67) else
          begin
            if IdentifierTable[I].REF<>ProcedureBlockIndex then CError(68);
            InsertGoto(I);
          end;
        end;
      end;

      procedure FORSTATEMENT; {finished asm}
      var CVT : TYPES;
          X   : ITEM;
          LVI : integer;
          LabelID1,LabelID2,LabelID3,FDir: word;
          LoopVarLb: string;                                                     //ss short

      begin
        GetNextSymbol;
        if LastSymbol = IDENT then
        begin
          LVI := GetIdentifierLocation(Identifier,true,true);
          GetNextSymbol;
          if IdentifierTable[LVI].OBJ = TVARIABLE then
          begin
            ASSIGNMENT(LVI,IdentifierTable[LVI].LEV, IdentifierTable[LVI].ADR, false, [TOSY,DOWNTOSY]);
            CVT := IdentifierTable[LVI].TYP;
            if not IdentifierTable[LVI].NORMAL then CError(37) else
            begin
              LoopVarlb:=LevelID(LVI);
            end;
            if not (CVT in [SINTS,INTS,WORDS,BYTES,TRIPPLETS,LINTS]) then CError(18)
          end else CError(37);
        end else SKIP([BECOMES,TOSY,DOWNTOSY,DOSY]+FSYS, 2);

        MakeNewLabel(LabelID1);
        MakeNewLabel(LabelID2);
        MakeNewLabel(LabelID3);

        AO('@@'+IntToStr(LabelID1)+':'); //start of for-loop

        if LastSymbol in [TOSY, DOWNTOSY] then
        begin
          if LastSymbol=TOSY then FDir:=0 else FDir:=1;
          Asm1(IdentifierTable[LVI].Typ,LVI);
          if not IdentifierTable[LVI].NORMAL or IdentifierTable[LVI].IsPointer then CError(100);
          GetNextSymbol;
          EXPRESSION([DOSY]+FSYS, X);
          if not (X.TYP in [BYTES,WORDS,SINTS,INTS,TRIPPLETS,LINTS]) then CError(19);
          if CVT>X.TYP then X.TYP:=CVT;
          if Fdir=0 then
          begin
            case X.TYP of
            Bytes: ASM48b;
            WORDS: ASM48;
            INTS,SINTS: ASM48I(X.TYP,X.TYP);
            LINTS,TRIPPLETS: ASM48L(X.TYP,X.TYP);
            end;
          end else
          begin
            case X.TYP of
            Bytes: ASM50b;
            WORDS: ASM50;
            INTS,SINTS: ASM50I(X.TYP,X.TYP);
            LINTS,TRIPPLETS: ASM50L(X.TYP,X.TYP);
            end;
          end;
          ASMJpZero('@@'+IntToStr(LabelID2));
        end else SKIP([DOSY]+FSYS, 55);

        if LastSymbol = DOSY then GetNextSymbol else CError(54);

        STATEMENT(FSYS,LabelID2,LabelID3); {for2up/for2down}

        AO('@@'+IntToStr(LabelID3)+':');  //continue
        IncDec(CVT,LVI,X,FDir,false,true);
        AT0('.jmp @@'+IntToStr(LabelID1));
        AO('@@'+IntToStr(LabelID2)+':'); //end loop and exit
      end; (* FORSTATEMENT *)

      procedure ASMStatement;
      begin
        if CurrentIncludeFile=0 then
        begin
          while not EndOfSourceFile do
          begin
            LastLine:=CurrentLine;
            ReadFromSource(CurrentLine);
            LineLength:=length(CurrentLine);
            inc(TotalLines);
            inc(ErrorLine);
            if pos('END;',Uppercase(CurrentLine))=0 then
            begin
              ASMOutput.Add(CurrentLine);
            end else break;
          end;
        end else
        begin
          with IncludeFile[CurrentIncludeFile] do
          begin
            while not EndOfIncludeFile do
            begin
              LastLine:=CurrentLine;
              if ReadFromInclude(CurrentLine) then
              begin
                LineLength:=length(CurrentLine);
                inc(TotalLines);
                inc(IncludeErrorLine);
                if pos('END;',Uppercase(CurrentLine))=0 then
                begin
                  ASMOutput.Add(CurrentLine);
                end else break;
              end;
            end;
          end;
        end;
        CharacterCounter:=0;
        LineLength:=0;
        LastSymbol:=SEMICOLON;
      end;

      procedure STANDPROC( N : integer );
      var I : integer;
          X,Y : ITEM;
          ID,V: word;
          s: string;
          SourceInCode: boolean;

      begin
        case N of
        5,6: {inc, dec}
          if LastSymbol <> LPARENT then CError(9) else
          begin
            GetNextSymbol;
            if LastSymbol<>IDENT then CError(0);
            V:=GetIdentifierLocation(Identifier,true,true);
            IdentAddress(true,false,false,false,X,ID);
            if not (X.TYP in [CHARS,SINTS,BYTES,INTS,WORDS,TRIPPLETS,LINTS]) then CError(82);
            if n=5 then
              IncDec(X.TYP,v,X,0,false,false) else
              IncDec(X.TYP,v,X,1,false,false);
            if LastSymbol=RPARENT then GetNextSymbol else CError(4)
          end;
          7: {move}
          if LastSymbol <> LPARENT then CError(9) else
          begin
            GetNextSymbol;
            IdentAddress(true,false,false,false,X,ID);
            if IdentLocation then SourceInCode:=true else SourceInCode:=false;
            if LastSymbol<>COMMA then CError(78);
            GetNextSymbol;
            IdentAddress(true,false,false,false,X,ID);
            if LastSymbol<>COMMA then CError(78);
            GetNextSymbol;
            CurrentAssignmentTarget:=0;
            EXPRESSION(FSYS+[RPARENT], Y);
            if Y.TYP=LINTS then CError(85);
            if not (Y.TYP in [BYTES,SINTS,INTS,WORDS,CHARS]) then CError(84) else ASM152I(SourceInCode);
            if LastSymbol=RPARENT then GetNextSymbol else CError(4)
          end;
          8: {Fillchar}
          if LastSymbol <> LPARENT then CError(9) else
          begin
            GetNextSymbol;
            IdentAddress(true,false,false,false,X,ID);
            if LastSymbol<>COMMA then CError(78);
            GetNextSymbol;
            EXPRESSION(FSYS+[RPARENT,COMMA], Y);
            if LastSymbol<>COMMA then CError(78);
            if Y.TYP=LINTS then CError(85);
            if not (Y.TYP in [BYTES,SINTS,INTS,WORDS,CHARS]) then CError(84);
            GetNextSymbol;
            EXPRESSION(FSYS+[RPARENT], Y);
            if Y.TYP=LINTS then CError(85);
            if not (Y.TYP in [BYTES,INTS,SINTS,WORDS,CHARS]) then CError(84) else ASM153I;
            if LastSymbol=RPARENT then GetNextSymbol else CError(4)
          end;
          9: {E2Write}
          if LastSymbol <> LPARENT then CError(9) else
          begin
            GetNextSymbol;
            s:=Identifier;
            IdentAddress(true,false,false,true,X,ID);
            Identifier:=s;
            I := GetIdentifierLocation(Identifier,true,false);
            if not IdentifierTable[I].E2Var then CError(99);
            if LastSymbol<>COMMA then CError(78);
            GetNextSymbol;
            IdentAddress(true,false,false,false,X,ID);
            if LastSymbol=RPARENT then GetNextSymbol else CError(4);
            ASM164(IdentifierTable[I].size);
          end;
          10: {E2BlockRead}
          if LastSymbol <> LPARENT then CError(9) else
          begin
            GetNextSymbol;
            s:=Identifier;
            IdentAddress(true,false,false,true,X,ID);
            Identifier:=s;
            I := GetIdentifierLocation(Identifier,true,false);
            if not IdentifierTable[I].E2Var then CError(99);
            if LastSymbol<>COMMA then CError(78);
            GetNextSymbol;
            IdentAddress(true,false,false,false,X,ID);
            if LastSymbol<>COMMA then CError(78);
            GetNextSymbol;
            EXPRESSION(FSYS+[RPARENT], Y);
            if Y.TYP=LINTS then CError(85);
            if not (Y.TYP in [BYTES,WORDS,INTS,SINTS]) then CError(83);
            if LastSymbol=RPARENT then GetNextSymbol else CError(4);
            ASM166;
          end;
          11: {Insert}
          if LastSymbol <> LPARENT then CError(9) else
          begin
            GetNextSymbol;
            EXPRESSION(FSYS+[RPARENT,COMMA], Y);
            if LastSymbol<>COMMA then CError(78);
            if not StringType(Y) then
            begin
              if Y.TYP<>Chars then CError(38);
              ASM105; {convert char on stack to string[1]}
            end;
            GetNextSymbol;
            IdentAddress(true,false,false,false,X,ID);
            if LastSymbol<>COMMA then CError(78);
            if not StringType(X) then CError(38);
            GetNextSymbol;
            EXPRESSION(FSYS+[RPARENT], Y);
            if Y.TYP=LINTS then CError(85);
            if not (Y.TYP in [BYTES,INTS,SINTS,WORDS]) then CError(84) else
              ASM162(ArrayTable[X.Ref].size);
            if LastSymbol=RPARENT then GetNextSymbol else CError(4)
          end;
          12: {Delete}
          if LastSymbol <> LPARENT then CError(9) else
          begin
            GetNextSymbol;
            IdentAddress(true,false,false,false,X,ID);
            if LastSymbol<>COMMA then CError(78);
            if not StringType(X) then CError(38);
            GetNextSymbol;
            EXPRESSION(FSYS+[RPARENT,COMMA], Y);
            if LastSymbol<>COMMA then CError(78);
            if not (Y.TYP in [BYTES,WORDS,INTS,SINTS]) then CError(84);
            GetNextSymbol;
            EXPRESSION(FSYS+[RPARENT], Y);
            if Y.TYP=LINTS then CError(85);
            if not (Y.TYP in [BYTES,INTS,WORDS,SINTS]) then CError(84) else ASM163;
            if LastSymbol=RPARENT then GetNextSymbol else CError(4)
          end;
          13:{New}
          begin
            if LastSymbol <> LPARENT then CError(9) else
            begin
              GetNextSymbol;
              if LastSymbol=IDENT then
              begin
                ID:=GetIdentifierLocation(Identifier,true,true);
                if IdentifierTable[ID].OBJ=TVariable then
                begin
                  if IdentifierTable[ID].IsPointer then
                  begin
                    ASM150(IdentifierTable[ID].sizeIfPointer);
                    ASM151;
                    ASM152(ID);
                  end else CError(72);
                end else CError(37);
                GetNextSymbol;
              end else CError(2);
            end;
            if LastSymbol=RPARENT then GetNextSymbol else CError(4)
          end;
          14: {Mark}
          begin
            if LastSymbol <> LPARENT then CError(9) else
            begin
              GetNextSymbol;
              if LastSymbol=IDENT then
              begin
                ID:=GetIdentifierLocation(Identifier,true,true);
                if IdentifierTable[ID].OBJ=TVariable then
                begin
                  if IdentifierTable[ID].IsPointer then
                  begin
                    ASM140;
                    ASM152(ID);
                  end else CError(72);
                end else CError(37);
                GetNextSymbol;
              end else CError(2);
            end;
            if LastSymbol=RPARENT then GetNextSymbol else CError(4)
          end;
          15: {Release}
          begin
            if LastSymbol <> LPARENT then CError(9) else
            begin
              GetNextSymbol;
              if LastSymbol=IDENT then
              begin
                ID:=GetIdentifierLocation(Identifier,true,true);
                if IdentifierTable[ID].OBJ=TVariable then
                begin
                  if IdentifierTable[ID].IsPointer then
                  begin
                    ASM141(ID);
                  end else CError(72);
                end else CError(37);
                GetNextSymbol;
              end else CError(2);
            end;
            if LastSymbol=RPARENT then GetNextSymbol else CError(4)
          end;
          16: {GetMem}
          begin
            if LastSymbol <> LPARENT then CError(9) else
            begin
              GetNextSymbol;
              if LastSymbol<>IDENT then CError(2);
              ID:=GetIdentifierLocation(Identifier,true,true);
              if not (IdentifierTable[ID].OBJ=TVariable) then CError(37);
              if not IdentifierTable[ID].IsPointer then CError(72);
              GetNextSymbol;
              if LastSymbol<>COMMA then CError(78);
              GetNextSymbol;
              EXPRESSION(FSYS+[RPARENT], Y);
              if Y.TYP=LINTS then CError(85);
              if not (Y.TYP in [BYTES,WORDS,INTS,SINTS]) then CError(83);
              ASM151;
              ASM152(ID);
            end;
            if LastSymbol=RPARENT then GetNextSymbol else CError(4)
          end;
          17: {E2BlockWrite}
          if LastSymbol <> LPARENT then CError(9) else
          begin
            GetNextSymbol;
            s:=Identifier;
            IdentAddress(true,false,false,true,X,ID);
            Identifier:=s;
            I := GetIdentifierLocation(Identifier,true,false);
            if not IdentifierTable[I].E2Var then CError(99);
            if LastSymbol<>COMMA then CError(78);
            GetNextSymbol;
            IdentAddress(true,false,false,false,X,ID);
            if LastSymbol<>COMMA then CError(78);
            GetNextSymbol;
            EXPRESSION(FSYS+[RPARENT], Y);
            if Y.TYP=LINTS then CError(85);
            if not (Y.TYP in [BYTES,WORDS,INTS,SINTS]) then CError(83);
            if LastSymbol=RPARENT then GetNextSymbol else CError(4);
            ASM167;
          end;
          18: {WDR}
          if LastSymbol<>Semicolon then CError(14) else
          begin
            Asm168;
          end;
          19: {Sleep}
          if LastSymbol<>Semicolon then CError(14) else
          begin
            Asm169;
          end;
          20: {OUT}
          if LastSymbol <> LPARENT then CError(9) else
          begin
            GetNextSymbol;
            if LastSymbol=IDENT then
            begin
              I:=GetIdentifierLocation(Identifier,true,true);
              with IdentifierTable[I] do
              begin
                if OBJ=TVariable then
                begin
                  if ConstantAddress(I,V) then
                    ASM171(V) else CError(95);
                end;
              end;
            end else
            begin
              if LastSymbol=BYTECON then
              begin
                ASM171(IntegerNumeric);
              end else CError(100);
            end;
            GetNextSymbol;
            if LastSymbol<>COMMA then CError(78);
            GetNextSymbol;
            EXPRESSION(FSYS+[RPARENT], Y);
            if not (Y.TYP in [BYTES,WORDS,INTS,SINTS,TRIPPLETS,LINTS,CHARS]) then CError(83);
            if LastSymbol=RPARENT then GetNextSymbol else CError(4);
            ASM172;
          end;
          21:
          if LastSymbol<>Semicolon then CError(14) else
          begin
            Asm300(HashIfGlobal(ProcedureIdTableIndex)+'@'+LevelID(ProcedureIdTableIndex));
          end;
          22:
          if LastSymbol<>Semicolon then CError(14) else
          begin
            Asm301(HashIfGlobal(ProcedureIdTableIndex)+'@'+LevelID(ProcedureIdTableIndex));
          end;
          23: {EI}
          if LastSymbol<>Semicolon then CError(14) else
          begin
            Asm305;
          end;
          24: {DI}
          if LastSymbol<>Semicolon then CError(14) else
          begin
            Asm306;
          end;
          25: {SetIOBit}
          if LastSymbol <> LPARENT then CError(9) else
          begin
            GetNextSymbol;
            if LastSymbol=IDENT then
            begin
              I:=GetIdentifierLocation(Identifier,true,true);
              with IdentifierTable[I] do
              begin
                if OBJ=TVariable then
                begin
                  if ConstantAddress(I,V) then
                    ASM171(V) else CError(95);
                end;
              end;
            end else
            begin
              if LastSymbol=BYTECON then
              begin
                ASM171(IntegerNumeric);
              end else CError(100);
            end;
            GetNextSymbol;
            if LastSymbol<>COMMA then CError(78);
            GetNextSymbol;
            if LastSymbol=IDENT then
            begin
              I:=GetIdentifierLocation(Identifier,true,true);
              with IdentifierTable[I] do
              begin
                if OBJ=TConstant then
                begin
                  if IsAbsolute=1 then
                    ASM171b(value) else CError(95);
                end;
              end;
            end else
            begin
              if LastSymbol=BYTECON then
              begin
                ASM171b(IntegerNumeric);
              end else CError(118);
            end;
            GetNextSymbol;
            if LastSymbol=RPARENT then GetNextSymbol else CError(4);
            ASM173;
          end;
          26: {ClrIOBit}
          if LastSymbol <> LPARENT then CError(9) else
          begin
            GetNextSymbol;
            if LastSymbol=IDENT then
            begin
              I:=GetIdentifierLocation(Identifier,true,true);
              with IdentifierTable[I] do
              begin
                if OBJ=TVariable then
                begin
                  if ConstantAddress(I,V) then
                    ASM171(V) else CError(95);
                end;
              end;
            end else
            begin
              if LastSymbol=BYTECON then
              begin
                ASM171(IntegerNumeric);
              end else CError(100);
            end;
            GetNextSymbol;
            if LastSymbol<>COMMA then CError(78);
            GetNextSymbol;
            if LastSymbol=IDENT then
            begin
              I:=GetIdentifierLocation(Identifier,true,true);
              with IdentifierTable[I] do
              begin
                if OBJ=TConstant then
                begin
                  if IsAbsolute=1 then
                    ASM171b(value) else CError(95);
                end;
              end;
            end else
            begin
              if LastSymbol=BYTECON then
              begin
                ASM171b(IntegerNumeric);
              end else CError(118);
            end;
            GetNextSymbol;
            if LastSymbol=RPARENT then GetNextSymbol else CError(4);
            ASM174;
          end;
          27:
          if LastSymbol <> LPARENT then CError(9) else
          begin
            GetNextSymbol;
            IdentAddress(true,false,false,false,X,ID);
            if LastSymbol<>COMMA then CError(78);
            GetNextSymbol;
            EXPRESSION(FSYS+[RPARENT], Y);
            if Y.TYP=LINTS then CError(85);
            if not (Y.TYP in [BYTES,WORDS,INTS,SINTS]) then CError(83);
            if LastSymbol=RPARENT then GetNextSymbol else CError(4);
            ASM177R;
          end;
          46: {STRADD}
          begin
            if LastSymbol <> LPARENT then CError(9) else
            begin
              GetNextSymbol;
              IdentAddress(true,false,false,false,X,ID);
              if LastSymbol<>COMMA then CError(78);
              if not StringType(X) then CError(38);
              GetNextSymbol;
              EXPRESSION(FSYS+[RPARENT,COMMA], Y);
              if not StringType(Y) then
              begin
                if Y.TYP<>Chars then CError(38);
                ASM105; {convert char on stack to string[1]}
              end;
              ASM307(ArrayTable[X.Ref].size);
            end;
            if LastSymbol=RPARENT then GetNextSymbol else CError(4)
          end;
          47: {Break}
          begin
            ASMBreak;
          end;
        end; (* CASE *)
      end; (* STANDPROC *)

      procedure ExitStatement;
      begin
        if ISFUN then ASM160(FuncExit) else AsmRET;
        GetNextSymbol;
      end;

      procedure ContinueStatement;
      begin
        if ContinueLabel>0 then ASM160(ContinueLabel) else CError(90);
        GetNextSymbol;
      end;

      procedure BreakStatement;
      begin
        if BreakLabel>0 then ASM160(BreakLabel) else CError(91);
        GetNextSymbol;
      end;

      procedure WithStatement;
      var
        X: Item;
        ID,ActiveWiths: word;
      begin
        ActiveWiths:=0;
        repeat
          GetNextSymbol;
          IdentAddress(true,true,false,false,X,ID);
          if X.TYP<>RECORDS then CError(105);
          WithInfo[NumberOfWiths].ID:=ID;
          WithInfo[NumberOfWiths].LabelID:=NumberOfRecordings-1;
          //StopRecording(true);
          ASM109B(NumberOfWiths); //move calculated address to pointer for with
          inc(NumberOfWiths);
          inc(ActiveWiths);
          inc(NumberOfWithPointers);
          //DeleteFromStartOfRecording;
        until LastSymbol<>COMMA;
        if LastSymbol = DOSY then GetNextSymbol else CError(54);
        STATEMENT(FSYS,BreakLabel,ContinueLabel);
        while ActiveWiths>0 do
        begin
          dec(NumberOfWiths);
          dec(ActiveWiths);
        end;
      end;

      procedure TypeCast;
      begin
        if LastSymbol<>LParent then CError(9);
        TCast.TYP := IdentifierTable[I].TYP;
        TCast.REF := IdentifierTable[I].REF;
        TCast.PTR := IdentifierTable[I].IsPointer;
        TCastTypeSize:=IdentifierTable[I].Size;
        GetNextSymbol;
      end;

    begin (*STATEMENT*)
     STP:=0;
     AdrCacheValid:=false;
     FirstADRCache:=true;
1:
     WithIsActive:=false;
      if LastSymbol in STATBEGSYS+[IDENT] then
          case LastSymbol of
            IDENT:    begin
                        AsmLineNumber;
                        Tis:=false;
                        if not IsWith(I) then
                           I := GetIdentifierLocation(Identifier,true,true) else Tis:=true;
                        if I <> 0 then
                        case IdentifierTable[I].OBJ of
                          TLABELS : begin
                                      if TCast.TYP<>NOTYP then CError(107);
                                      GetNextSymbol;
                                      InsertLabel(I);
                                      if LastSymbol<>Colon then CError(5);
                                      LastSymbol:=Semicolon;
                                    end;
                          TCONSTANT: CError(45);
                          TTYPE    : begin
                                       GetNextSymbol;
                                       TypeCast;
                                       goto 1;
                                     end;
                          TVARIABLE :
                          begin
                            GetNextSymbol;
                            ASSIGNMENT(I,IdentifierTable[I].LEV, IdentifierTable[I].ADR, TiS, []);
                          end;
                          TProcs:
                          begin
                            if TCast.TYP<>NOTYP then CError(107);
                            GetNextSymbol;
                            if IdentifierTable[I].LEV <> 0 then CallProcedure(FSYS, I)
                              else STANDPROC(IdentifierTable[I].ADR);
                          end;
                          TFunc :
                          begin
                            if TCast.TYP<>NOTYP then CError(107);
                            if IdentifierTable[I].PROCREF = DISPLAY[LEVEL] then
                            begin
                              GetNextSymbol;
                              ASSIGNMENT(I,IdentifierTable[I].LEV+1, 0, TiS, []);
                            end else
                            begin
                              if IdentifierTable[I].LEV <> 0 then
                              begin
                                GetNextSymbol; CallProcedure(FSYS, I)
                              end else
                              begin
                                EXPRESSION(FSYS+[], X);
                              end;
                              Asm156(I);
                            end;
                          end;
                        end; (* case *)
                      end;
            BEGINSY  :   COMPOUNDSTMNT;
            IFSY     :     IFSTATEMENT;
            CASESY   :   CASESTATEMENT;
            WHILESY  :  WHILESTATEMENT;
            REPEATSY : REPEATSTATEMENT;
            FORSY    :    FORSTATEMENT;
            GOTOSY   :   GOTOSTATEMENT;
            ASMSY    :    ASMStatement;
            EXITSY   :   EXITStatement;
            CONTINUESY : ContinueStatement;
            BREAKSY :   BreakStatement;
            WITHSY :   WithStatement;
          end;
        TEST(FSYS, [], 14)
    end (*STATEMENT*) ;

label repx,AsGlobal;

   begin //new block
   if level=1 then
      ASMCoff1(ProgramName)
   else
      ASMCoff1(Identifier);
   if Level = 2 then
      TShareSize := 0;
   ExtraOffset := 0;
   LevelForParser := Level;
   StubProcedure := false;
   IsAbsoluteProcedure := false;
   DataAllocationIndex := 5;
   ProcedureIDTableIndex := IdTableIndex;
   if GetForward(Identifier, IX, Btix, FirstParameter, NumberOfParameters, CurrentProcedureIndex) then
      begin
      ProcedureIDTableIndex := IX;
      Display[Level] := Btix;
      ProcedureBlockIndex := Btix;
      FrameSize := 0;
      if LastSymbol = LParent then
         begin
         CheckParamList(FirstParameter, NumberOfParameters);
         end;
      FrameSize := IdentifierTable[ProcedureIDTableIndex].Parametersize;
      if IsFun then
         if LastSymbol = COLON then
            begin
            GetNextSymbol; {IsFuncCaret:=Caret;}  (*FUNCTION TYPE*)
            if LastSymbol = IDENT then
               begin
               X := GetIdentifierLocation(Identifier, true, true);
               if IdentifierTable[X].Obj <> TType then
                  CError(127);
               if IdentifierTable[X].Ref <> IdentifierTable[ProcedureIDTableIndex].Ref then
                  CError(127);
               GetNextSymbol;
               end;
            end;

         if LastSymbol <> Semicolon then CError(14);
         end
      else
         begin
         if Level > MaximumLevel then Fatal(5);
         Test([LPARENT, COLON, SEMICOLON], FSYS, 14);
         EnterBlock;
         Display[Level] := BlockTableIndex;
         ProcedureBlockIndex := BlockTableIndex;
         with IdentifierTable[ProcedureIDTableIndex] do
            begin
            Typ := NoTyp;
         ProcRef := ProcedureBlockIndex;
         end;

      FrameSize := 0;
      FirstParameter := IDTableIndex;
      NumberOfParameters := 0;
      NP := 0;
      if LastSymbol = LPARENT then
         begin
         if Level > 1 then
            ParameterList(NP);
         end
      else if LastSymbol = COLON then
         IntFileAdd(':')
      else IntFileAdd(';');
      BlockTable[ProcedureBlockIndex].LastPar := IdTableIndex;
      BlockTable[ProcedureBlockIndex].PSize := DataAllocationIndex;
      IdentifierTable[ProcedureIDTableIndex].Block := FirstParameter;
      IdentifierTable[ProcedureIDTableIndex].NumberOfParameters := NP;
      IdentifierTable[ProcedureIDTableIndex].IsDynamic := false;
      IdentifierTable[ProcedureIDTableIndex].Parametersize := FrameSize;
      if IsFun then
         if LastSymbol = COLON then
            begin
            GetNextSymbol; {IsFuncCaret:=Caret;}  (*FUNCTION TYPE*)
            if LastSymbol = IDENT then
               begin
               if level=2 then
                  IntFileAdd(Identifier + ';');
               X := GetIdentifierLocation(Identifier, true, true);
               GetNextSymbol;
               if X <> 0 then
                  if IdentifierTable[X].Obj <> TTYPE then
                     CError(29)
                  else
                     begin
                     with IdentifierTable[ProcedureIDTableIndex] do
                        begin
                        Typ := IdentifierTable[X].Typ;
                        Size := IdentifierTable[X].Size;
                        Lev := Level;
                        SizeIfPointer := IdentifierTable[X].SizeIfPointer;
                        Normal := true;
                        IsPointer := IdentifierTable[X].IsPointer;
                        Ref := IdentifierTable[X].Ref;
                        IsDynamic := DynamicVars;
                        ExtraOffset := Size;
                        StackOffset := 0;
                        TShareSize := TShareSize+size;
                        if SharedWith > 0 then
                           begin
                           if IdentifierTable[SharedWith].typ = TShare then
                              if IdentifierTable[SharedWith].Size < TShareSize then
                                 IdentifierTable[SharedWith].Size := TShareSize;
                           end;
                         //OnStack:=false;
                        end;

                     EnterNewIdentifier('RESULT', TVARIABLE);
                     Ip := IdTableIndex;
                     IdentifierTable[Ip].Typ := IdentifierTable[ProcedureIDTableIndex].Typ;
                     IdentifierTable[Ip].Size := IdentifierTable[ProcedureIDTableIndex].Size;
                     IdentifierTable[Ip].SizeIfPointer := IdentifierTable[ProcedureIDTableIndex].SizeIfpointer;
                     IdentifierTable[Ip].Ref := IdentifierTable[ProcedureIDTableIndex].Ref;
                     IdentifierTable[Ip].IsPointer := IdentifierTable[ProcedureIDTableIndex].IsPointer;
                     IdentifierTable[Ip].Address := ProcedureIDTableIndex;
                     IdentifierTable[Ip].IsAbsolute := 2;
                     IdentifierTable[Ip].Normal := true;
              //IdentifierTable[Ip].OnStack:=false;
                     IdentifierTable[Ip].StackOffset := 0;
                     IdentifierTable[Ip].IsDynamic := Dynamicvars;
                     end;
                  end
               else
                  Skip([SEMICOLON] + FSYS, 2)
            end
         else
            CError(5);

         if level>1 then
            begin
            IntFileAdd('External;');
            IntFileAdd('');
            end;

         if UnitSystem and InterfaceSection and (level<=2) and not InsideUsesClause then
            begin
            Globals.Add('@' + LevelID(ProcedureIDTableIndex));
            if IsFun then
               Globals.Add(LevelID(ProcedureIDTableIndex));
            inc(NumberOfParameters);
            FP := FirstParameter;
            PN := NumberOfparameters;
            while PN > 0 do
               begin
               IdentifierTable[FP].Global := true;
               inc(FP);
               dec(PN);
               end;
            end;
         end;

      if LastSymbol = SEMICOLON then
         GetNextSymbol
      else if LastSymbol <> ABSOLUTESY then
         CError(14);

      if (Level = 1) and (LastSymbol = VECTORSY) then
         begin
         GetNextSymbol;
         if LastSymbol <> IDENT then
            CError(2);
         if Identifier = 'SHORTJMP' then
            Jmpx := 1
         else if Identifier = 'LONGJMP' then
            jmpx := 2
         else if Identifier = 'NOJMP' then
            jmpx := 0
         else
            begin
            ErrorMsg := 'Expected SHORTJMP,LONGJMP or NOJMP';
            CError(126);
            end;

         GetNextSymbol;
         if LastSymbol = IDENT then
            begin
            ASM403(Identifier, ProgramName, jmpx);
            end
         else if LastSymbol in [BYTECON,INTCON,WORDCON,LINTCON] then
            begin
            ASM403(IntToStr(Integernumeric), ProgramName, jmpx);
            end
         else
            CError(2);
         GetNextSymbol;
         if LastSymbol <> SEMICOLON then
            CError(14);
         GetNextSymbol;
         end;

      if (Level = 1) and UnitSystem then
         begin
         if LastSymbol <> InterfaceSY then
            CError(125);
         GetNextSymbol;
         InterfaceSection := true;
         assignfile(IntFile, Project[prjPath] + ChangeFileExt(ProgramName, '.EPI'));
         rewrite(INTFile);
         if DynamicVars then
            IntFileAddcr('{#K+}')
         else
            IntFileAddcr('{#K-}');
         if PointerBend = Codemem then
            IntFileAddcr('{#X Code}')
         else if PointerBend=Datamem then
            IntFileAddcr('{#X Data}');
         end;

      if (Level = 1) and (LastSymbol = USESSY) then
         begin
         OldDynamicvars := DynamicVars;
         OldPointerBend := PointerBend;
         LastSymbol := COMMA;
         LinkProject.Clear;
         while LastSymbol = COMMA do
            begin
            GetNextSymbol;
            if LastSymbol <> IDENT then
               CERROR(2);
            ASMOutput.Add(#9 + 'library ' + Identifier);
            LinkProject.Add(Identifier);
            GetNextSymbol;
            end;

         if LastSymbol = SEMICOLON then
            begin
            if LinkProject.count>0 then
               begin
               ReadingFromUnit := false;
               ReadingUnitNumber := 0;
               InsideUsesClause := true;
               end;
            GetNextSymbol;
            end
         else
            CError(14);
      end;
   if LastSymbol = VectorSY then
      begin
   GetNextSymbol;
   if LastSymbol <> IDENT then
      CError(2);
   if identifier = 'SHORTJMP' then
      jmpx := 1
   else if identifier = 'LONGJMP' then
      jmpx := 2
   else
   if identifier = 'NOJMP' then
      jmpx := 0
   else
      begin
      ErrorMsg := 'Expected SHORTJMP,LONGJMP or NOJMP';
      CError(126);
      end;
   GetNextSymbol;
   if LastSymbol<>IDENT then
      CError(2);
   ASM402(Identifier,ProcedureIDTableIndex,jmpx);
   GetNextSymbol;
   if LastSymbol<>SEMICOLON then
      CError(14);
   GetNextSymbol;
   end;

   if LastSymbol = ABSOLUTESY then
      begin
      GetNextSymbol;
      if LastSymbol in [BYTECON,INTCON,WORDCON] then
         begin
         IdentifierTable[ProcedureIDTableIndex].Address:=IntegerNumeric;
         IdentifierTable[ProcedureIDTableIndex].IsAbsolute:=1;
         GetNextSymbol;
         end
      else if LastSymbol = IDENT then
         begin
         IP := GetIdentifierLocation(Identifier, true, true);
         if IP > 0 then
            begin
            IdentifierTable[ProcedureIDTableIndex].Address := IP;
            IdentifierTable[ProcedureIDTableIndex].IsAbsolute := 2;
            GetNextSymbol;
            end;
         end
      else if LastSymbol <> LINTCON then
         CError(44)
      else
         CError(61);

      if LastSymbol<>SEMICOLON then
         CError(14)
      else
         GetNextSymbol;

      if UnitSystem and InterfaceSection and (level<=2) and not InsideUsesClause then
         goto AsGlobal;
      if LastSymbol = GlobalSY then
         begin
         if UnitSystem and InterfaceSection then
            CError(128);
         GetNextSymbol;
AsGlobal:
         Globals.Add('@' + LevelID(ProcedureIDTableIndex));
         if IsFun then
            Globals.Add(LevelID(ProcedureIDTableIndex));
         inc(NumberOfParameters);
         FP := Firstparameter;
         PN := NumberOfParameters;
         while PN > 0 do
            begin
            IdentifierTable[FP].Global := true;
            inc(FP);
            dec(PN);
            end;

         if LastSymbol = SEMICOLON then
            GetNextSymbol
         else
            CError(14);

         if LastSymbol = ExternalSY then
            CError(66);
         end;

      IsAbsoluteProcedure := true;
      end
   else if LastSymbol = GlobalSY then
      begin
      if UnitSystem and InterfaceSection then
         CError(128);
      GetNextSymbol;
      Globals.Add('@' + LevelID(ProcedureIDTableIndex));
      if IsFun then
         Globals.Add(LevelID(ProcedureIDTableIndex));
      inc(NumberOfParameters);
      FP := FirstParameter;
      PN := NumberOfParameters;
      while PN > 0 do
         begin
         IdentifierTable[FP].Global := true;
         inc(FP);
         dec(PN);
         end;
      if LastSymbol = SEMICOLON then
         GetNextSymbol
      else
         CError(14);

      if LastSymbol = ExternalSY then
        CError(66);
      end;

      if (LastSymbol in [ExternalSY,ForwardSY]) or IsAbsoluteProcedure then
         StubProcedure:=true;
      if UnitSystem and InterfaceSection and (level>1) then
         StubProcedure:=true;
      if not StubProcedure then
         begin
         I := 0;
         LocalVarSize := 0;
         VarFrag := 0;
         repeat
repx:
            if UnitSystem and InterfaceSection and (Level=1) then
               begin
               if LastSymbol = ImplementationSY then
                  begin
                  GetNextSymbol;
                  CloseFile(INTFile);
                  InterfaceSection := false;
                  end;
               end;

            if LastSymbol = CONSTSY then
               begin
               if Level = 1 then
                  begin
                  IntFileAdd('Const');
                  IntFileAdd('');
                  end;

               CONSTDECLARATION(false);
               goto repx;
               end;

            if LastSymbol = E2CONSTSY then
               begin
               if level=1 then
                  begin IntFileAdd('E2Const');
                  IntFileAdd('');
                  end;

               CONSTDECLARATION(true);
               goto repx;
               end;

            if LastSymbol =  TYPESY then
               begin
               if Level = 1 then
                  begin
                  IntFileAdd('Type');
                  IntFileAdd('');
                  end;

               TYPEDECLARATION;
               goto repx;
               end;

            if LastSymbol = VARSY then
               begin
               if Level = 1 then
                  begin
                  IntFileAdd('Var');
                  IntFileAdd('');
                  end;

            if DynamicVars and (VarFrag=2) then
               CError(109);
            if VarFrag=0 then
               VarFrag:=1;

            VARDECLARTION(false); goto repx;
            end;

         if LastSymbol = E2VARSY then
            begin
            if Level = 1 then
               begin
               IntFileAdd('E2Var');
               IntFileAdd('');
               end;

         if DynamicVars and (VarFrag=2) then
            CError(109);
         if VarFrag = 0 then
            VarFrag:=1;
         VARDECLARTION(true);
            goto repx;
         end;

      if LastSymbol = LabelSY then
         begin
         LabelDeclaration;
         goto repx;
         end;

      BlockTable[ProcedureBlockIndex].VSize := DataAllocationIndex;
      inc(I);
      //if level>1 then LevelOffset[Level]:=FrameSize;
      if LastSymbol in [PROCSY,FUNCSY] then
         begin
         PROCDECLARATION;
         if LastSymbol = Semicolon then
            GetNextSymbol;
         goto repx;
         end;

      if UnitSystem and (Level = 1) then
         begin
         if LastSymbol = ENDSY then
            begin
            GetNextSymbol;
            exit;
            end
         else
            CError(57);
         end
      else
         TEST([BEGINSY], BLOCKBEGSYS+STATBEGSYS, 56);
      until LastSymbol in STATBEGSYS;

      Asm302(HashIfGlobal(ProcedureIdTableIndex) + '@' + LevelID(ProcedureIdTableIndex));
      if IDName(ProcedureIdTableIndex) = '' then
         begin
         AO('@'+ProgramName+':');
         IdentifierTable[ProcedureIDTableIndex].StackUse := 0;
         InitialStack:=0;
         end
      else
         begin
         AO('@' + LevelID(ProcedureIdTableIndex) + ':');
         if DynamicVars then
            begin
            LevelOffset[Level] := FrameSize;
            ResultSize[Level] := ExtraOffset;
            DSize := FrameSize;
            ASM500(FrameSize, LocalVarSize);
            if IsFun then
               IdentifierTable[ProcedureIDTableIndex].StackOffset := 0;
            IdentifierTable[ProcedureIDTableIndex].StackUse := FrameSize + ExtraOffset;
            InitialStack := FrameSize + ExtraOffset;
            end
         else
            begin
            IdentifierTable[ProcedureIDTableIndex].StackUse := 0;
            InitialStack := 0;
            end;
         end;

      IdentifierTable[ProcedureIDTableIndex].Adr := ProgramLocationCounter;
      GetNextSymbol;
      STATEMENT([SEMICOLON,ENDSY]+FSYS,0,0);
      while LastSymbol in [SEMICOLON]+STATBEGSYS do
         begin
         if LastSymbol = SEMICOLON then GetNextSymbol else CError(14);
      STATEMENT([SEMICOLON,ENDSY]+FSYS,0,0)
    end;
    if LastSymbol = ENDSY then GetNextSymbol else CError(57);
    if StackEstimate<IdentifierTable[ProcedureIDTableIndex].StackUse then
      StackEstimate:=IdentifierTable[ProcedureIDTableIndex].StackUse;
    if IDName(ProcedureIdTableIndex)='' then
    begin
      if (pos('reti',AsmOutput[AsmOutput.count-1])=0) and
      (pos('reti',AsmOutput[AsmOutput.count-2])=0) then AT0('ret');
    end;
    Asm304;
  end else
  begin
    {if IsAbsoluteProcedure then
    begin
      inc(FirstParameter);
      while NumberOfParameters>0 do
      begin
        IdentifierTable[FirstParameter].Extern:=true;
        inc(FirstParameter);
        dec(NumberOfParameters);
      end;
    end else}
    if LastSymbol=ExternalSY then
    begin
      inc(NumberOfParameters);
      while NumberOfParameters>0 do
      begin
        IdentifierTable[FirstParameter].Extern:=true;
        inc(FirstParameter);
        dec(NumberOfParameters);
      end;
      ExternalAdd('@'+IDName(ProcedureIDTableIndex));
      if IsFun then
        ExternalAdd(IDName(ProcedureIDTableIndex));
      IdentifierTable[ProcedureIDTableIndex].Extern:=true;
      GetNextSymbol; if LastSymbol<>Semicolon then CError(14);
    end else
    if (identifier='FORWARD') or (UnitSystem and InterfaceSection) then
    begin
      EnterForward(IDName(ProcedureIDTableIndex),ProcedureIDTableIndex);
      if identifier='FORWARD' then
      begin
        GetNextSymbol; if LastSymbol<>Semicolon then CError(14);
      end;
    end;
  end;
  TEST(FSYS+[PERIOD,SEMICOLON,IMPLEMENTATIONSY], [], 6);
  dec(LevelForParser);
  AsmCoff2;
end; { block }

end.

