unit Compiler;

interface

uses SysUtils,forms,Dialogs,Init,PasSym,BlockA,AsmPas;

procedure ReadNextCharFromSource;   (* read next char; process line end *)
procedure ReadToEndOfLine;
procedure CERROR( N : INTEGER );
procedure FATAL( N : integer ); (* internal table overflow *)
procedure ENDSKIP;    (* underline skipped part of input *)
procedure RunPascalCompiler(Filename: string; Editor: word; var cs,ds: longint);
procedure ShowErrorPosition(ErrorFile: string; ErrorLine: longint; CharacterCounter: byte);
function ReadFromSource(var S: string): boolean;                                 //ss  short
function ReadFromInclude(var S: string): boolean;                                //ss  short
procedure IntFileAdd(s: string);
procedure IntFileAddcr(s: string);
procedure PRINTTABLES;
procedure Compile;

var
  SourceBuffer: array[0..255] of byte;
  SourceBufferPtr: word;
  CharsInSourceBuffer: Integer;
  FileBeingCompiled:   string;

implementation

uses AsmStatus,AsmDefs,PascalDefs, StringConversion, MainForm;

(*--------------------------------------------------------ERROR-----*)
{==============================================================================}

procedure IntFileAdd(S: string);

   var  SE: string;     //[1]

   begin
   if UnitSystem and InterfaceSection then
   begin
      if InsideUsesClause then
         exit;
      if S = '' then
         begin
         writeln(INTFile, S);
         IntLineLength := 0;
         end
      else
         begin
         if IntLineLength + length(S) > 255 then
            begin
            IntLineLength:=0;
            SE := '';
            Writeln(INTFIle, SE);
            end;

         IntLineLength := IntLineLength + length(S);
         write(INTFile, S);
         end;
      end;
   end;

{==============================================================================}

procedure IntFileAddcr(S: string);

   begin
   if UnitSystem and InterfaceSection then
      begin
      if InsideUsesClause then
         exit;
      writeln(INTFile, S);
      IntLineLength := 0;
      end;
   end;

{==============================================================================}

function ReadFromSource (var S: string): boolean;                                //ss  short

   begin
   Result := true;
   repeat
      S := '';
      if SourceLineNumber >= PascalSource.Count then
         begin
         result := false;
         EndOfSourceFile := true;
         exit;
         end
      else
         begin
         S := PascalSource [SourceLineNumber];
         inc (SourceLineNumber);
         SourceBufferPtr := 1;
         end;
      until length (S) > 0;
   end;

{==============================================================================}

{function ReadFromSource (var S: string): boolean;                                //ss  short

   var  C: byte;
        Initial: boolean;

   begin
   S := '';
   Result := true;
   C := 0;
   Initial := true;

   while (C <> 13) and (C <> $1A) do
      begin
      if CharsInSourceBuffer = 0 then
         begin
         BlockRead(Source, SourceBuffer, 256, CharsInSourceBuffer);
         SourceBufferPtr:=0;
         end;

      if CharsInSourceBuffer = 0 then
         begin
         Result := false;
         EndOfSourceFile := true;
         exit;
         end;

      C := SourceBuffer [SourceBufferPtr];
      inc(SourceBufferPtr);
      dec(CharsInSourceBuffer);

      if Initial then
         begin
         Initial := false;
         if C = 10 then
            continue;
         end;

      if C > 127 then
         if C in [185,178,179] then
            continue;

      if (C <> 13) and (C <> $1A) then
         S := S + char(C);                //**

      if C = $1A then
         begin
         EndOfSourceFile := true;
         exit;
        end;
      end;
   end;

{==============================================================================}

function ReadFromInclude (var S: string): boolean;                               //ss  short

   var  C: byte;
        Initial: boolean;

   begin
   Result := true;
   with IncludeFile [CurrentIncludeFile] do
      repeat
         S := '';
         if IncludeLineNumber >= IncludeSource.Count then
            begin
            result := false;
            EndOfIncludeFile := true;
            exit;
            end
         else
            begin
            S := IncludeSource [IncludeLineNumber];
            inc (IncludeLineNumber);
            SourceBufferPtr := 1;
            end;
         until length (S) > 0;
   end;

{   S := '';
   Result := true;
   C := 0;
   Initial:=true;
   with IncludeFile[CurrentIncludeFile] do
      begin
      while C <> 13 do
         begin
         if CharsInIncludeBuffer = 0 then
            begin
            BlockRead(IFile, IncludeSourceBuffer, 256, CharsInIncludeBuffer);
            IncludeBufferPtr := 0;
            end;

         if (CharsInIncludeBuffer = 0) and (length(S) = 0) then
            begin
            Result := false;
            EndOfIncludeFile := true;
            exit;
            end;

         C := IncludeSourceBuffer[IncludeBufferPtr];
         inc(IncludeBufferPtr);
         dec(CharsInIncludeBuffer);
         if Initial then
            begin
            Initial := false;
            if C = 10 then
               continue;
            end;

         if C <> 13 then
            S := S + char(C);
         end;
      end;
   end;
 }
{==============================================================================}

procedure ShowErrorPosition(ErrorFile: string; ErrorLine: longint; CharacterCounter: byte);
var
  n: word;

  procedure ShowPos;
  begin
//    if length(EditList[n].Editor.Lines[ErrorLine])>CharacterCounter then
//      EditList[n].Editor.SelCol:=CharacterCounter else
//      EditList[n].Editor.SelCol:=0;
//    EditList[n].Editor.ScrollInView;
//    Editor.ShowEditor(n);
//    EditList[n].Editor.SetFocus;
   fmMainForm.SetCurrentPage (N);
   fmMainForm.ShowError (N, SourceLineNumber);
  end;

begin
  if RunningFromCommandLine then exit;
  ErrorFile:=Uppercase(ErrorFile);
  if ExtractFileExt(ErrorFile)='.RSL' then
  begin
    if FileExists(ChangeFileExt(ErrorFile,'.ASM')) then
    begin
      ErrorFile:=ChangeFileExt(ErrorFile,'.ASM');
    end else
    begin
      ShowMessage('Source file for "'+ErrorFile+'" not available. Cannot position error line');
      exit;
    end;
  end;

  N := fmMainForm.FileIsOpen (ErrorFile);
  if N > -1 then
     begin
     ShowPos;
     exit;
     end
  else
     begin
     ShowMessage ('Cannot position errir line in source file');
     exit;
     end;

{  for n:=0 to NumberOfEditItems-1 do
  begin
    if EditList[n].Used then
    begin
      if uppercase(EditList[n].FileName)=ErrorFile then
      begin
        if EditList[n].Editor.Lines.Count>ErrorLine then
        begin
          EditList[n].Editor.SelLine:=ErrorLine;
          ShowPos;
          exit;
        end else
        begin
          ShowMessage('Cannot position error line in source file');
          exit;
        end;
      end;
    end;
  end;
}
{  for n:=0 to NumberOfEditItems-1 do
  if not EditList[n].Used then
  begin
    EditList[n].FileName:=ErrorFile;
    EditList[n].Used:=true;
    Editor.CreateEditor(n);
    Editor.ShowEditor(n);
    if EditList[n].Editor.Lines.Count>ErrorLine then
    begin
      EditList[n].Editor.SelLine:=ErrorLine;
      ShowPos;
      exit;
    end else
    begin
      ShowMessage('Cannot position error line in source file');
      exit;
    end;
  end;
}
end;

{==============================================================================}

procedure CERROR( N : INTEGER );
(*
   write error on current line & add to TOT ERR
*)
   var  S, ErrorFile: string;                                                     // short
        C: word;
        Encrypted: boolean;

   begin
//   closeFile(Source);
   if UnitSystem and InterfaceSection then
      begin
      CloseFile(INTFile); InterfaceSection:=false;
      end;

   if CurrentIncludeFile > 0 then
      begin
      C := CurrentIncludeFile;
      while C > 0 do
         begin
         closeFile(IncludeFile[C].IFile);
         dec(C);
         end;
      end;

   if CurrentIncludeFile = 0 then
      ErrorFile := SourceFileName
   else
      begin
      ErrorFile := IncludeFile[CurrentIncludeFile].IncludeFileName;
      if ErrorFile = ExtractFilename(ErrorFile) then
         ErrorFile := ExtractFilePath(SourceFilename) + ErrorFile;
      end;

   if uppercase(ExtractFileExt(ErrorFile)) = '.EPS' then
      Encrypted := true
   else
      Encrypted := false;

   if CurrentIncludeFile = 0 then
      Status(SourceFileName)
   else
      Status(IncludeFile[CurrentIncludeFile].IncludeFileName);

   Status('');
   Status(LastLine);
   Status(CurrentLine);
   S := '';
   while length(S) < CharacterCounter do
      S := S + ' ';
   if length(S) > 2 then
      begin
      DecStringLength (S);
      DecStringLength (S);
      end;
//ss      dec(s[0]); dec(s[0]); end;
   Status (S + '^');
   if N = 126 then
      Status(ErrorMsg)
   else
      Status(Errors[N]);

   if not Encrypted then
      begin
      if CurrentIncludeFile = 0 then
         begin
         if ErrorLine > 0 then
            dec(ErrorLine);
         if CharacterCounter > 0 then
            dec(CharacterCounter);
         if Cmd = '' then
            ShowErrorPosition(ErrorFile,ErrorLine,CharacterCounter);
         ErrorStr := 'Error Line:'+IntToStr(ErrorLine)+' Column:'+IntToStr(CharacterCounter);
         end
      else
         begin
         if IncludeFile[CurrentIncludeFile].IncludeErrorLine > 0 then
            dec(IncludeFile[CurrentIncludeFile].IncludeErrorLine);
         if CharacterCounter > 0 then
            dec(CharacterCounter);
         if Cmd = '' then
            ShowErrorPosition(ErrorFile, IncludeFile[CurrentIncludeFile].IncludeErrorLine,CharacterCounter);
         ErrorStr := 'Error Line:'+IntToStr(ErrorLine)+' Column:'+IntToStr(CharacterCounter);
         end;
      end;

//   AssemblerStatus.show;
PrintTables;
   raise ECompileError.Create('Error Occured');
   end; { ERROR }


{==============================================================================}

procedure EndSkip;

   var  S: string;                                                                  //ss short

   begin
   S := '';
   while ERRPOS < CharacterCounter do
      begin
      S := S + ' ';
      ERRPOS := ERRPOS + 1;
      end;
   Status(s);
   SKIPFLAG := FALSE;
   end; { ENDSKIP }

(*--------------------------------------------------PRINTTABLES-----
   this procedure prints out the internal compiler and
   interpreter tables.  This procedure is called if the
   DEBUG flag is TRUE.
*)

procedure PRINTTABLES;
var I: INTEGER;
    TFile: TextFile;
begin
   AssignFile(TFile,ChangeFileExt(SourceFileName,'.TBL'));
   rewrite(TFile);
   writeln(TFile);
   writeln(TFile,' Identifiers         Link  Obj  Typ  Ref  NRM  Lev  Adr size  ptr  fld  blk ');
   for I := BlockTable[1].LAST +1 to IdTableIndex do
   with IdentifierTable[I] do
     writeln(TFile,I,' ',IdentifierNames[NAMELOOKUP]:15,LINK:5, ORD(OBJ):5, ORD(TYP):5, REF:5,
             ORD(NORMAL):5, LEV:5, ADR:5, Size:5, ptr: 5,ORD(Field):5, Block:5, ORD(Extern):5,
             ORD(GLOBAL):5, ORD(IsPointer):5);
   writeln(TFile,' Blocks    Last LPar PSze Vsze');
   for I := 1 to BlockTableIndex do with BlockTable[I] do
     writeln(TFile,I, LAST:5, LASTPAR:5, PSIZE:5, VSIZE:5);
   writeln(TFile);
   writeln(TFile,' Arrays    Xtyp Etyp Eref  Low High Elsz Size');
   for I := 1 to ArrayTableIndex do with ArrayTable[I] do
     writeln(TFile,I, ORD(INXTYP):5, ORD(ELTYP):5,
       ELREF:5, LOW:5, HIGH:5, ELSIZE:5, SIZE:5);
   writeln(TFile);
   CloseFile(TFile);
end; { PRINTTABLES }

(*--------------------------------------------------------FATAL-----*)

procedure FATAL;  (* internal table overflow *)

   var  S: string;                                                               //ss short

   begin
   S := ( 'Compiler table for ' );
      case N of
      1 : s:=s+( 'IDENTIFIER' );
      2 : s:=s+( 'PROCEDURES' );
      3 : s:=s+(      'REALS' );
      4 : s:=s+(     'ARRAYS' );
      5 : s:=s+(     'LEVELS' );
      6 : s:=s+(       'CODE' );
      7 : s:=s+(    'STRINGS' );
      end;

   S := S+( ' overflowed' );
   Status(S);
   Status(' Fatal termination of Embedded Pascal');
//   AssemblerStatus.show;
   raise ECompileError.Create('Error Occured');
   end; { FATAL }

{==============================================================================}
(*-------------------------------------------------------NEXTCH-----*)

procedure ReadNextCharFromSource;   (* read next char; process line end *)

   label  NextChar, GT1, Again;

   begin
   if InsideUsesClause then
      begin
Again:
      while not ReadingFromUnit and (ReadingUnitNumber < LinkProject.Count) do
         begin
         IncludeUnit(LinkProject[ReadingUnitNumber]);                             // LinkProject = TstringList
         inc(ReadingUnitNumber);
         end;

      if not ReadingFromUnit then
         begin
         InsideUsesClause := false;
         DynamicVars := OldDynamicVars;
         PointerBend := OldPointerBend;
         end;
     end;

// If string ParserLookAhead not empty then LastCharFromSouce = first char
// in ParserLookAhead. Delete first char in ParserLookAhead.

   if ParserLookAhead <> '' then
      begin
      LastCharFromSource := ParserLookAhead [1];                                  // ParserLookAhead = srring
//      ParserLookAhead := copy(ParserLookAhead, 2, 255);                           //ff
      delete (ParserLookAhead, 1, 1);
      exit;
      end;

NextChar:
   if CharacterCounter = LineLength then
      begin
      if FirstEOL then
         begin
         LastCharFromSource := ' ';
         FirstEOL := false;
         exit;
         end;

   FirstEOL := true;
   if LineLength > 0 then
      if IncludePas then
         AO (';' + CurrentLine);                                                  // CurrentLine = string

   if CurrentIncludeFile = 0 then
      begin
      if EndOfSourceFile then
         begin
         if ConditionalSkip then
            CError(102)
         else
            CError(103);
         end;
      end
   else
      begin
      if IncludeFile[CurrentIncludeFile].EndOfIncludeFile then
         begin
         AO('; End of include file ' + IncludeFile[CurrentIncludeFile].Includefilename);
//         closeFile(IncludeFile[CurrentIncludeFile].IFile);
         ReadingFromUnit := false;
         dec(CurrentIncludeFile);
         LastLineNumber := $FFFFFFF;
         if CurrentIncludeFile = 0 then
            ASMFileSpec(SourceFileName)
         else
            ASMFileSpec(IncludeFile[CurrentIncludeFile].IncludeFilename);
         if InsideUsesClause then
            goto again;
         end;
      end;

   if ERRPOS <> 0 then
      begin
      if SKIPFLAG then
         endSKIP;
      ERRPOS := 0;
      end;

   if CurrentIncludeFile = 0 then
      inc (LineCount);
   CharacterCounter := 0;
   LineLength:=0;
   if CurrentIncludeFile = 0 then
      begin
      while (LineLength=0) and (not EndOfSourceFile) do
         begin
         LastLine := CurrentLine;
         if ReadFromSource (CurrentLine) then
        begin
         if length (CurrentLine) = 0 then
            ERRPOS := 0;
             LineLength:=length(CurrentLine);
          inc(TotalLines);
          inc(ErrorLine);
          if TotalLines mod 10=0 then
          begin
            fmMainForm.ShowCompilerStatus (FileBeingCompiled, TotalLines);
//            CompilerStatus.Edit2.Text:=IntToStr(TotalLines);
            Application.ProcessMessages;
          end;
        end;
      end;
    end else
    begin
      while (LineLength=0) and (not IncludeFile[CurrentIncludeFile].EndOfIncludeFile) do
      begin
        LastLine:=CurrentLine;
        if ReadFromInclude(CurrentLine) then
        begin
          LineLength:=length(CurrentLine);
          inc(TotalLines);
          inc(IncludeFile[CurrentIncludeFile].IncludeErrorLine);
          if TotalLines mod 10=0 then
          begin
            fmMainForm.ShowCompilerStatus (FileBeingCompiled, TotalLines);
//            CompilerStatus.Edit2.Text:=IntToStr(TotalLines);
            Application.ProcessMessages;
          end;
        end;
      end;
      if IncludeFile[CurrentIncludeFile].EndOfIncludeFile then
      begin
        FileBeingCompiled := ExtractFilename (SourceFilename);
        fmMainForm.ShowCompilerStatus (FileBeingCompiled, TotalLines);
//        CompilerStatus.Edit1.Text:=ExtractFilename(SourceFilename);
        CharacterCounter:=0;
        LineLength:=0;
        goto nextchar;
      end;
    end;
  end;
  CharacterCounter := CharacterCounter+1;
//  if CharacterCounter <= length (CurrentLine) then
     begin
     LastCharFromSource := CurrentLine[CharacterCounter];
     if LastCharFromSource=#9 then LastCharFromSource:=' ';
     if LastCharFromSource < ' ' then CERROR(60)
     end;
end;

{==============================================================================}

procedure ReadToEndOfLine;

   begin
   CharacterCounter := length(CurrentLine);
   end;

{==============================================================================}

procedure Compile;

   var  IsStubProcedure: boolean;
        Dummy: word;

   begin { COMPILE }

(*
   =============================
     check for program heading
   =============================
*)

   DoInitialize;
   GetNextSymbol;
   CodeLinkAddress := $10000000;
   DataLinkAddress := $10000000;
   CodeLoadAddress := $10000000;

   if LastSymbol = IDENT then
      begin
      if Identifier = 'LINK' then
         begin
         GetNextSymbol;
         if LastSymbol in [BYTECON,WORDCON,LINTCON] then
            begin
            CodeLinkAddress:=IntegerNumeric;
            end
         else
            if Identifier = 'CODEADD' then
               CodeLinkAddress := $10000001
            else
               CError(93);
         GetNextSymbol;
         if LastSymbol<>COMMA then
            CError(78);
         GetNextSymbol;
         if LastSymbol in [BYTECON,WORDCON,LINTCON] then
            begin
            DataLinkAddress:=IntegerNumeric;
            end
         else if Identifier='DATAADD' then
            DataLinkAddress:=$10000001
         else
            CError(94);

         GetNextSymbol;
         if LastSymbol=COMMA then
            begin
            GetNextSymbol;
            if LastSymbol in [BYTECON,WORDCON,LINTCON] then
               begin
               CodeLoadAddress:=IntegerNumeric;
               end
            else
              CError(94);
            GetNextSymbol;
            end;
         end;
      end;

  ConstPlacement:=$FFFFFF;
  if LastSymbol=IDENT then
  begin
    if Identifier='PLACECONST' then
    begin
      GetNextSymbol;
      if LastSymbol in [BYTECON,WORDCON,INTCON,LINTCON] then
      begin
        ConstPlacement:=IntegerNumeric;
      end else CError(25);
      GetNextSymbol;
    end else CError(20);
  end;
  if (LastSymbol <> PROCSY) and (LastSymbol <>PROGRAMSY) and (LastSymbol<>UNITSY) then CERROR(3);
  UnitSystem:=LastSymbol=UNITSY;
  GetNextSymbol;
  if LastSymbol <> IDENT then CERROR(2);
  ProgramName := Identifier;
  if UnitSystem then
  begin
    if uppercase(Identifier)<>uppercase(ChangeFileExt(FileBeingCompiled, '')) then //CompilerStatus.Edit1.Text,'')) then
    begin
      ErrorMsg:='Unit name must be same as filename';
      CError(126);
    end;
    ProgramNameInLabel:=false;
  end;
  GlobalsAdd('@'+ProgramName);
  ExternalAdd('HeapPtr');
  ExternalAdd ('_ADRCache_');
  GetNextSymbol;
  if LastSymbol<>SEMICOLON then CError(14);

  EnterStandardFunctions;

  with BlockTable[1] do
  begin
   LAST := IdTableIndex;
   LASTPAR := 1;
   PSIZE := 0;
   VSIZE := 0
  end;

  if ConstPlacement=$FFFFFF then
  begin
    LevelForParser:=1;
    ConstPlacement:=FindLocation('_CONSTSECTIONADDR');
    if ConstPlacement=0 then ConstPlacement:=$FFFFFF else
    ConstPlacement:=IdentifierTable[ConstPlacement].address;
  end;
  //EnterPascalIODefs;

(*
   ============
     COMPILE
   ============
*)
  if ConstPlacement<$20000 then
     begin
     if not UnitSystem then
        begin
        AT0('CONST 0'+IntToHex(ConstPlacement,4)+'H');
        AT0('CODESP');
        end;
     end
  else
     AT0('CODE');
  IsStubProcedure:=false;
  ASMFileSpec(SourceFileName);
  StackEstimate:=0;
  block( BLOCKBEGSYS+STATBEGSYS, FALSE, 1 ,IsStubProcedure, 0, Dummy);
  if (LastSymbol <> PERIOD) and (LastSymbol<>SEMICOLON) then CERROR(22);
  {if DEBUG then} PRINTTABLES;
end; { COMPILE }


{==============================================================================}

procedure InitCompiler;

   var  I:  integer;

   begin
   CancelCompile := false;
   TotalLines := 0;
   PascalSource.Clear;
   SourceLineNumber := 0;
   EndOfSourceFile := false;

   for I := 1 to SizeOfBlockTable do
      begin
      BlockTable[I].Last := 0;
      BlockTable[I].LastPar := 0;
      BlockTable[I].PSize := 0;
      BlockTable[I].VSize := 0;
      end;
   end;

{==============================================================================}

procedure RunPascalCompiler(Filename: string; Editor: word; var CS, DS: longint);

   var  SX: string;

   begin
   SourceFileName := Filename;
   FileBeingCompiled := ExtractFilename (Filename);
   fmMainForm.ShowCompilerStatus (FileBeingCompiled, 0);
//   CompilerStatus.Edit1.Text := ExtractFilename (Filename);
//   CompilerStatus.Edit2.Text := '0';
//   if uppercase (ExtractFileExt(S)) = '.EPS' then
//      SourceEncrypted := true
//   else
//      SourceEncrypted := false;
   InitCompiler;
   PascalSource.LoadFromFile (Filename);
//   assignFile (SOURCE, Filename);
   CharsInSourceBuffer := 0;

{$I-}
//   FileMode := 0;
//   reset (SOURCE, 1);
//   Key := 23874;
//   FileMode := 2;
{$I+}

//   if IOresult <> 0 then
//      begin
//      Status ('Cannot find file : ' + Filename );
//      end
//   else
      begin
      Status ('   ' + HEADER);
      debug := true;
      COMPILE;
      if UnitSystem and InterfaceSection then
         closeFile(INTFile);
//      closeFile (Source);
      if AsmOutput.Count > 0 then
         Optimizer;
      if CodeLinkAddress <> $10000000 then
         begin
         if CodeLinkAddress < $20000 then
            SX := '0' + IntToHex($1FFFF and CodeLinkAddress, 4) + 'H,'
         else
            SX:='CODEADD,';

         if DataLinkAddress < $10000 then
            SX := SX + '0' + IntToHex($FFFF and DataLinkAddress, 4) + 'H'
         else
            SX := SX + 'DATAADD';
      {if CodeLoadAddress<>$20000 then
        sx:=sx+',0'+IntToHex($1FFFF and CodeLoadAddress,4)+'H'; }
         AsmOutput.Insert (0, #9+'Link ' + SX);
         end;

      AddMemoryReferences;
      AddGlobalReferences;
      AddExternalReferences;
      if AsmOutput.Count > 0 then
         AsmOutput.SaveToFile (ChangeFileExt (Filename, '.ASM'));
      CS := CodeSize;
      DS := DataSize;
      AsmOutput.Clear;
      end;

   PrintTables;
   end;

end.


