unit EditorOptions_U;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtCtrls, EditorDefs, Vcl.StdCtrls,
  SynEditHighlighter, SynHighlighterPas, SynEdit, Vcl.Buttons;

type
  TEditorOptions = class(TForm)
    ColorDialog: TColorDialog;
    SynEdit1: TSynEdit;
    ListBox1: TListBox;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    FontDialog1: TFontDialog;
    btnFont: TButton;
    procedure FormCreate(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure btnFontClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    NewFont:   TFont;

    { Private declarations }
  public

  end;

var
  EditorOptions: TEditorOptions;

implementation

uses MainForm;

{$R *.dfm}

{==============================================================================}

procedure TEditorOptions.FormCreate(Sender: TObject);

   begin
   SynEdit1.Highlighter := fmMainForm.SynPascal;
   SynEdit1.Lines.Clear;
   SynEdit1.Lines.Add ('{ Syntax Highlighting }');
   SynEdit1.Lines.Add ('procedure SendMessage (S: string');
   SynEdit1.Lines.Add (' ');
   SynEdit1.Lines.Add ('   var  I, X:  integer');
   SynEdit1.Lines.Add (' ');
   SynEdit1.Lines.Add ('   begin');
   SynEdit1.Lines.Add ('   Number := 123 + $FF + round(356.2)');
   SynEdit1.Lines.Add ('   S := ''C''');
   SynEdit1.Lines.Add ('   S := ''Msg number is '' + IntToStr (I)');
   SynEdit1.Lines.Add ('   for I := 1 to 10 do');
   SynEdit1.Lines.Add ('      inc (X)');
   SynEdit1.Lines.Add ('{$IFDEFINED A85}');
   SynEdit1.Lines.Add ('   asm');
   SynEdit1.Lines.Add ('      push R31');
   SynEdit1.Lines.Add ('      ret');
   SynEdit1.Lines.Add ('   end');
   NewFont := nil;
   end;

procedure TEditorOptions.FormShow(Sender: TObject);

   begin
   SynEdit1.Color := BackgroundColor;
   SynEdit1.Font := EditorFont;
   end;

{==============================================================================}

procedure TEditorOptions.ListBox1Click(Sender: TObject);

   procedure SetAttriColor (Attr: TSynHighlighterAttributes);

      begin
      if ColorDialog.Execute then
         begin
         Attr.Foreground := ColorDialog.Color;
//         EditorColors [ListBox1.ItemIndex] := ColorDialog.Color;
         end;
      end;

{===================}

   begin
   with fmMainForm.SynPascal do
      case ListBox1.ItemIndex of
         0: SetAttriColor (AsmAttri);
         1: SetAttriColor (CharAttri);
         2: SetAttriColor (CommentAttri);
         3: SetAttriColor (DirectiveAttri);
         4: SetAttriColor (FloatAttri);
         5: SetAttriColor (HexAttri);
         6: SetAttriColor (IdentifierAttri);
         7: SetAttriColor (KeyAttri);
         8: SetAttriColor (NumberAttri);
         9: SetAttriColor (StringAttri);
         10: SetAttriColor (SymbolAttri);
         11: if ColorDialog.Execute then
                begin
                BackgroundColor := ColorDialog.Color;
                SynEdit1.Color := BackgroundColor;
                end;
         end;
   end;


procedure TEditorOptions.btnFontClick(Sender: TObject);

   begin
   FontDialog1.Options := [fdAnsiOnly, fdWysiwyg, fdTrueTypeOnly];
   FontDialog1.Font := SynEdit1.Font;
   if FontDialog1.Execute then
      begin
      EditorFont := FontDialog1.Font;
      SynEdit1.Font := EditorFont;
      end;
   end;

{==============================================================================}

end.
