unit MainForm;

interface

uses
  Winapi.Windows, Winapi.Messages, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.Menus, SynEdit, Vcl.ComCtrls, Contnrs, EditorFrame,
  SynEditHighlighter, SynHighlighterPas, SynEditMiscClasses, SynEditSearch,
  SynEditOptionsDialog, Vcl.ToolWin, Vcl.StdCtrls, Vcl.ExtCtrls, VrControls,
  VrArrow, SynEditTypes, EditorDefs, PascalDefs, SynEditRegexSearch,
  System.Actions, Vcl.ActnList, System.ImageList, Vcl.ImgList, Vcl.Buttons,
  Vcl.PlatformDefaultStyleActnCtrls, Vcl.ActnMan, Vcl.Styles, Vcl.Themes;

const
   MaxEditors = 50;

type
   PSynEdit = ^TSynEdit;
   PEditorTabsheet = ^TEditorTabsheet;
   TEditorTabsheet = class (TTabsheet)
      protected
      Editor:   TfmEditorFrame;
      end;

type
   TEditorPages = class (TPageControl)
      protected
      Pages:  TEditorTabsheet;
      end;

  type
  TfmMainForm = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    New1: TMenuItem;
    Open1: TMenuItem;
    Save1: TMenuItem;
    OpenDialog: TOpenDialog;
    SynPascal: TSynPasSyn;
    Edit1: TMenuItem;
    Find1: TMenuItem;
    StatusBar: TStatusBar;
    SynEditOptionsDialog1: TSynEditOptionsDialog;
    N2: TMenuItem;
    Cut1: TMenuItem;
    Copy1: TMenuItem;
    Paste1: TMenuItem;
    Project1: TMenuItem;
    ools2: TMenuItem;
    Editor1: TMenuItem;
    Close1: TMenuItem;
    CloseAll1: TMenuItem;
    SaveAs1: TMenuItem;
    SaveDialog: TSaveDialog;
    FindandReplace1: TMenuItem;
    SearchDlg: TSynEditOptionsDialog;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    OpenProject2: TMenuItem;
    OpenProject3: TMenuItem;
    SaveProject2: TMenuItem;
    ToolButton3: TToolButton;
    EditorActions: TActionList;
    acOpenFile: TAction;
    acNewFile: TAction;
    acSaveFile: TAction;
    acCompileFile: TAction;
    CompileFile1: TMenuItem;
    acBuildProject: TAction;
    BuildProject1: TMenuItem;
    SaveProjectAs2: TMenuItem;
    N5: TMenuItem;
    acSaveFileAs: TAction;
    acCloseFile: TAction;
    acCloseAll: TAction;
    MessagePanel: TPanel;
    Splitter1: TSplitter;
    SearchToolBar: TToolBar;
    SearchPanel: TPanel;
    arwForward: TVrArrow;
    arwBackward: TVrArrow;
    bbFind: TButton;
    ebSearch: TEdit;
    Label1: TLabel;
    cbWholeWords: TCheckBox;
    cbMatchCase: TCheckBox;
    cbSelectionOnly: TCheckBox;
    cbEntireScope: TCheckBox;
    Label2: TLabel;
    ebReplace: TEdit;
    bbReplace: TButton;
    bbReplaceAll: TButton;
    MessageMemo: TMemo;
    ModePages: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    EditorPages: TPageControl;
    GroupBox1: TGroupBox;
    Panel1: TPanel;
    Label4: TLabel;
    Label7: TLabel;
    Label5: TLabel;
    edProjectName: TEdit;
    ebCpuType: TEdit;
    edProjectPath: TEdit;
    Panel2: TPanel;
    FileListBox: TListBox;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    GroupBox2: TGroupBox;
    cbTiny: TCheckBox;
    cbLowStructures: TCheckBox;
    cbSmallStack: TCheckBox;
    cbHasMult: TCheckBox;
    cbHasFarCall: TCheckBox;
    cbROM4K: TCheckBox;
    cbSwapBytes: TCheckBox;
    cbNoConst: TCheckBox;
    Label3: TLabel;
    cbCpuType: TComboBox;
    GroupBox3: TGroupBox;
    cbIncludePascal: TCheckBox;
    cbWriteSym: TCheckBox;
    cbCOFFEnabled: TCheckBox;
    cbObjEnabled: TCheckBox;
    GroupBox4: TGroupBox;
    cbStyles: TComboBox;
    ImageList1: TImageList;
    acSaveAll: TAction;
    SaveAllFiles1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    ToolButton4: TToolButton;
    acCut: TAction;
    ToolButton5: TToolButton;
    acCopy: TAction;
    ToolButton6: TToolButton;
    acPaste: TAction;
    ToolButton7: TToolButton;
    N3: TMenuItem;
    ProjectMainFile1: TMenuItem;
    CloseProject1: TMenuItem;
    acFindText: TAction;
    acReplace: TAction;
    acNewProject: TAction;
    acOpenProject: TAction;
    acSaveProject: TAction;
    acSaveProjectAs: TAction;
    acCloseProject: TAction;
    Action1: TAction;
    SampleSynEdit: TSynEdit;
    ebMainFile: TEdit;
    ebOutputFile: TEdit;
    Label6: TLabel;
    Label8: TLabel;

    procedure NewFile1Click(Sender: TObject);
    procedure OpenFile1Click(Sender: TObject);
    procedure SaveFile1Click(Sender: TObject);
    procedure SaveFileAs1Click(Sender: TObject);
    procedure SaveAllFiles1Click(Sender: TObject);
    procedure CloseFile1Click(Sender: TObject);
    procedure CloseAllFiles1Click(Sender: TObject);

    procedure SaveProject1Click (Sender: TObject);
    procedure Mainfile1Click(Sender: TObject);

    procedure FormCreate(Sender: TObject);
    procedure Editor1Click(Sender: TObject);
    procedure arwForwardClick(Sender: TObject);
    procedure cbMatchCaseClick(Sender: TObject);
    procedure cbWholeWordsClick(Sender: TObject);
    procedure cbSelectionOnlyClick(Sender: TObject);
    procedure cbEntireScopeClick(Sender: TObject);
    procedure arwBackwardClick(Sender: TObject);
    procedure cbSearchTextKeyPress(Sender: TObject; var Key: Char);
    procedure Find1Click(Sender: TObject);
    procedure FindNext1Click(Sender: TObject);
    procedure Cut1Click(Sender: TObject);
    procedure Copy1Click(Sender: TObject);
    procedure Paste1Click(Sender: TObject);
    procedure FindandReplace1Click(Sender: TObject);
    procedure ebSearchKeyPress(Sender: TObject; var Key: Char);
    procedure bbFindClick(Sender: TObject);
    procedure CompileCurrentBtnClick(Sender: TObject);
    procedure BuildAllBtnClick(Sender: TObject);
    procedure EditorPagesChange(Sender: TObject);
    procedure bbReplaceClick(Sender: TObject);
    procedure bbReplaceAllClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure CloseCurrentProject (Sender: TObject);
    procedure NewProject1Click(Sender: TObject);
    procedure SaveProjectAs1Click(Sender: TObject);
    procedure OpenProject1Click(Sender: TObject);
    procedure AddToProject1Click(Sender: TObject);
    procedure RemoveFromProject1Click(Sender: TObject);
    procedure MoveFileUp (Sender: TObject);
    procedure MoveFileDown (Sender: TObject);
    procedure FileListBoxDblClick(Sender: TObject);
    procedure cbStylesChange(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure cbCpuTypeChange(Sender: TObject);

  private
    { Private declarations }
    SearchOptions:  TSynSearchOptions;

    function CurrentEditor: TfmEditorFrame;

    procedure LoadHighlighterColors;
    procedure SaveHighlighterColors;
    procedure ShowProjectDetails;
    procedure LoadOptions;

  public
    { Public declarations }
    function NewEditor (Filename: string; Line: word; EditAction: TEditorAction): boolean;
    function FileIsOpen (S: string): integer;
    procedure LoadLastProject;
    procedure LoadProject(ProjectFilename: String; ShowEditor: boolean);

    procedure ShowFileModified (Modified: boolean);
    procedure SetCurrentPage (P: integer);
    procedure ShowError (Page, Line: integer);
    procedure AddMessage (S: string);
    procedure ShowCompilerStatus (Filename: string; Lines: integer);

  end;

const
   prjName = 0;
   prjPath = 1;
   prjFileStart = 4;
   FormTitle = 'AVR Pascal 3.0.1b';

var
  fmMainForm: TfmMainForm;

implementation

{$R *.dfm}

uses IniFiles,EditorOptions_U, AsmDefs, AsmStatus, Compiler, SysUtils;


{==============================================================================}
{==============================================================================}
{==============================================================================}
{                          EXTERNAL INTERFACE                                  }
{==============================================================================}
{==============================================================================}
{==============================================================================}

procedure TfmMainForm.ShowFileModified (Modified: boolean);

   begin
   if Modified then
      StatusBar.Panels [1].Text := 'Modified'
   else
      StatusBar.Panels [1].Text := '';
   end;

{==============================================================================}

procedure TfmMainForm.SetCurrentPage (P: integer);

   begin
   if EditorPages.PageCount > P then
      EditorPages.ActivePageIndex := P;
   end;

{==============================================================================}

procedure TfmMainForm.ShowError (Page, Line: integer);

   var  C, D:  integer;

   begin
   MainFilename := '';
   SetCurrentPage (Page);
   D := CurrentEditor.LinesDisplayed div 2;
   if CurrentEditor.LineCount > Line + D then
      CurrentEditor.SetCaretPosition (1, Line + D)
   else
      CurrentEditor.SetCaretPosition (1, CurrentEditor.LineCount);
   CurrentEditor.HighlightLine (Line);
   Show;
   end;

{==============================================================================}

procedure TfmMainForm.ShowCompilerStatus (Filename: string; Lines: integer);

   begin
   StatusBar.Panels [3].Text := 'Compiling ' + Filename + ': ' + IntToStr (Lines);
   end;

{==============================================================================}

procedure TfmMainForm.AddMessage (S: string);

   begin
   MessageMemo.Lines.Add (S);
   end;

{==============================================================================}
{==============================================================================}
{==============================================================================}
{                              FORM FUNCTIONS                                  }
{==============================================================================}
{==============================================================================}
{==============================================================================}

procedure TfmMainForm.FormCreate(Sender: TObject);

   type TAStr = array of string;

   var  IniFile:  TIniFile;
        FileList: TStringList;
        I:        integer;
        S: string;
        WDir: array[0..255] of char;
        Found:  integer;
        SearchRec:  TSearchRec;
        StyleList:  TAstr;

   begin
   ExePath := ExtractFilePath (Application.ExeName);
   S := ExePath + 'Lib';
   if not SysUtils.DirectoryExists (S) then
      try
      MkDir (S);
      except
      end;

   S := ExePath + 'Default';
   if not SysUtils.DirectoryExists (S) then
      try
      MkDir (S);
      except
      end;

   Found := FindFirst(ExePath + 'Styles\*.vsf', 0, SearchRec);
   while Found = 0 do
      begin
      if TStyleManager.IsValidStyle (ExePath + 'Styles\' + SearchRec.Name) then
         TStyleManager.LoadFromFile (ExePath + 'Styles\' + SearchRec.Name);
      Found := FindNext(SearchRec);
      end;

   cbStyles.Items.Clear;
   StyleList := TAStr (TStyleManager.Stylenames);
   for I := 0 to length (StyleList) do
      cbStyles.Items.Add (StyleList [I]);
   cbStyles.Sorted := true;

   BufferSize := 2048;
   Application.HelpFile := ExePath + 'EPascal.hlp';
   Application.Icon := Icon;
   MsList := TStringList.Create;
   Project := TStringList.Create;
   IdentifierNames := TStringList.Create;
   Includes := TStringList.Create;
   MacroArguments := TStringList.Create;
   MacroCall := TStringList.Create;
   Global := TStringList.Create;
   Global.Sorted := true;
   RunWhenDoneFiles := TStringList.Create;
   AsmOutput := TStringlist.Create;
   AsmConstList := TStringlist.Create;
   Externals := TStringlist.Create;
   StringConstants := TStringList.Create; //special
   Globals := TStringList.Create;
   ALabels := TStringList.Create;
   Forwards := TStringList.Create;
   AssemblerSource := TStringList.Create;
   InfoList := TStringList.Create;
   ReferenceList := TStringList.Create;
   ReferenceList.Sorted:=true;
   for I := 1 to NumberOfIncludeFiles do
      IncludeFile [I].IncludeSource := TStringList.Create;
   StringConstantsUsed := TStringList.Create;   //special
   PointerForwards := TStringList.Create;
   SourceFiles := TStringList.Create;
   RegsUsed := TStringList.Create;
   RegsUsed.Sorted:=true;
   KeywordList := TStringList.Create;
   KeywordList.Sorted := true;
   OpLines := TStringList.Create;
   LinkProject := TStringList.Create;
   PascalSource := TStringList.Create;

   PgmIniFilename := ExePath + 'AVRPascal.ini';
   IniFile := TIniFile.Create(PgmIniFilename);
   Project.Add(IniFile.ReadString('General', 'LastProject', 'Project1'));
   Project.Add(IniFile.ReadString('General', 'LastPath', ExePath));
   Width := IniFile.ReadInteger('Main', 'Width', 900);
   Height := IniFile.ReadInteger('Main', 'Height', 800);
   Top := IniFile.ReadInteger('Main', 'Top', Screen.Height div 2 - Height div 2);
   Left := IniFile.ReadInteger('Main', 'Left', Screen.Width div 2 - width div 2);
   if Width < 900 then Width := 900;
   if Height < 800 then Height := 800;
   FontName := IniFile.ReadString('PrinterFont', 'Name', 'Arial');
   FontSize:=IniFile.ReadInteger('PrinterFont', 'Size', 10);
   S := IniFile.ReadString ('General', 'Style', 'NoStyle');
   IniFile.Free;

   BufferSize := 32*1024;
   RunningFromCommandline := false;
   GetMem(Buffer, BufferSize);
   FileListBox.Items.Assign(Project);
   GetWindowsDirectory(@wdir,250);
   FreeMem(Buffer,BufferSize);
   BufferSize := 250 * 1024;
   GetMem(Buffer, BufferSize);
   for I := 1 to NumberOfKeywords do
      KeywordList.Add (Keywords [I]);
   for I := 0 to NumberOfMnemonics - 1 do
      MsList.Add (Ms [I]);

   SearchOptions := [];
   arwForward.Active := true;
   arwBackward.Active := false;
   EditorPages.ActivePage := nil;
   OpenDialog.InitialDir := ExePath;
   SaveDialog.InitialDir := ExePath;
   if Project [prjPath] <> '' then
      begin
      OpenDialog.InitialDir := Project [prjPath];
      SaveDialog.InitialDir := Project [prjPath];
      end;
   LoadHighlighterColors;
   MessageMemo.Clear;
   Caption := FormTitle;

   cbCpuType.Items.Clear;
   Found := FindFirst(ExePath + 'Lib\*.inc', 0, SearchRec);
   while Found = 0 do
      begin
      cbCpuType.Items.Add(SearchRec.Name);
      Found := FindNext(SearchRec);
      end;

   FindClose(SearchRec);
   if S <> 'NoStyle' then
   try
      tStyleManager.SetStyle (S);
      cbStyles.ItemIndex := cbStyles.Items.IndexOf (S);
      except;
      end;
   end;

{==============================================================================}

procedure TfmMainForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);

   var
     IniFile: TIniFile;
     I,C,CI: word;
     IniFilename: string;

   begin
   IniFilename := ExePath + 'AVRPascal.ini';
   IniFile:=TIniFile.Create(IniFilename);
   IniFile.WriteString('General','LastProject',Project[prjName]);
   IniFile.WriteString('General','LastPath',Project[prjPath]);
   IniFile.WriteString ('General', 'Style', TStyleManager.ActiveStyle.Name);
   IniFile.WriteInteger('Main','Top',Top);
   IniFile.WriteInteger('Main','Left',Left);
   IniFile.WriteInteger('Main','Height',Height);
   IniFile.WriteInteger('Main','Width',Width);
   IniFile.WriteString('PrinterFont','Name',FontName);
   IniFile.WriteInteger('PrinterFont','Size',FontSize);

   I := 1;
   C := Project.Count;
   CI := ProjectFileStart;
   while CI < C do
      begin
      IniFile.WriteString('Sources', 'Source' + IntToStr(i), Project[ci]);
      inc(I);
      inc(CI);
      end;

   IniFile.WriteString('Sources', 'Source'+IntToStr(I), 'Undefined');
   I := 0;
   while (I < NumberOfEditItems) and (EditList[i].Used) do
  begin
    IniFile.WriteString('Editor','Source'+IntToStr(i+1),EditList[i].FileName);
    inc(i);
  end;
  IniFile.WriteString('Editor','Source'+IntToStr(i+1),'Undefined');
  IniFile.Free;
  SaveProject1Click (nil);
  CloseAllFiles1Click (nil);

  Globals.Free;
end;

{==============================================================================}

procedure TfmMainForm.cbStylesChange(Sender: TObject);

   var  S:  string;
        StyleName:  string;

   begin
   try
      TStyleManager.SetStyle (cbStyles.Items [cbStyles.ItemIndex]);
      except;
      end;
   end;

{==============================================================================}

procedure TfmMainForm.Exit1Click(Sender: TObject);

   begin
   Close;
   end;

{==============================================================================}
{==============================================================================}
{==============================================================================}
{                           PROJECT MANAGEMENT                                 }
{==============================================================================}
{==============================================================================}
{==============================================================================}

procedure TfmMainForm.NewProject1Click(Sender: TObject);

   begin
   CloseCurrentProject (nil);
   Project.Clear;
   Project.Add('Project1');
   Project.Add(ExePath);
   Project.Add('No target device');
   Project.Add('AVR');
   SmallStack:=false;
   LowStructures:=false;
   HasMult:=false;
   Tiny:=false;
   HasFarCall:=false;
   ROM4K:=false;
   SwapBytes:=false;
   MainFilename:='';
   FileListBox.Items.clear;
   edProjectName.Text := Project[prjName];
   ebCpuType.Text:=Project[2];
   edProjectPath.Text:=Project[prjPath];
   ProjectChanged:=false;
   SaveDialog.Filename := 'NewProject.prj';
   SaveDialog.InitialDir := ExePath;
   SaveDialog.Filter := 'AVR Pascal Project *.prj|*.prj';

   if SaveDialog.Execute then
      begin
      if FileExists(SaveDialog.Filename) then
         if MessageDlg('Project file exists. Overwrite ?',mtConfirmation,[mbYes,mbNo],0) = mrNo then
            exit;

      Project[0]:=ExtractFileName(ChangeFileExt(SaveDialog.FileName,''));
      Project[1]:=ExtractFilePath(SaveDialog.Filename);
      FileListBox.Items.Assign(Project);
      ShowProjectDetails;
      SaveProject1Click (nil);
      end;
   end;

{==============================================================================}

procedure TfmMainForm.OpenProject1Click(Sender: TObject);

   begin
   OpenDialog.Filter := 'AVR Pascal Project (*.prj)|*.prj';
   if OpenDialog.Execute then
      begin
      CloseCurrentProject (nil);
      LoadProject(OpenDialog.FileName,true);
      ShowProjectDetails;
      ProjectChanged:=false;
      end;
   end;

{==============================================================================}

procedure TfmMainForm.SaveProject1Click (Sender: TObject);

   var  IniFile: TIniFile;
        I, C, CI, Line: word;
        S, IniFilename:  string;

   begin
{$I+}
   try
      SaveAllFiles1Click (nil);
      IniFilename := Project[prjPath]+Project[prjName]+'.Prj';
      IniFile := TIniFile.Create (IniFilename);
      IniFile.WriteInteger('General', 'Target', 0);
      IniFile.WriteString('General', 'CPU', cbCpuType.Items [cbCpuType.ItemIndex]);
      IniFile.WriteBool('General', 'IncludePAS', cbIncludePascal.Checked);
      IniFile.WriteBool('General', 'WriteSym', cbWriteSym.Checked);
      IniFile.WriteBool('General', 'Tiny', cbTiny.Checked);
      IniFile.WriteBool('General', 'LowStructures', cbLowStructures.Checked);
      IniFile.WriteBool('General', 'SmallStack', cbSmallStack.Checked);
      IniFile.WriteBool('General', 'HasMult', cbHasMult.CHecked);
      IniFile.WriteBool('General', 'HasFarCall', cbHasFarCall.Checked);
      IniFile.WriteBool('General', 'ROM4K', cbROM4K.Checked);
      IniFile.WriteBool('General', 'SwapBytes', cbSwapBytes.CHecked);
      IniFile.WriteBool('General', 'AutoIndent', INIAutoIndent);
      IniFile.WriteBool('General', 'NoConst', cbNoConst.Checked);
      IniFile.WriteBool('General', 'COFFEnabled', cbCOFFEnabled.Checked);
      IniFile.WriteBool('General', 'OBJEnabled', cbOBJEnabled.Checked);
      IniFile.WriteString('General', 'MainFileName', MainFilename);
      IniFile.WriteString ('General', 'OutputFile', ebOutputFile.Text);

      I := 1;
      C := Project.Count;
      CI := ProjectFileStart;
      while CI < C do
         begin
         IniFile.WriteString('Sources', 'Source'+IntToStr(I), Project[CI]);
         inc(I);
         inc(CI);
         end;
      IniFile.WriteString('Sources', 'Source'+IntToStr(I), 'Undefined');
      except
         ShowMessage('Cannot write to '+Project[1]+Project[0]+'.Prj');
      end;

   if EditorPages.PageCount > 0 then
      begin
      for I := 0 to EditorPages.PageCount - 1 do
         begin
         S := (EditorPages.Pages [I] as TEditorTabsheet).Editor.GetFilename;
         Line := (EditorPages.Pages [I] as TEditorTabsheet).Editor.GetLineNumber;
         IniFile.WriteString ('Editor', 'Source' + IntToStr (I+1), S);
         IniFile.WriteInteger ('Editor', 'PosY' + IntToStr (I+1), Line);
         end;
      IniFile.WriteInteger ('Editor', 'Current', EditorPages.ActivePageIndex);
      end;
   IniFile.WriteString ('Editor', 'Source' + IntToStr (I+1), 'Undefined');
   IniFile.Free;
   end;

{==============================================================================}

procedure TfmMainForm.SaveProjectAs1Click(Sender: TObject);

   begin
   SaveDialog.InitialDir := Project [prjPath];
   SaveDialog.Filename := Project [prjName];
   SaveDialog.Filter := 'AVR Pascal Project *.prj|*.prj';
   if SaveDialog.Execute then
      begin
      if FileExists(SaveDialog.Filename) then
         if MessageDlg('Project file exists. Overwrite ?',mtConfirmation,[mbYes,mbNo],0) = mrNo then
            exit;
      Project[0]:=ExtractFileName(ChangeFileExt(SaveDialog.FileName,''));
      Project[1]:=ExtractFilePath(SaveDialog.Filename);
      FileListBox.Items.Assign(Project);
      SaveProject1Click (nil);
      ShowProjectDetails;
      end;
   end;

{==============================================================================}

procedure TfmMainForm.CloseCurrentProject (Sender: TObject);

   begin
   SaveProject1Click (nil);
   CloseAllFiles1Click (nil);
   Caption := FormTitle;
   Project.Clear;
   ShowProjectDetails;
   end;

{==============================================================================}

procedure TfmMainForm.ShowProjectDetails;

   var  C,I: word;

   begin
   C := Project.Count;
   if C > 0 then
      begin
      edProjectName.Text := Project[prjName];
      Caption := FormTitle + ' - ' + Project[prjName];
      end;
   if C > 1 then edProjectPath.Text:=Project[prjPath];
   if C > 3 then ebCpuType.Text:=Project[3];
   FileListBox.Items.Clear;
   I := prjFileStart;
   while I < C do
      begin
      FileListBox.Items.Add(Project[I]);
      inc(I);
      end;
   ebMainFile.Text := ExtractFilename (MainFilename);
   cbCpuType.ItemIndex := cbCpuType.Items.IndexOf (CPU);
   end;

{==============================================================================}

procedure TfmMainForm.LoadLastProject;

   var  S:  string;

   begin
   S := Project [prjPath] + Project [prjName] + '.prj';
   if FileExists (S) then
      LoadProject (S, true);
   end;

{==============================================================================}

procedure TfmMainForm.LoadProject(ProjectFilename: String; ShowEditor: boolean);

   var  IniFile: TIniFile;
        I,V,X,Y: word;
        S:  string;
        Line:  word;

   begin
   if not FileExists(ProjectFilename) then
      begin
      Messagedlg ('Project ' + ProjectFilename + ' does not exist', mtError, [mbOk], 0);
      exit;
      end;

   Project.Clear;
   Project.Add(ChangeFileExt(ExtractFilename(ProjectFilename),''));
   Project.Add(ExtractFilePath(ProjectFilename));
   IniFile := TIniFile.Create(ProjectFilename);
   Project.Add('Standard Targets');
   CPU := IniFile.ReadString('General', 'CPU', 'No selection');
   Project.Add(CPU);

// Load project options
   cbIncludePascal.Checked := IniFile.ReadBool('General', 'IncludePAS', true);
   cbWriteSym.Checked := IniFile.ReadBool('General', 'WriteSym', false);
   cbTiny.Checked := IniFile.ReadBool('General', 'Tiny', false);
   cbSmallStack.Checked := IniFile.ReadBool('General', 'SmallStack', false);
   cbHasMult.Checked := IniFile.ReadBool('General', 'HasMult', false);
   cbHasFarCall.Checked := IniFile.ReadBool('General', 'HasFarCall', false);
   cbROM4K.Checked := IniFile.ReadBool('General', 'ROM4K', false);
   cbSwapBytes.Checked := IniFile.ReadBool('General', 'SwapBytes', false);
   cbLowStructures.Checked := IniFile.ReadBool('General', 'LowStructures', false);
   INIAutoIndent := IniFile.ReadBool('General', 'AutoIndent', true);
   cbNoConst.Checked := IniFile.ReadBool('General', 'NoConst', false);
   cbCOFFEnabled.Checked := IniFile.ReadBool('General', 'COFFEnabled', false);
   cbOBJEnabled.Checked := IniFile.ReadBool('General', 'OBJEnabled', false);
//   Editor.AutoIndent.Checked := IniAutoIndent;
   MainFilename := IniFile.ReadString('General', 'MainFileName', '');
   ebOutputFile.Text := IniFile.ReadString('General', 'OutputFile', Project [prjName]);

// Load source files
   I := 1;
   S := '';
   while S <> 'Undefined' do
      begin
      S := IniFile.ReadString('Sources', 'Source'+IntToStr(I), 'Undefined');
      if S <> 'Undefined' then
         Project.Add(S);
      inc(I);
      end;

// Load editor files
   if ShowEditor then
      begin
      I := 1;
      S := '';
      while S <> 'Undefined' do
         begin
         S := IniFile.ReadString('Editor', 'Source'+IntToStr(I), 'Undefined');
         Line := IniFile.ReadInteger('Editor', 'PosY'+IntToStr(I), 1);
         if (S <> 'Undefined') and (FileExists(S)) then
            fmMainForm.NewEditor (S, Line, eaLoadFile);
         inc(I);
         end;
//      fmNewEditor.Show;
      end;

   V := IniFile.ReadInteger('Editor','Current',0);
   SetCurrentPage (V);
   IniFile.Free;
   ShowProjectDetails;
   end;

{==============================================================================}

procedure TfmMainForm.Mainfile1Click(Sender: TObject);

   begin
   OpenDialog.InitialDir := Project [prjPath];
   OpenDialog.Filter := 'Pascal files *.pas|*.pas';
   OpenDialog.Filename := MainFilename;
   if OpenDialog.Execute then
      begin
      if (UpperCase(ExtractFileExt (OpenDialog.Filename)) = '.PAS') then
         begin
         MainFilename := OpenDialog.Filename;
         ShowProjectDetails;
         end
      else
         ShowMessage('The main file type must be of type ".PAS"');
      end;
   end;

{==============================================================================}

procedure TfmMainForm.AddToProject1Click(Sender: TObject);

   begin
   OpenDialog.Filter := 'Pascal files *.pas|*.pas|Assembly files *.asm|*.asm|All files *.*|*.*';
   if OpenDialog.Execute then
      begin
      if not FileExists(OpenDialog.Filename) then
         begin
         ShowMessage ('You must select an existing file...');
         exit;
         end
      else
         fmMainForm.NewEditor (OpenDialog.Filename, 1, eaLoadFile);
      Project.Add (OpenDialog.Filename);
      ShowProjectDetails;
      end;
   end;

{==============================================================================}

procedure TfmMainForm.RemoveFromProject1Click(Sender: TObject);

   var  S:  string;

   begin
   if FileListBox.ItemIndex < 0 then
      exit;
   S := FileListBox.Items [FileListBox.ItemIndex];
   if Project.IndexOf (S) < 0 then
      exit;
   if MessageDlg ('Do you wish to remove ' + S + ' from project?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
      begin
      Project.Delete (Project.IndexOf (S));
      ShowProjectDetails;
      ProjectChanged := true;
      end;
   end;

{==============================================================================}

procedure TfmMainForm.MoveFileUp (Sender: TObject);

   var  S:  string;
        I:  integer;

   begin
   if FileListBox.ItemIndex < 1 then
      exit;
   S := FileListBox.Items [FileListBox.ItemIndex];
   I := Project.IndexOf (S);
   if I < 1 then
      exit;
   Project.Exchange (I, I-1);
   ShowProjectDetails;
   FileListBox.ItemIndex := FileListBox.Items.IndexOf (S);
   ProjectChanged := true;
   end;

{==============================================================================}

procedure TfmMainForm.MoveFileDown (Sender: TObject);

   var  S:  string;
        I:  integer;

   begin
   if FileListBox.ItemIndex < 0 then
      exit;
   S := FileListBox.Items [FileListBox.ItemIndex];
   I := Project.IndexOf (S);
   if I = Project.Count - 1 then
      exit;
   Project.Exchange (I+1, I);
   ShowProjectDetails;
   FileListBox.ItemIndex := FileListBox.Items.IndexOf (S);
   ProjectChanged := true;
   end;

{==============================================================================}

procedure TfmMainForm.FileListBoxDblClick(Sender: TObject);

   var  S: string;

   begin
   if FileListBox.ItemIndex > -1 then
      begin
      S := FileListBox.Items[FileListBox.ItemIndex];
      if ExtractFilename(S) = S then
         S := Project[prjPath] + S;
      if FileExists(S) then
         NewEditor (S, 1, eaLoadFile)
      else
         Showmessage('File ' + S + ' not found');
      end;
   end;

{==============================================================================}

procedure TfmMainForm.LoadOptions;

   begin
   IncludePas := cbIncludePascal.Checked;
   WriteSymbolFile := cbWriteSym.Checked;
   Tiny := cbTiny.Checked;
   LowStructures := cbLowStructures.Checked;
   SmallStack := cbSmallStack.Checked;
   HasMult := cbHasMult.Checked;
   HasFarCall := cbHasFarCall.Checked;
   ROM4K := cbROM4K.Checked;
   SwapBytes := cbSwapBytes.Checked;
   NoConst := cbNoConst.Checked;
   COFFEnabled := cbCOFFEnabled.Checked;
   OBJEnabled := cbObjEnabled.Checked;
   CPU := cbCpuType.Items [cbCpuType.ItemIndex];
   MainFilename := ebMainFile.Text;
   if ebOutputFile.Text = '' then
      OutputFilename := Project[prjPath] + Project[prjName]
   else
      OutputFilename := Project[prjPath] + ebOutputFile.Text;
   end;

{==============================================================================}
{==============================================================================}
{==============================================================================}
{                               EDITOR OPTIONS                                 }
{==============================================================================}
{==============================================================================}
{==============================================================================}

procedure TfmMainForm.Editor1Click(Sender: TObject);

   begin
   EditorOptions.ShowModal;
   if EditorOptions.ModalResult = mrOK  then
      SaveHighlighterColors;
   LoadHighlighterColors;
   end;

{==============================================================================}

procedure TfmMainForm.LoadHighlighterColors;

   var  IniFile:  TIniFile;
        I:  integer;

   begin
   EditorFont := SampleSynEdit.Font;
   IniFile := TIniFile.Create (PgmIniFilename);
   SynPascal.AsmAttri.Foreground := IniFile.ReadInteger ('Color', 'Asm', clAssembly);
   SynPascal.CharAttri.Foreground := IniFile.ReadInteger ('Color', 'Char', clCharacter);
   SynPascal.CommentAttri.Foreground := IniFile.ReadInteger ('Color', 'Comment', clComment);
   SynPascal.DirectiveAttri.Foreground := IniFile.ReadInteger ('Color', 'Directive', clComment);
   SynPascal.KeyAttri.Foreground := IniFile.ReadInteger ('Color', 'Keyword', clKeyword);
   SynPascal.HexAttri.Foreground := IniFile.ReadInteger ('Color', 'Hex', clNumber);
   SynPascal.FloatAttri.Foreground := IniFile.ReadInteger ('Color', 'Float', clNumber);
   SynPascal.NumberAttri.Foreground := IniFile.ReadInteger ('Color', 'Number', clNumber);
   SynPascal.StringAttri.Foreground := IniFile.ReadInteger ('Color', 'String', clString);
   SynPascal.IdentifierAttri.Foreground := IniFile.ReadInteger ('Color', 'Identifier', clWhite);
   SynPascal.SymbolAttri.Foreground := IniFile.ReadInteger ('Color', 'Symbol', clWhite);
   EditorFont.Name := IniFile.ReadString ('Font', 'Name', 'Courier New');
   EditorFont.Size := IniFile.ReadInteger ('Font', 'Size', 10);
   BackgroundColor := IniFile.ReadInteger ('Color', 'Background', clBackground);
   IniFile.Free;

   for I := 0 to EditorPages.PageCount - 1 do
      begin
      (EditorPages.Pages [I] as TEditorTabsheet).Editor.SetBackground (BackgroundColor);
      (EditorPages.Pages [I] as TEditorTabsheet).Editor.SetFont (EditorFont);
      end;
   MessageMemo.Color := BackgroundColor;
   MessageMemo.Font.Color := SynPascal.IdentifierAttri.Foreground;
   end;

{==============================================================================}

procedure TfmMainForm.SaveHighlighterColors;

   var  IniFile:  TIniFile;

   begin
   IniFile := TIniFile.Create (PgmIniFilename);
   IniFile.WriteInteger ('Color', 'Asm', SynPascal.AsmAttri.Foreground);
   IniFile.WriteInteger ('Color', 'Char', SynPascal.CharAttri.Foreground);
   IniFile.WriteInteger ('Color', 'Comment', SynPascal.CommentAttri.Foreground);
   IniFile.WriteInteger ('Color', 'Directive', SynPascal.DirectiveAttri.Foreground);
   IniFile.WriteInteger ('Color', 'Keyword', SynPascal.KeyAttri.Foreground);
   IniFile.WriteInteger ('Color', 'Hex', SynPascal.HexAttri.Foreground);
   IniFile.WriteInteger ('Color', 'Float', SynPascal.FloatAttri.Foreground);
   IniFile.WriteInteger ('Color', 'Number', SynPascal.NumberAttri.Foreground);
   IniFile.WriteInteger ('Color', 'String', SynPascal.StringAttri.Foreground);
   IniFile.WriteInteger ('Color', 'Identifier', SynPascal.IdentifierAttri.Foreground);
   IniFile.WriteInteger ('Color', 'Symbol', SynPascal.SymbolAttri.Foreground);
   IniFile.WriteInteger ('Color', 'Background', BackgroundColor);
   IniFile.WriteString ('Font', 'Name', EditorFont.Name);
   IniFile.WriteInteger ('Font', 'Size', EditorFont.Size);

   end;

{==============================================================================}
{==============================================================================}
{==============================================================================}
{                           EDITOR FUNCTIONS                                   }
{==============================================================================}
{==============================================================================}
{==============================================================================}

function TfmMainForm.FileIsOpen (S: string): integer;

   var  I:   integer;

   begin
   Result := -1;
   S := uppercase (S);
   for I := 0 to EditorPages.PageCount - 1 do
      if uppercase ((EditorPages.Pages [I] as TEditorTabsheet).Editor.GetFilename) = S then
         begin
         Result := I;
         exit;
         end;
   end;

{==============================================================================}

procedure TfmMainForm.EditorPagesChange(Sender: TObject);
   begin
   StatusBar.Panels [2].Text := (EditorPages.ActivePage as TEditorTabsheet).Editor.GetFilename;
   end;

{==============================================================================}

function TfmMainForm.CurrentEditor: TfmEditorFrame;

   begin
   Result := nil;
   if (EditorPages.PageCount > 0) and (EditorPages.ActivePageIndex > -1) then
      Result := (EditorPages.ActivePage as TEditorTabsheet).Editor;
   end;

{==============================================================================}

function TfmMainForm.NewEditor (Filename: string; Line: word; EditAction: TEditorAction): boolean;

    var  Frame: PfmEditorFrame;
         Tabsheet: TEditorTabSheet;
         PageCount:  integer;
         I:  integer;

    begin
    Result := true;
    I := FileIsOpen (Filename);
    if I > -1 then
       EditorPages.ActivePageIndex := I
    else
       try
       TabSheet := TEditorTabsheet.Create (EditorPages);
       TabSheet.PageControl := EditorPages;
       TabSheet.ParentColor := true;
       TabSheet.ParentFont := true;
       PageCount := EditorPages.PageCount;
       Tabsheet.Editor := TfmEditorFrame.Create (TabSheet);
       Tabsheet.Editor.Color := BackgroundColor;
       Tabsheet.Editor.SynEdit.Highlighter := SynPascal;
       Tabsheet.Editor.Align := alCLient;
       Tabsheet.Editor.Visible := true;
       Tabsheet.Editor.Initialize;
       Tabsheet.Editor.SetBackground (BackgroundColor);
       Tabsheet.Editor.Parent := TabSheet;
       TabSheet.Caption := ExtractFilename (Filename);
       EditorPages.ActivePage := TabSheet;
       StatusBar.Panels [2].Text := Filename;
       if EditAction = eaLoadFile then
          Tabsheet.Editor.LoadFile (Filename);
       if EditAction = eaNewFile then
          Tabsheet.Editor.SaveFileAs (Filename);
       Tabsheet.Editor.SetCaretPosition (1, Line);
       ModePages.ActivePageIndex := 1;
       except
          Result := false;
       end;
    end;

{==============================================================================}
{==============================================================================}
{==============================================================================}
{                             FILE FUNCTIONS                                   }
{==============================================================================}
{==============================================================================}
{==============================================================================}

procedure TfmMainForm.NewFile1Click(Sender: TObject);

   begin
   SaveDialog.InitialDir := Project [prjPath];
   SaveDialog.Filename := 'Untitled.pas';
   SaveDialog.Filter := '';
   if SaveDialog.Execute then
      if SaveDialog.Filename <> '' then
         begin
         ModePages.ActivePageIndex := 1;
         NewEditor (SaveDialog.Filename, 1, eaNewFile);
         end;
   end;

{==============================================================================}

procedure TfmMainForm.OpenFile1Click(Sender: TObject);

   begin
   OpenDialog.Filter := 'Pascal files (*.pas)|*.pas|Assembly files (*.asm)|*.asm|Include files (*.inc)|*.inc|All files (*.*)|*.*';
   if OpenDialog.Execute then
      if FileExists (OpenDialog.Filename) then
         NewEditor (OpenDialog.Filename, 1, eaLoadFile)
      else
         MessageDlg ('File ' + OpenDialog.Filename + ' does not exists', mtError, [mbOK], 0);
   end;

{==============================================================================}

procedure TfmMainForm.SaveFile1Click(Sender: TObject);

   begin
   CurrentEditor.SaveFile;
   end;

{==============================================================================}

procedure TfmMainForm.SaveFileAs1Click(Sender: TObject);

   var  S:  string;
   begin
   SaveDialog.Filename := (EditorPages.ActivePage as TEditorTabsheet).Editor.GetFilename;
   if SaveDialog.Execute then
      begin
      S := SaveDialog.Filename;
      if FileExists (S) then
         if MessageDlg ('File ' + S + ' already exists. Overwrite?', mtConfirmation, [mbYes, mbNo], 0) = mrNo then
            exit;
      CurrentEditor.SaveFileAs (S);
      (EditorPages.ActivePage as TEditorTabsheet).Caption := ExtractFilename (S);
      end;
   end;

{==============================================================================}

procedure TfmMainForm.SaveAllFiles1Click(Sender: TObject);

   var  I:  integer;

   begin
   if EditorPages.PageCount > 0 then
      for I := 0 to EditorPages.PageCount - 1 do
         (EditorPages.Pages [I] as TEditorTabsheet).Editor.SaveFile;
   end;

{==============================================================================}

procedure TfmMainForm.CloseFile1Click(Sender: TObject);

   begin
   CurrentEditor.CloseFile;
   CurrentEditor.Free;
   (EditorPages.ActivePage as TEditorTabsheet).Free;
   end;

{==============================================================================}

procedure TfmMainForm.CloseAllFiles1Click(Sender: TObject);

   begin
   while EditorPages.PageCount > 0 do
      begin
      EditorPages.ActivePage := EditorPages.Pages [0];
      CloseFile1Click (nil);
      end;
   end;

{==============================================================================}
{==============================================================================}
{==============================================================================}
{                           CUT COPY PASTE
{==============================================================================}
{==============================================================================}
{==============================================================================}

procedure TfmMainForm.Copy1Click(Sender: TObject);

   var  Editor:  TfmEditorFrame;

   begin
   Editor := CurrentEditor;
   if Editor <> nil then
      Editor.Copy;
   end;

{==============================================================================}

procedure TfmMainForm.Cut1Click(Sender: TObject);

   var  Editor:  TfmEditorFrame;

   begin
   Editor := CurrentEditor;
   if Editor <> nil then
      Editor.Cut;
   end;

{==============================================================================}

procedure TfmMainForm.Paste1Click(Sender: TObject);

   var  Editor:  TfmEditorFrame;

   begin
   Editor := CurrentEditor;
   if Editor <> nil then
      Editor.Paste;
   end;

{==============================================================================}
{==============================================================================}
{==============================================================================}
{                               SEARCH OPTIONS                                 }
{==============================================================================}
{==============================================================================}
{==============================================================================}

procedure TfmMainForm.ebSearchKeyPress(Sender: TObject; var Key: Char);

   begin
   if (Key = #13) and (ebSearch.Text <> '') then
      bbFindClick (nil);
   end;


procedure TfmMainForm.arwBackwardClick(Sender: TObject);

   begin
   Include (SearchOptions, ssoBackwards);
   arwForward.Active := false;
   arwBackward.Active := true;
   end;

procedure TfmMainForm.arwForwardClick(Sender: TObject);

   begin
   Exclude (SearchOptions, ssoBackwards);
   arwForward.Active := true;
   arwBackward.Active := false;
   end;

procedure TfmMainForm.cbCpuTypeChange(Sender: TObject);

   begin
   ebCpuType.Text := cbCpuType.Items [cbCpuType.ItemIndex];
   end;

procedure TfmMainForm.cbEntireScopeClick(Sender: TObject);

   begin
   if cbEntireScope.Checked then
      Include (SearchOptions, ssoEntireScope)
   else
      Exclude (SearchOptions, ssoEntireScope);
   end;

procedure TfmMainForm.cbMatchCaseClick(Sender: TObject);

   begin
   if cbMatchCase.Checked then
      Include (SearchOptions, ssoMatchCase)
   else
      Exclude (SearchOptions, ssoMatchCase);

   end;

procedure TfmMainForm.cbSelectionOnlyClick(Sender: TObject);

   begin
   if cbSelectionOnly.Checked then
      Include (SearchOptions, ssoSelectedOnly)
   else
      Exclude (SearchOptions, ssoSelectedOnly);
   end;

procedure TfmMainForm.cbWholeWordsClick(Sender: TObject);

   begin
   if cbWholeWords.Checked then
      Include (SearchOptions, ssoWholeWord)
   else
      Exclude (SearchOptions, ssoWholeWord);
   end;

{==============================================================================}
{==============================================================================}
{                            SEARCH AND REPLACE                                }
{==============================================================================}
{==============================================================================}
{==============================================================================}

procedure TfmMainForm.Find1Click(Sender: TObject);

   begin
   ActiveControl := ebSearch;
   end;

procedure TfmMainForm.FindandReplace1Click(Sender: TObject);

   begin
   ActiveControl := ebReplace;
   end;

procedure TfmMainForm.bbFindClick(Sender: TObject);

   begin
   Exclude (SearchOptions, ssoReplace);
   Exclude (SearchOptions, ssoReplaceAll);
   if (ebSearch.Text <> '') and (CurrentEditor <> nil) then
      CurrentEditor.SearchFor (ebSearch.Text, SearchOptions);
   end;

procedure TfmMainForm.bbReplaceClick(Sender: TObject);

   begin
   if EditorPages.ActivePageIndex > -1 then
      if (ebSearch.Text <> '') and (ebReplace.Text <> '') then
         begin
         Exclude (SearchOptions, ssoReplaceAll);
         Include (SearchOptions, ssoReplace);
         (EditorPages.ActivePage as TEditorTabsheet).Editor.Replace (ebSearch.Text, ebReplace.Text, SearchOptions);
         end;
   end;

{==============================================================================}

procedure TfmMainForm.bbReplaceAllClick(Sender: TObject);

   begin
   if EditorPages.ActivePageIndex > -1 then
      if (ebSearch.Text <> '') and (ebReplace.Text <> '') then
         begin
         Include (SearchOptions, ssoReplaceAll);
         Include (SearchOptions, ssoReplace);
         (EditorPages.ActivePage as TEditorTabsheet).Editor.Replace (ebSearch.Text, ebReplace.Text, SearchOptions);
         end;
   end;

{==============================================================================}

procedure TfmMainForm.FindNext1Click(Sender: TObject);

   begin
   if (ebSearch.Text <> '') and (EditorPages.PageCount > 0) then
      (EditorPages.ActivePage as TEditorTabsheet).Editor.SearchFor (ebSearch.Text, SearchOptions);
   end;

{==============================================================================}

procedure TfmMainForm.cbSearchTextKeyPress(Sender: TObject; var Key: Char);

   begin
   if (Key = #13) and (ebSearch.Text <> '') and (EditorPages.PageCount > 0) then
      (EditorPages.ActivePage as TEditorTabsheet).Editor.SearchFor (ebSearch.Text, SearchOptions);
   end;


procedure TfmMainForm.CompileCurrentBtnClick(Sender: TObject);

   var  I: word;
        Filename:   string;

   begin
   CurrentEditor.ClearError;
   LoadOptions;
   SaveAllFiles1Click (nil);
   if EditorPages.ActivePage = nil then
      exit;
//   I := PageControl1.ActivePage.Tag;
//xx   AssemblerStatus.ListBox1.Items.Clear;
   Filename := (EditorPages.ActivePage as TEditorTabsheet).Editor.GetFilename;
   if uppercase (ExtractFileExt (Filename)) = '.ASM' then
      begin
//      AssemblerStatus.Show;
      (EditorPages.ActivePage as TEditorTabsheet).Editor.SaveFile;
      RunAssembler (FileName);
      end
   else
      if uppercase (ExtractFileExt (FileName)) = '.PAS' then
         begin
            try
            (EditorPages.ActivePage as TEditorTabsheet).Editor.SaveFile;
            StatusBar.Panels [3].Text := '';
//            CompilerStatus.Edit2.Text := '0';
//            CompilerStatus.Show;
            RunPascalCompiler (Filename, EditorPages.ActivePageIndex+1, CodeSize, DataSize);
//            AssemblerStatus.Show;
            Status ('');
            Status ('Compile: ' + Editlist[I].Filename);
            Status ('Code size:      ' + IntToStr (CodeSize) + ' instructions (approximate)');
            Status ('Data size:      ' + IntToStr (DataSize) + ' byte(s)');
            Status ('E2Data size:    ' + IntToStr (E2DataSize) + ' byte(s)');
            Status ('Identifiers:    ' + IntToStr (IDTableIndex));
            Status ('Procedures:     ' + IntToStr (BlockTableIndex));
            Status ('Arrays/Strings: ' + IntToStr (ArrayTableIndex - 1));
            Status ('Dynamic Stack:  ' + IntToStr (StackEstimate) + '+10 bytes');
            if UsesAddStrings then
               Status ('Maximum Stack:  ' + IntToStr (StackEstimate+MaxStringSize * 2) + ' bytes (for maximum string usage)')
            else
               Status ('Maximum Stack:  ' + IntToStr (StackEstimate + MaxStringSize) + ' bytes (for maximum string usage)');
            Status ('Device:         ' + DeviceCode);
//            UpdateSourceSelection (I);
            Status('');
//            CompilerStatus.Hide;
      //RunAssembler(ChangeFileExt(EditList[i].FileName,'.ASM'));
            except on ECompileError do
               begin
               end;
            end;
         end
      else
         ShowMessage ('Don''t know how to handle this file. File extention should be '+
                '.Pas for Pascal files or .Asm for assembler files...');
   end;

{==============================================================================}
{==============================================================================}
{==============================================================================}
{                              BUILD ALL                                       ]
{==============================================================================}
{==============================================================================}
{==============================================================================}

procedure TfmMainForm.BuildAllBtnClick(Sender: TObject);

   var  S: string;
        FX: string;
        I:  word;

   begin
   CurrentEditor.ClearError;
   LoadOptions;
   SaveAllFiles1Click (nil);
   MessageMemo.Clear;
   if MainFileName='' then
      begin
      ShowMessage ('Main file name not defined, please choose it now.');
      MainFile1Click(nil);
      if MainFilename='' then
         exit;
      end;

   if not FileExists(MainFilename) then
      begin
      MainFileName := Project [1] + ExtractFilename (MainFilename);
      if not FileExists (MainFilename) then
         begin
         ShowMessage (MainFilename + ' not found');
         exit;
         end;
      end;

//   SpeedButton4Click (nil);  // Save all files
//xx   AssemblerStatus.ListBox1.Items.Clear;
   FX := uppercase (ExtractFileExt (MainFileName));
   if FX = '.PAS' then
   begin
      try
      S := MainFileName;
{      if not FileExists (MainFileName) then
            begin
            if fx='.PAS' then
               begin
               if FileExists(ChangeFileExt(MainFileName,'.EPS')) then
                  s:=ChangeFileExt(MainFileName,'.EPS');
//             PascalHasEncodedParts:=true;
               end
            else if fx='.EPS' then
               begin
               if FileExists(ChangeFileExt(MainFileName,'.PAS')) then
                  s:=ChangeFileExt(MainFileName,'.PAS');
               end;
            end;

      if not FileExists(MainFilename) then
         begin
         ShowMessage('Main file "' + MainFilename + '" not found');
         exit;
         end;
}
      ShowCompilerStatus (FileBeingCompiled, TotalLines);
//      CompilerStatus.Edit1.Text:='';
//      CompilerStatus.Edit2.Text:='0';
//      CompilerStatus.Show;
      RunPascalCompiler(S, I, CodeSize, DataSize);                             // Compile main file
//      AssemblerStatus.Show;
      Status('');
      Status('Compile: '+MainFileName);
      Status('Code size:      '+IntToStr(CodeSize)+' instructions (approximate)');
      Status('Data size:      '+IntToStr(DataSize)+' byte(s)');
      Status('E2Data size:    '+IntToStr(E2DataSize)+' byte(s)');
      Status('Identifiers:    '+IntToStr(IDTableIndex));
      Status('Procedures:     '+IntToStr(BlockTableIndex));
      Status('Arrays/Strings: '+IntToStr(ArrayTableIndex-1));
      Status('Dynamic Stack:  '+IntToStr(StackEstimate)+'+10 bytes');
      if UsesAddStrings then
         Status('Maximum Stack:  '+IntToStr(StackEstimate+MaxStringSize*2)+' bytes (for maximum string usage)')
      else
         Status('Maximum Stack:  '+IntToStr(StackEstimate+MaxStringSize)+' bytes (for maximum string usage)');
      Status('Device:         '+DeviceCode);
      Status('');
//      CompilerStatus.Hide;
      Link;
    except
      on ECompileError do begin end;
    end;
  end;
end;

   end.
