unit PasSym;

interface

uses AsmDefs,PascalDefs, StringConversion;

procedure GetNextSymbol;     (* reads next symbol *)
procedure ConvertZ80Single(SS: Single; var II: Longint);
procedure IncludeUnit (S: string);
function FindLocation(s: string) : word;                                         //ss   short

implementation

uses SysUtils,Compiler,MainForm,AsmStatus,RpnUtils,AsmPas;

procedure ConvertZ80Single(SS: Single; var II: Longint);
var
  l,exp,mant: longint;
begin
  move(SS,L,4);
  exp:=(l and $7F800000) shr 23;
  if exp=0 then
  begin
    II:=0; Exit;
  end;
  mant:=l and $7FFFFF or $800000;
  exp:=exp-$3E;
  II:=l and $80000000 or ((exp and $7F) shl 24) or mant;
end;

{==============================================================================}

function FindLocation(S: string) : word;                                         //ss  short

   var  IX, J: Integer;
        HASHID: word;
        label X1;

   begin
   Result := 0;
//mov   move(S, HASHID, 2);
//   StrToShort (S, Str);
//   move (Str, HASHID, 2);
   HASHID := GetHashID (S);
   IX := LevelForParser; //set at beginning of every block
   if IX = 0 then
      exit;
   try
      repeat
         J := BlockTable[Display[IX]].Last;
x1:
         while ( J <> 0) and (IdentifierTable[J].HASHID <> HASHID) do
            J := IdentifierTable[J].Link;

//         if J in [0..IdentifierNames.Count] then
         if (J <> 0) and (IdentifierNames[IdentifierTable[J].NameLookup] <> S) then
            begin
            J := IdentifierTable[J].Link;
            goto x1;
            end;

         IX := IX-1;
      until (Ix<0) OR (J<>0);

      Result := J;
      except on Exception do
         begin
         end;
      end;
   end;

{==============================================================================}

procedure IncludeAFile;

   var
      S: string;                                                                     //ss short
      FX: string;                                                                    //ss [4];

{====================}

      procedure SaveFileIfInEditor;

         var
            FN: string;                                                                  //ss [20];
            N: word;

         begin
         FN := ExtractFileName(S);
         for N := 0 to NumberOfEditItems-1 do
            begin
            if EditList[N].Used then
               if uppercase(ExtractFileName(EditList[n].Filename)) = uppercase(FN) then
                  begin
                  if EditList[N].Editor.Modified then
//          EditList[n].Editor.Lines.SaveToFile(EditList[n].FileName);
//                     Editor.SaveFile(EditList[N].Filename, N);
                  break;
                  end;
            end;
         end;

{====================}

   begin
   ReadNextCharFromSource;
   while LastCharFromSource <= ' ' do
      ReadNextCharFromSource;
   S := '';
   while (S.Length < 255) and (LastCharFromSource <> '}') do
      begin
      S := S + LastCharFromSource;
      ReadNextCharFromSource;
      end;

   if (S = '') or (length(S) > 250) then
      CError(86);
   if ConditionalSkip then
      exit;
   FX := uppercase(ExtractFileExt(S));
   if not FileExists(S) then
      begin
      if FX = '.PAS' then
         if FileExists(ChangeFileExt(S, '.EPS')) then
            begin
            S := ChangeFileExt(S, '.EPS');
            end
         else if FX = '.EPS' then
            if FileExists(ChangeFileExt(S,'.PAS')) then
               begin
               S := ChangeFileExt(S,'.PAS');
               end;

            if not FileExists(S) then
               begin
               S := ExtractFilename(S);
               S := Project[1] + S;
               if not FileExists(S) then
                  begin
                  if FX = '.PAS' then
                     if fileExists(ChangeFileExt(S, '.EPS')) then
                        begin
                        S := ChangeFileExt(S, '.EPS');
                        end
                     else if FX = '.EPS' then
                        if FileExists(ChangeFileExt(S, '.PAS')) then
                           S := ChangeFileExt(S, '.PAS');
                  end;
               end;
      end;

   if FileExists(S) then
      begin
      SaveFileIfInEditor;
      if CurrentIncludeFile >= NumberOfIncludeFiles then
         CError(88);
      inc(CurrentIncludeFile);
      with IncludeFile[CurrentIncludeFile] do
         begin
         IncludeFilename := ExtractFilename(S);
         AssignFile(IFile,S);
         end;
      end
   else
      CError(87);

   FileMode := 0;
   with IncludeFile[CurrentIncludeFile] do
      begin
//      reset(IFile, 1);
      IncludeErrorLine := 0;
      EndOfIncludeFile := false;
      CharsInIncludeBuffer := 0;
      IncludeSource.Clear;
      IncludeSource.LoadFromFile (S);
      IncludeLineNumber := 0;
      end;

//   FileMode:=2;
   FileBeingCompiled := ExtractFilename (S);
   fmMainForm.ShowCompilerStatus (FileBeingCompiled, TotalLines);
//   CompilerStatus.Edit1.Text := ExtractFilename(s);
   LineLength := 0;
   CharacterCounter := 0;
   ASMOutput.Add('; Include file ' + S);
   if S = ExtractFileName(S) then
      S := Project[1] + S;
   AsmFileSpec(S);
   LastLineNumber:=$FFFFFFF;
   end;

{==============================================================================}

procedure IncludeUnit (S: string);

   begin
   S := Project[1] + ChangeFileExt (S, '.EPI');                                   // Project = TStringList
   if not FileExists(S) then
      begin
      S := Exepath + 'lib\' + ExtractFilename(S);
      end;

   if FileExists (S) then
      begin
      if CurrentIncludeFile >= NumberOfIncludeFiles then
         CError(88);
      inc(CurrentIncludeFile);

      with IncludeFile [CurrentIncludeFile] do
         begin
         IncludeFilename := ExtractFilename (S);
         AssignFile(IFile, S);
         end;
      end
   else
      begin
      exit;
      end;

   fileMode := 0;
   with IncludeFile [CurrentIncludeFile] do
      begin
      reset(IFile, 1);
      ReadingFromUnit := true;
      IncludeErrorLine := 0;
      IncludeKey := 23874;
      EndOfIncludeFile := false;
      CharsInIncludeBuffer := 0;
      IncludeSource.Clear;
      IncludeSource.LoadFromFile (S);
      IncludeLineNumber := 0;
      end;

   fileMode := 2;
   FileBeingCompiled := ExtractFilename (S);
//   CompilerStatus.Edit1.Text := ExtractFilename(S);
   LineLength := 0;
   CharacterCounter := 0;
   ASMOutput.Add (';Unit Interface file ' + S);
   AsmFileSpec (S);
   LastLineNumber:=$FFFFFFF;
   end;

{==============================================================================}

procedure ShareData;

   var  S: string;                                                                     //ss short
        x: word;

   begin
   ReadNextCharFromSource;
   if LastCharFromSource = '-' then
      begin
      SharedData := false;
      while LastCharFromSource <> '}' do
         ReadNextCharFromSource;
      exit;
      end;

   while LastCharFromSource = ' ' do
      ReadNextCharFromSource;
   S := '';
   while (LastCharFromSource <> '}') and (length(S) < 250) do
      begin
      S := S + LastCharFromSource;
      ReadNextCharFromSource;
      end;

   if ConditionalSkip then
      exit;
   if (LastCharFromSource <> '}') or (S = '') then
      CError(89);
   x:=FindLocation(Uppercase(S));
   if x = 0 then
      CError(0);
   if identifierTable[x].OBJ <> TVariable then
      CError(37);
   ShareDataWith := x;
   SharedData:=true;
   NextVarResetsShare := true;
   end;

{==============================================================================}

procedure LabelModifier;

   begin
   ReadNextCharFromSource;
   if LastCharFromSource = '-' then
      begin
      while LastCharFromSource<>'}' do
         ReadNextCharFromSource;
     if ConditionalSkip then
        exit;
     ProgramNameInLabel:=false;
     end
   else if LastCharFromSource='+' then
      begin
      while LastCharFromSource<>'}' do
         ReadNextCharFromSource;
      if ConditionalSkip then
         exit;
      ProgramNameInLabel := true;
      end else CError(89);
   end;

procedure StripBlanks;
begin
  while LastCharFromSource<=' ' do ReadNextCharFromSource;
end;

{==============================================================================}

procedure SetDynamics;

   var  S: string;                                                               //ss short

   begin
   ReadNextCharFromSource;
   S := '';
   StripBlanks;
   PreviousDynamicVars:=DynamicVars;
   while (LastCharFromSource <> '}') and (length(S) < 250) do
      begin
      S := S + UpCase(LastCharFromSource);
      ReadNextCharFromSource;
      end;

   if ConditionalSkip then
      exit;
   if S = '-' then
      DynamicVars := false
   else if S = '+' then
      DynamicVars := true
   else if S = 'PREV' then
      DynamicVars := PreviousDynamicVars
   else
      CError(116);
   if (LastCharFromSource <> '}') or ( S = '') then
      CError(89);
   end;

{==============================================================================}

procedure SetRegisterTrack;

   var  S: string;                                                               //ss short

   begin
   ReadNextCharFromSource;
   S := '';
   StripBlanks;
   while (LastCharFromSource <> '}') and (length(S) < 250) do
      begin
      S := S + UpCase(LastCharFromSource);
      ReadNextCharFromSource;
      end;

   if ConditionalSkip then
      exit;
   if S = '-' then
      RegisterTrack := false
   else if S = '+' then
      RegisterTrack := true
   else
      CError(116);
   if (LastCharFromSource <> '}') or (S = '') then
      CError(89);
end;

{==============================================================================}

procedure ExLPM;

   var  S: string;                                                               //ss short

   begin
   ReadNextCharFromSource;
   S := '';
   StripBlanks;
   while (LastCharFromSource <> '}') and (length(S) < 250) do
      begin
      S := S + UpCase(LastCharFromSource);
      ReadNextCharFromSource;
      end;

   if ConditionalSkip then
      exit;
   if S = '-' then
      AT0('EXLPM -')
   else if S = '+' then
      AT0('EXLPM +')
   else
      CError(116);

   if (LastCharFromSource <> '}') or (S = '') then
      CError(89);
   end;

{==============================================================================}

procedure Casting;

   var  S: string;                                                               //ss short

   begin
   ReadNextCharFromSource;
   S := '';
   StripBlanks;
   while (LastCharFromSource <> '}') and (length(S) < 250) do
      begin
      S := S + UpCase(LastCharFromSource);
      ReadNextCharFromSource;
      end;

   if ConditionalSkip then
      exit;
   if S = '-' then
      AllowAnyCast := false
   else if S = '+' then
      AllowAnyCast := true
   else
      CError(116);

   if (LastCharFromSource <> '}') or (S = '') then
      CError(89);
   end;

{==============================================================================}

procedure PointerBending;

   var S: string;                                                                //ss short

   begin
   ReadNextCharFromSource;
   S := '';
   StripBlanks;
   while (LastCharFromSource <> '}') and (length(S) < 250) do
      begin
      S := S + UpCase(LastCharFromSource);
      ReadNextCharFromSource;
      end;

   if ConditionalSkip then
      exit;
   PreviousPointerBend := PointerBend;
   if S = 'DATA' then
      PointerBend := DataMem
   else if S = 'CODE' then
      PointerBend := CodeMem
   else if S = 'PREV' then
      PointerBend := PreviousPointerBend
   else
      CError(116);

   if (LastCharFromSource <> '}') or (S = '') then
      CError(89);
   end;

{==============================================================================}

procedure PassThrough;

   var  S: string;

   begin
   ReadNextCharFromSource;
   S := '';
   while LastCharFromSource <> '}' do
      begin
      S := S + LastCharFromSource;
      ReadNextCharFromSource;
      end;

   if ConditionalSkip then
      exit;
   if S <> '' then
      begin
      AsmOutput.Add(S);
      end;
   end;

{==============================================================================}

function Conditionals: boolean;

   var  S: string;                                                               //ss short
        ix: longint;

      procedure GetAString;

         begin
         ReadNextCharFromSource;
         while LastCharFromSource <= ' ' do
            ReadNextCharFromSource;
         S := '';
//ss         while (S[0]<#255) and (LastCharFromSource in ['A'..'Z','a'..'z','0'..'9','_']) do
         while (length (S) < 255) and (CharInSet (LastCharFromSource, ['A'..'Z','a'..'z','0'..'9','_'])) do
            begin
            S := S + Upcase(LastCharFromSource);
            ReadNextCharFromSource;
            end;

         if (S = '') or (length(S) > 250) then
            CError(101);
         end;

   begin
   result := false;
   GetAString;
   if S = 'DEFINE' then
      begin
      GetAString;
      if ConditionalSkip then
         exit;
      ix := ReferenceList.IndexOf(S);
      if ix > -1 then
         CError(1);
      ReferenceList.Add(s);
      end
   else if S = 'IFDEFINED' then
      begin
      GetAString;
      if ConditionalSkip then
         exit;
      ix := ReferenceList.IndexOf(S);
      if ix < 0 then
         begin
         ConditionalElse:=false;
         while LastCharFromSource <> '}' do
            ReadNextCharFromSource;
         ReadNextCharFromSource;
         ConditionalSkip := true;
         repeat
            GetNextSymbol;
         until ConditionalSkip = false;
         result:=true;
         end
      else
         ConditionalElse := true;
      end
   else if S = 'IFNOTDEFINED' then
      begin
      GetAString;
      if ConditionalSkip then
         exit;
      ix := ReferenceList.IndexOf(S);
      if ix >= 0 then
         begin
         ConditionalElse := false;
         while LastCharFromSource <> '}' do
            ReadNextCharFromSource;
         ReadNextCharFromSource;
         ConditionalSkip:=true;
         repeat
            GetNextSymbol;
         until ConditionalSkip = false;
         result:=true;
         end
      else
         ConditionalElse := true;
      end
   else if S = 'ENDIF' then
      begin
      ConditionalSkip := false;
      ConditionalElse := false;
      result := false;
      end
   else if S = 'ELSE' then
      begin
      if ConditionalElse then
         begin
         while LastCharFromSource <> '}' do
            ReadNextCharFromSource;
         ReadNextCharFromSource;
         ConditionalElse := false;
         ConditionalSkip := true;
         repeat
            GetNextSymbol;
         until ConditionalSkip=false;
         result := true;
         end
      else
         begin
         ConditionalSkip:=false;
         result:=false;
         end;
      end
   else
      CError(101);
   end;

{==============================================================================}

procedure GetNextSymbol;     (* reads next symbol *)

   label 1,2,3,4,5,X1,X2;

   var  I,J,K,E,Brackets: integer;
        TS: Symbol;
        FS: string;                                                              // short

      procedure ReadScale;

         var  S, Sign: integer;

         begin
         ReadNextCharFromSource;
         Sign := 1;
         S := 0;

         if LastCharFromSource = '+' then
            ReadNextCharFromSource
         else if LastCharFromSource = '-' then
            begin
            ReadNextCharFromSource;
            SIGN := -1;
            end;

         if not (CharInSet (LastCharFromSource, ['0'..'9'])) then
            CERROR (40)
         else
            repeat
               S := 10 * S + ord(LastCharFromSource) - ord('0');
               ReadNextCharFromSource;
            until not (CharInSet (LastCharFromSource, ['0'..'9']));
         E := S * Sign + E;
         end; { READSCALE }

{====================}

      procedure ADJUSTSCALE;

         var  S: integer;
              D,T: double;

         begin
         if K + E > MaxRealExponent then
            CERROR(21)
         else if K + E < MinRealExponent then
            RealNumeric := 0
         else
            begin
            S := abs(E);
            T := 1.0;
            D := 10.0;
            repeat
               while not odd(S) do
                  begin
                  S := S div 2;
                  D := sqr(D);
                  end;
               S := S - 1;
               T := D * T;
               until S = 0;

            if E >= 0 then
               RealNumeric := RealNumeric * T
            else
               RealNumeric := RealNumeric / T;
            end;
         end; { ADJUSTSCALE }

{====================}

      function ValidHexChar(Ch: char) : boolean;

         begin
         if CharInSet (upcase(Ch), ['0'..'9','A'..'F']) then
            result := true
         else
            result := false;
         end;

{====================}

      function ValidBinChar(Ch: char) : boolean;

         begin
         if CharInSet (Ch, ['0','1']) then
            result := true
         else
            result := false;
         end;

{====================}

      function HexCharToDec(Ch: char): word;         //ss   ansichar

         begin
         Ch := upcase(Ch);
         if CharInSet (Ch,  ['A'..'F']) then
            Result := ord(Ch) - ord('A' ) + 10
         else
            Result := ord(Ch) - $30;
         end;

{====================}

      procedure GetIdentifierInParanthesis(var I: word; L: word);

         begin
         if (I <= L) and (Expression[I] <> '(') then
            CError(9);
         inc(I);
         ParserLookAhead := '';
         while (I <= L) and (CharInSet (Expression[I], ['A'..'Z','_','0'..'9'])) do
            begin
            ParserLookAhead := ParserLookAhead + Expression[I];
            inc(I);
            end;
         if (I <= L) and (Expression[I] <> ')') then
            CError(4);
         inc(I);
         if ParserLookAhead = '' then
            CError(2);
         end;

{====================}

      procedure SimplifyExpression;

         var CF, S: string;                                                      //ss short
             V: longint;
             I,L,J,Brackets,Remember: word;
             Ch: char;                                                           //ss ansichar

         label Done,FX,FD,XX;

         begin
         Expression := uppercase(Expression);
     //replace all occurences of "div" with "/"
         while pos (' DIV ', Expression) > 0 do
            begin
            I := pos(' DIV ', Expression);
            if I > 0 then
               begin
               delete(Expression, I+1, 3);
               insert('/', Expression, I+1);
               end;
            end;  // while pos

         if InsideConstantDeclaration then
            begin
            while pos(' MOD ', Expression) > 0 do
               begin
               I := pos(' MOD ', Expression);
               if I > 0 then
                  begin
                  delete(Expression, I+1, 3);
                  insert('.MOD.',Expression, I+1);
                  end;
               end;

            while pos(' AND ', Expression) > 0 do
               begin
               I :=pos(' AND ', Expression);
               if I > 0 then
                  begin
                  delete(Expression, I+1, 3);
                  insert('.AND.', Expression, I+1);
                  end;
               end;

            while pos(' OR ', Expression) > 0 do
               begin
               I := pos(' OR ', Expression);
               if I > 0 then
                  begin
                  delete(Expression, I+1, 3);
                  insert('.OR.', Expression, I+1);
                  end;
               end;

            while pos(' XOR ', Expression) > 0 do
               begin
               I := pos(' XOR ', Expression);
               if I > 0 then
                  begin
                  delete(Expression, I+1, 3);
                  insert('.XOR.', Expression, I+1);
                  end;
               end;

            while pos(' SHR ', Expression) > 0 do
               begin
               I := pos(' SHR ', Expression);
               if I > 0 then
                  begin
                  delete(Expression, I+1, 3);
                  insert('.SHR.', Expression, I+1);
                  end;
               end;

            while pos(' SHL ', Expression) > 0 do
               begin
               I := pos(' SHL ', Expression);
               if I > 0 then
                  begin
                  delete(Expression, I+1, 3);
                  insert('.SHL.', Expression, I+1);
                  end;
               end;
            end;  //if InsideConstantDeclaration

         I := 1;
         L := length(Expression);
         S := '';
         Brackets := 0;
         while I <= L do
            begin
            Ch := Expression[I];
            if CH = '(' then
               inc(Brackets);
       //first get simple expressions like "1+1" to s
            if CharInSet (Ch, ['0'..'9','(',')','+','-','*','/',' ','.']) then
               begin
               if CH = '.' then
                  begin
                  if copy(Expression, I, 5) = '.MOD.' then
                     begin
                     S := S + '.MOD.';
                     I := I+5;
                     goto XX;
                     end;

                  if copy(Expression, I, 5) = '.AND.' then
                     begin
                     S := S + '.AND.';
                     I := I+5;
                     goto XX;
                     end;

                  if copy(Expression, I, 4) = '.OR.' then
                     begin
                     S := S + '.OR.';
                     I := I+4;
                     goto XX;
                     end;

                  if copy(Expression, I, 5) = '.XOR.' then
                     begin
                     S := S + '.XOR.';
                     I := I+5;
                     goto XX;
                     end;

                  if copy(Expression, I, 5) = '.SHL.' then
                     begin
                     S := S + '.SHL.';
                     I := I+5;
                     goto XX;
                     end;

                  if copy(Expression, I, 5) = '.SHR.' then
                     begin
                     S := S + '.SHR.';
                     I := I+5;
                     goto XX;
                     end;
                  end
               else  // if Ch <> '.'
                  begin
XX:
                  if CH = ')' then
                     if Brackets > 0 then
                        begin
                        dec(Brackets);
                        end
                     else
                        begin
                        Expression := S;
                        exit; //end of expression reached
                        end;

                  S := S + Expression[I];
                  inc(I);
                  end;
               end  // if InsideConstantDeclaration
            else if CH = '$' then  //convert a hex constant
               begin
               V := 0;
               inc(I);
               while (I <= L) and (CharInSet (Expression[I], ['0'..'9','A'..'F'])) do
                  begin
                  V := V * 16 + HexCharToDec(Expression[I]);
                  inc(I);
                  end;
               S := S + IntToStr(V);
               end
            else if CH = '%' then  //convert a binary constant
               begin
               V := 0;
               inc(i);
               while (I <= L) and (CharInSet (Expression[I], ['0'..'1'])) do
                  begin
                  V := V * 2 +(ord(Expression[i]) - $30);
                  inc(I);
                  end;
               S := S + IntToStr(V);
               end
            else
               begin //could be constant identifier
               Remember := I;
               CF := '';
               while (I <= L) and (CharInSet (Expression[I], ['A'..'Z','_','0'..'9'])) do
                  begin
                  CF := CF + Expression[I];
                  inc(I);
                  end;

               if copy (CF, 1, 6) = 'SIZEOF' then
                  begin
                  J := FindLocation(CF);
               if J > 0 then
                  if IdentifierTable[J].Obj <> TFunc then
                     goto FD;
               GetIdentifierInParanthesis(I, L);
               J := FindLocation(ParserLookAhead);
               if J = 0 then
                  begin
                  Expression := S;
                  exit;
                  end;

               if IdentifierTable[J].Obj in [TType, TVariable] then
                  begin
                  S := S + IntToStr(IdentifierTable[J].Size);
                  ParserLookAhead := '';
                  end;
               end   // while (I <=L)
            else
               begin
               J := FindLocation(CF);
FD:
               if J = 0 then
                  begin
FX:
             //s ends in non expression character.
             //remove any overread components and add them to parserlookahead
                  I := Remember;
                  while (length(S) > 0) and (CharInSet (S[length(S)], ['+','-','*','/',' ','('])) do
                     begin
   //ss               dec(S[0]);
                     DecStringLength (S);
                     dec(i);
                     end;

                  ParserLookAhead := copy(Expression, I, 255) + StoreLastChar;
                  LastCharFromSource := ' ';
                  Brackets := 0;
                  goto done;
                  end;

               if IdentifierTable[J].Obj <> TConstant then
                  goto fx;
               if IdentifierTable[J].Typ in [BYTES,WORDS,INTS,LINTS,BOOLS] then
                  begin
                  S := S + IntToStr(IdentifierTable[J].Value);
                  ParserLookAhead:='';
                  end;

                  end;
               end;
            end;
Done:
         Expression := S;
         I := 1;
         while i<=length(Expression) do
            if Expression[I] = ' ' then
               delete(Expression, I, 1)
            else
               inc(I);
         end;

{====================}

      function ExpressionToChar(S: string): char;                                   // short

         var  L,V,I: word;
              IsHex: boolean;

         begin
         L := length(S);
         if L = 0 then
            CError(6);
         V := 0;
         I := 1;
         IsHex := false;
         if S[1] = '$' then
            begin
            I := 2;
            IsHex := true;
            end;

         while I <= L do
            begin
            if IsHex then
               begin
               if CharInSet (S[I], ['0'..'9','A'..'F','a'..'f']) then
                  V := V * 16 + HexCharToDec(S[I])
               else
                  CError(6);
               inc(I);
               end
            else
               begin
               if CharInSet (S[I], ['0'..'9']) then
                  V := V * 10 + HexCharToDec(S[I])
               else
                  CError(6);
               inc(I);
               end;
            end;  // while I

         if V > 255 then
            CError(21);
         result := char(V);
         end;

{====================}

   begin { GetNextSymbol }
   DoubleDot := false;
   if CancelCompile
      then CError(111);
1: while LastCharFromSource = ' ' do
      ReadNextCharFromSource;

   if LastCharFromSource = '}' then
      ReadNextCharFromSource;

   if CharTypes[LastCharFromSource] = ILLEGAL then
      begin
      ReadNextCharFromSource;
      CERROR(24);
      end;

   case LastCharFromSource of

      'A'..'Z','_',
      'a'..'z','@'  :
         begin    (* identifier or wordsymbol *)
         K  := 0;
         Identifier := '';

         repeat
            if K < 255 then
               begin
               K := K + 1;
               Identifier := Identifier + UpCase( LastCharFromSource );
               end;

            ReadNextCharFromSource;
            until ((LastCharFromSource <> '_') and (CharTypes[LastCharFromSource] in [SPECIAL,ILLEGAL])) or (Identifier = '@');

//      I := 1;
//      J := NumberOfKeywords;   (*BINARY SEARCH*)
//      repeat
//         K := (I + J) div 2;
//         if Identifier <= KeyWords[K] then
//            J := K - 1;
//      if Identifier >= KeyWords[K] then
//            I := K + 1;
//         until I > J;
//      if I - 1 > J then
         K := KeywordList.IndexOf (Identifier);
         if K <> -1 then
            LastSymbol := KeyWordSymbol[K]
         else
            LastSymbol := IDENT;

         if ParserOptimizer and (LastSymbol = IDENT) then
            begin
            J := FindLocation(Identifier);
            if J <> 0 then
               begin
               if (IdentifierTable[J].Obj = TConstant) then
                  begin
                  if (IdentifierTable[J].Typ <= LINTS) then
                     begin
                     Expression := Identifier;
                     Brackets := 0;
                     goto 4;
                     end;
                  end
               else if uppercase(Identifier) = 'SIZEOF' then
                  begin
                  Expression := Identifier;
                  Brackets:=0;
                  goto 4;
                  end
               else if InsideConstantDeclaration then
                  if uppercase(Identifier) = 'CHR' then
                     begin
                     GetNextSymbol;
                     if LastSymbol <> LPARENT then
                        CError(9);
                     GetNextSymbol;
                     if LastSymbol in [BYTECON,CHARCON,BOOLCON] then
                        begin
                        GetNextSymbol;
                        if LastSymbol <> RPARENT then
                           CError(4);
                        LastSymbol := CHARCON;
                        StringContent := char(IntegerNumeric);
                        end
                     else
                        CError(25);
                     end
                  else if Uppercase(Identifier) = 'ORD' then
                     begin
                     GetNextSymbol;
                     if LastSymbol <> LPARENT then
                  CError(9);
                  GetNextSymbol;
                  TS := LastSymbol;
                  GetNextSymbol;
                  if LastSymbol <> RPARENT then
                     CError(4);
                  LastSymbol := TS;
                  if LastSymbol in [CHARCON,BOOLCON] then
                     LastSymbol := BYTECON;
                  end;
               end;
            end;
         end;

      '^':
         begin
         LastSymbol := CARET;
         ReadNextCharFromSource;
         end;

      '0'..'9','$','%':
         begin { NUMBER }
         Expression := '';
         StoreLastChar := ' ';
         Brackets := 0;
         if InsideConstantDeclaration then
            begin
            while CharInSet (LastCharFromSource, ['0'..'9','A'..'Z','a'..'z','+','-','*','/','(',')','$','%','_',' ']) do
               begin
               if not InsideConstantDeclaration then
                  if LastCharFromSource = ' ' then
                     break;

               if (LastCharFromSource = '/') and (length(Expression) > 0) and (Expression[length(Expression)] = '/') then
                  begin
                  StoreLastChar := '/';
                  goto 5;
                  end;

               if LastCharFromSource = '(' then
                  inc(Brackets)
               else if LastCharFromSource = ')' then
                  if Brackets > 0 then
                     dec(Brackets)
                  else
                     begin
                     StoreLastChar := ')';
                     goto 5;
                     end;

               Expression := Expression + LastCharFromSource;
               ReadNextCharFromSource;
4:
               end;
            end
         else
            begin
            while CharInSet (LastCharFromSource, ['0'..'9','A'..'Z','a'..'z','$','%','_']) do
               begin
               Expression := Expression + LastCharFromSource;
               ReadNextCharFromSource;
               end;
            end;

         StoreLastChar := LastCharFromSource;
5:       SimplifyExpression;
         if not EvaluateExpression(IntegerNumeric,Expression) then
            begin
            ParserLookAhead := Expression + ParserLookahead;
            Expression := '';
            ReadNextCharFromSource;
            while CharInSet (LastCharFromSource, ['0'..'9']) do
               begin
               if not InsideConstantDeclaration then
                  if LastCharFromSource=' ' then
                     break;
               Expression := Expression + LastCharFromSource;
               ReadNextCharFromSource;
               end;

            if not EvaluateExpression(IntegerNumeric,Expression) then
               CError(92);
            end;

         LastSymbol := INTCON;
         if (IntegerNumeric >= 0) and (IntegerNumeric < 256) then
            LastSymbol:=BYTECON
         else if (IntegerNumeric >= 0) and (IntegerNumeric < 65536) then
            LastSymbol := WORDCON
         else if (IntegerNumeric >= -32768) and (IntegerNumeric < 32768) then
            LastSymbol:=INTCON
         else LastSymbol:=LINTCON;

         if LastCharFromSource = '.' then
            begin
            ReadNextCharFromSource;
            if LastCharFromSource = '.' then
               begin
               LastCharFromSource := ':';
               DoubleDot:=true;
               end
            else
               begin
               FS := IntToStr(IntegerNumeric);
               K := length(FS);
               LastSymbol := SINGLECON;
               RealNumeric := IntegerNumeric;
               E := 0;
               while CharTypes[LastCharFromSource] = NUMBER do
                  begin
                  E := E-1;
                  RealNumeric := 10.0 * RealNumeric + (ord(LastCharFromSource)-ord('0'));
                  ReadNextCharFromSource
                  end;

               if E = 0 then
                  CERROR(40);
               if upcase(LastCharFromSource) = 'E' then
                  ReadScale;
               if E <> 0 then
                  AdjustScale;
               SingleNumeric := RealNumeric;
               ConvertZ80Single (SingleNumeric, IntegerNumeric);
               end;
            end
         else
            if UpCase(LastCharFromSource) = 'E' then
               begin
               LastSymbol := SINGLECON;
               RealNumeric := IntegerNumeric;
               E := 0;
               ReadScale;
               if E <> 0 then
                  AdjustScale;
               SingleNumeric := RealNumeric;
               ConvertZ80Single(SingleNumeric,IntegerNumeric);
               end;
            end;
      ':' :
         begin
         ReadNextCharFromSource;
         if LastCharFromSource = '=' then
            begin
            LastSymbol := BECOMES;
            ReadNextCharFromSource;
            end
         else
            begin
            LastSymbol := COLON;
            DoubleDot:=false;
            end;
         end;

      '<' :
         begin
         ReadNextCharFromSource;
         if LastCharFromSource = '=' then
            begin
            LastSymbol := LEQ;
            ReadNextCharFromSource;
            end
         else if LastCharFromSource = '>' then
            begin
            LastSymbol := NEQ;
            ReadNextCharFromSource;
            end
         else
            LastSymbol := LSS;
         end;

      '>' :
         begin
         ReadNextCharFromSource;
         if LastCharFromSource = '=' then
            begin
            LastSymbol := GEQ;
            ReadNextCharFromSource;
            end
         else
            LastSymbol := GTR;
         end;

      '.' :
         begin
         ReadNextCharFromSource;
         if LastCharFromSource = '.' then
            begin
            LastSymbol := COLON;
            DoubleDot := true;
            ReadNextCharFromSource;
            end
         else
            LastSymbol := PERIOD;
         end;

      '''','#':
         begin
         K := 0;
         StringContent := '';
X2:
         if LastCharFromSource = '#' then
            begin
            Expression := '';
            ReadNextCharFromSource;

            while CharInSet (LastCharFromSource, ['0'..'9','A'..'F','a'..'f','$']) do
               begin
               Expression := Expression + LastCharFromSource;
               ReadNextCharFromSource;
               end;

            ParserLookahead:=LastCharFromSource;
            StringContent:=StringContent+ExpressionToChar(Expression);
            inc(K);
            end
         else
            begin
2:          ReadNextCharFromSource;

            if LastCharFromSource = '''' then
               begin
               ReadNextCharFromSource;
               if LastCharFromSource <> '''' then
                  goto 3;
               end;

            StringContent := StringContent + LastCharFromSource;
            inc(K);
            if CharacterCounter = 1 then
               CError(96) (*END OF LINE*)
            else
               goto 2;
            end;

         ReadNextCharFromSource;
3:
         while LastCharFromSource = ' ' do
            ReadNextCharFromSource;
         if LastCharFromSource = '+' then
            begin
            ReadNextCharFromSource;
            while LastCharFromSource = ' ' do
               ReadNextCharFromSource;

            if CharInSet (LastCharFromSource, ['#','''']) then
               goto x2
            else
               begin
               ParserLookAhead := '+' + LastCharFromSource;
               LastCharFromSource := ' ';
               end;
            end;

         if K = 1 then
            begin
            LastSymbol := CHARCON;
            IntegerNumeric := ord(StringContent[1]);
            end
         else if K = 0 then
            begin
            LastSymbol := STRINGCON;
            StringLength := 0;
            IntegerNumeric := 0;
            end
         else
            begin
            LastSymbol := STRINGCON;
            IntegerNumeric := 0;
            StringLength := K;
            end;
         end;

      '(' :
         begin
         ReadNextCharFromSource;
         if LastCharFromSource <> '*' then
            LastSymbol := LPARENT
         else
            begin    (* comment *)
            ReadNextCharFromSource;

            repeat
               while LastCharFromSource <> '*' do
                  ReadNextCharFromSource;
               ReadNextCharFromSource
               until LastCharFromSource = ')';

            ReadNextCharFromSource;
            goto 1;
            end
         end;

      '{' :
         begin            (* comment *)
         ReadNextCharFromSource;
         case LastCharFromSource of
            '}':
               begin
               end;
            '#':
               begin
               ReadNextCharFromSource;
               case upcase(LastCharFromSource) of
                  'I': IncludeAFile;
                  'S': ShareData;
                  'C': if Conditionals = true then
                     exit;
                  'L':
                     LabelModifier;
                  'P':
                     PassThrough;
                  'K':
                     SetDynamics;
                  'X':
                     PointerBending;
                  'R':
                     SetRegisterTrack;
                  'B':
                     Casting;
                  'E':
                     ExLPM;
                  else
                     CError(89)
                  end;
               end;

            '*':
               begin
               ReadNextCharFromSource;
               If LastCharFromSource = '}' then
                  begin
X1:
                  while LastCharFromSource <> '{' do
                     ReadNextCharFromSource;
                  ReadNextCharFromSource;
                  if LastCharFromSource <> '*' then
                     goto x1;
                  ReadNextCharFromSource;
                  if LastCharFromSource<>'}' then
                     goto x1;
                  end  // if LastCharFromSource
               else if LastCharFromSource = '!' then
                  begin
                  DelphiOnlyComment := true;
                  end;
               end; // case '*'
            else
               begin
               while LastCharFromSource <> '}' do
                  ReadNextCharFromSource;
               end;
            end; // case

         ReadNextCharFromSource;
         goto 1;
         end;

      '/':
         begin
         ReadNextCharFromSource;
         if LastCharFromSource = '/' then
            begin
            ReadToEndOfLine;
          //ParserLookahead:='';
            ReadNextCharFromSource;
            goto 1;
            end
          else
             LastSymbol := SPS['/'];
          end;

      '+', '-', '*', ')', '=', ',', '[', ']',  ';' :
         begin
         LastSymbol := SPS[LastCharFromSource];
         ReadNextCharFromSource;
         end;

      '!':
         begin
         if DelphiOnlyComment then
            begin
            ReadNextCharFromSource;
            if LastCharFromSource = '*' then
               begin
               ReadNextCharFromSource;
               if LastCharFromSource = '}' then
                  begin
                  ReadNextCharFromSource;
                  goto 1;
                  end;
               end;
            end;
         CERROR(24);
         end;

      '\', '?', '"', '&' :
         begin
         CERROR(24);
         end;
      end;
end; { GetNextSymbol }

end.

