unit PascalDefs;
{H-}
interface

uses SysUtils,Classes, System.Contnrs;

const
    SizeOfArrayBlock =  500;
    SizeOfBlockTable =  500;
    MaximumCases = 100;
    MaxRealExponent = 63;
    MinRealExponent = -64;
    HEADER = 'Embedded Pascal AVR Windows 95/98/NT';
    MaxSignificantDigits = 10;
    NumberOfKeywords = 55;
    LargestInteger = MAXINT;
    MaximumLevel = 7;
    ORDMINCHAR = 0;
    ORDMAXCHAR = 255;
    STMAX = 1100;
    STKINCR = 200;
    SizeOfIdentifierTable = 20000;
    NumberOfForwardDeclarations = 500;
    NotAbsolute = 0;
    DirectAbsolute = 1;
    IndirectAbsolute = 2;
    NumberOfIncludeFiles = 5;
    NumberOfRecordingPointers = 2000;
    NumberOfWithStatements = 10;
    prjTitle = 0;
    prjPath = 1;
    prjTargets = 2;
    prjCpuDef = 3;
    prjMainFile = 4;
    prjInclude = 5;

type
    TRRCRec = record
       Data: array [1..255] of byte;
       Count: byte;
       end;

    TIncludeFile= record
       IFile: file;
       IncludeFileName: string;                                     //ss [128];
       IncludeErrorLine,
       IncludeKey,
       IncludeBufferPtr: word;
       CharsInIncludeBuffer: Integer;
       EndOfIncludeFile: boolean;
       IncludeSourceBuffer: array[0..255] of byte;
       IncludeLineNumber:  word;
       IncludeSource: TStringList;
       end;

     TMEMTypes= (CodeMem,DataMem);
     POBJECT = ( TConstant, TVariable, TType, TProcs, TFunc, TLabels    );
     TYPES  = ( NOTYP, BYTES, SINTS, WORDS, INTS, TRIPPLETS, LINTS, BOOLS, SINGLES, CHARS, CSTRINGS, ARRAYS, RECORDS,
                LABELS, TSHARE );
     CharType   = ( LETTER, LOWCASE, NUMBER, SPECIAL, ILLEGAL);

     ITEM   = record
                TYP: TYPES;
                PTR: boolean;
                REF: word;
              end;

     TypeSet = SET of TYPES;

     TSTAccess = (StOnStack,STFromAddress,STAddress,STLiteral,STPointer,STOnFrame);
     TSTTypes = (STByte,STWord,STInt,STTRIP,STLint,STString,STArray,STRecord,STValue,STBaseAddress);
     TST = record
             Offset,ElSize: longint;
             Access: TSTAccess;
             Types: TSTTypes;
             Constant: boolean;
             case integer of
             0: (Value: longint);
             1: (RealValue: single);
           end;

const KeyWords : array[1..NumberOfKeywords] of string =                          //ss [14]
          ( 'ABSOLUTE', 'AND', 'ARRAY', 'ASM', 'AT',
            'BEGIN', 'BREAK', 'CASE',
            'CONST', 'CONTINUE', 'DIV',
            'DO', 'DOWNTO', 'E2CONST', 'E2VAR',
            'ELSE', 'END', 'EXIT', 'EXTERNAL',
            'FOR','FORWARD','FUNCTION','GLOBAL','GOTO',
            'IF','IMPLEMENTATION','IN','INTERFACE','LABEL','MOD',
            'NOT', 'OF',
            'OR', 'PROCEDURE',
            'PROGRAM', 'RECORD',
            'REPEAT', 'RL', 'RR', 'SHARE', 'SHL', 'SHR', 'STRING',
            'THEN', 'TO', 'TYPE','UNIT',
            'UNTIL', 'USES', 'VAR', 'VECTOR', 'WHILE', 'WITH', 'XOR', '');


type  SYMBOL = ( BOOLCON, BYTECON, INTCON, WORDCON, LINTCON, SINGLECON, CHARCON, STRINGCON, ISWORD,
                 PLUS, MINUS, TIMES, IDIV, RDIV, IMOD,
                 NOTSY, ANDSY, ORSY, SHLSY, SHRSY, RRSY, RLSY,
                 EQL, NEQ, GTR, GEQ, LSS, LEQ,
                 LPARENT, RPARENT, LBRACK, RBRACK,
                 COMMA, SEMICOLON, PERIOD, COLON,
                 BECOMES, CONSTSY, TYPESY, VARSY, ARRAYSY, RECORDSY, STRINGSY,
                 FUNCSY, PROCSY, PROGRAMSY, IDENT, BEGINSY, ENDSY,
                 REPEATSY, UNTILSY, WHILESY, DOSY, FORSY, WITHSY,
                 IFSY, THENSY, ELSESY, CASESY, OFSY, TOSY, DOWNTOSY, DUMMYSY,
                 EXTERNALSY,GLOBALSY,FORWARDSY,LABELSY,GOTOSY,ABSOLUTESY,XORSY,
                 ASMSY,CONTINUESY,BREAKSY,EXITSY,INSY,CARET,E2VARSY,E2CONSTSY,
                 USESSY,UNITSY,INTERFACESY,IMPLEMENTATIONSY,VECTORSY,SHARESY );

      SYMSET = SET OF SYMBOL;

const KeyWordSymbol : array[1..NumberOfKeywords] of SYMBOL =
            ( ABSOLUTESY,ANDSY,ARRAYSY,ASMSY,ABSOLUTESY,BEGINSY,BREAKSY,CASESY,
              CONSTSY,CONTINUESY,IDIV,
              DOSY,DOWNTOSY,E2CONSTSY,E2VARSY,ELSESY,ENDSY,
              EXITSY,EXTERNALSY,
              FORSY,FORWARDSY,FUNCSY,GLOBALSY,GOTOSY,IFSY,IMPLEMENTATIONSY,INSY,
              INTERFACESY,LABELSY,IMOD,
              NOTSY,OFSY,ORSY,PROCSY,
              PROGRAMSY,RECORDSY,REPEATSY,RLSY, RRSY, SHARESY, SHLSY, SHRSY, STRINGSY, THENSY,
              TOSY,TYPESY,UNITSY,UNTILSY,USESSY,VARSY,VECTORSY,WHILESY,WITHSY,XORSY,dummySY);

      BitMask: array[0..7] of byte = (1,2,4,8,$10,$20,$40,$80);
      LongMask: array[0..31] of cardinal =
      (1,2,4,8,$10,$20,$40,$80,
       $100,$200,$400,$800,$1000,$2000,$4000,$8000,
       $10000,$20000,$40000,$80000,$100000,$200000,$400000,$800000,
       $1000000,$2000000,$4000000,$8000000,$10000000,$20000000,$40000000,$80000000);
var
//  BList: TBinaryList;
//  MacList: TBInaryList;
  ExePath: string;
  RRCList: array of TRRCRec;
  TotalSourceLines: integer;

    ERRPOS   : INTEGER;
    SKIPFLAG : BOOLEAN;

    LastSymbol    : SYMBOL;
    Identifier    : string;                                                      //ss  short
    IntegerNumeric  : LongInt;
    RealNumeric  : REAL;
    SingleNumeric: Single;
    StringLength : INTEGER;
    CharTypes: ARRAY[CHAR] OF CharType;
    CurrentLine:   string;                                                       //ss  short
    LastLine: String;
    CharacterCounter   : INTEGER;
    LineLength    : INTEGER;
    LINECOUNT: INTEGER;

    StringContent,
    StringAssembly:   string;                                                    //ss short
    ParserLookAhead: string;                                                     //ss short

    TCast: ITEM;

    CONSTBEGSYS, TYPEBEGSYS,
    BLOCKBEGSYS, FACBEGSYS, STATBEGSYS : SYMSET;

  DATA,AsmFile: textfile;
  Source: File;
  INTFile: Textfile;
  SourceFileName:   string;   //update from String
  MainFilename,
  OutputFilename: String;
  DISPLAY : ARRAY [ 0 .. MaximumLevel ] of INTEGER;
  SPS: ARRAY [ ' '.. ']' ] of SYMBOL;
  LastCharFromSource: Char;    //ss   ansichar
  StandardTypes:TypeSet;
  ProgramName: String;
  m, n:    integer;
  DEBUG:    boolean;

  PascalSource: TStringList;
  SourceLineNumber: integer;
  PascalSourceLine: string;

    IdentifierTable: array [0 .. SizeOfIdentifierTable] of record
      NameLookup,HASHID: word;
      LINK  : word;
      OBJ   : POBJECT;
      TYP   : TYPES;
      REF   : word;
      LEV   : 0 .. MaximumLevel;
      Value : LongInt;
      IsAbsolute,NumberOfParameters: byte;
      PROCREF,ADR,Size,Block,address,ptr,SizeIfPointer,SharedWith,
      StackOffset,StackUse,Parametersize: word;
      TypedConstant,Field,Extern,Global,IsPointer,Normal,ResetShare,E2Var,
      IsDynamic: Boolean;
    end;

    ArrayTable: array [1 .. SizeOfArrayBlock] of record
      INXTYP, ELTYP: TYPES;
      ELREF, LOW, HIGH, ELSIZE, SIZE: word;
      IDREF, ElSizeIfPtr : word;
      IsArrayOfPointers: boolean;
    end;

    BlockTable: array [ 1..SizeOfBlockTable ] of record
      LAST,LASTPAR,PSIZE,VSIZE :  word;
    end;

    BlockTableIndex,
    IdTableIndex,
    ArrayTableIndex: integer;

    CPU: string;
    ZeroStringIs,
    StackStringConstant: string;                                                 //ss [128];

    StoreLastChar:  char;    //ss   ansichar
//    SplashID: ansichar;

    LastLabelID,
    CurrentProcedureIndex,
    CurrentIncludeFile,
    LevelForParser,
    ShareDataWith,
    NumberOfRecordings,
    RecordingStart,
    RecordingStartSize,
    ProgramLocationCounter,
    NumberOfWiths,
    TCastTypeSize,
    IntLineLength,
    ReadingUnitNumber,
    ErrorLine,
    Key,
//    RTXTimer,
//    EFTimer,
    IDAtIODEFStart,
    MaxStringSize,
    TShareSize,
    NumberOfWithPointers: word;

    KeywordList,
    AsmOutput,
    AsmConstList,
    Externals,
    Globals,
    Forwards,
    IdentifierNames: TStringlist;

    StringConstantsUsed,
    StringConstants: TStringlist;   //special

    CallParameters,
    DoubleDot,
    IncludePAS,
    FirstEOL,
    DelphiOnlyComment,
    InsideConstantDeclaration,
    ParserOptimizer,
    SharedData,
    NextVarResetsShare,
    DynamicVars,
    PreviousDynamicVars,
    HasMult,
    RegisterTrack,
    NextIsZeroSizeOnly,
    ConditionalSkip,
    ConditionalElse,
    UsesAddStrings,
    ProgramNameInLabel,
    SourceEncrypted,
    CancelCompile,
    EndOfSourceFile,
//    PascalHasEncodedParts,
    IsDynamic,
    ItemLocation,
    NextPointerIsCode,
    RunningFromCommandLine,
    WithIsActive,
    ROM4K,
    AllowAnyCast,
    UnitSystem,
    InterfaceSection,
    InsideUsesClause,
    ReadingFromUnit,
    OldDynamicVars,
    StackStringIsZero,
    StackStringIsConstant,
    AdvancedLPM,
    IdentLocation: boolean;

    DataSize,
    CodeSize,
    E2DataSize,
    CodeLinkAddress,
    CodeLoadAddress,
    DataLinkAddress,
    TotalLines,
    LastLineNumber,
    StackEstimate,
    ConstPlacement: LongInt;

    ForwardDeclaration: array[0..NumberOfForwardDeclarations] of
       record
       BlockTableIndex,
       FirstParameter,
       NumberOfParameters,
       CurrentProcedureIndex: word;
       end;

    RecordingPointer: array[0..NumberOfRecordingPointers] of
       record
       F,
       T: longint;
       end;

    LoadAddressSymbol: string;
    IncludeFile: array[1..NumberOfIncludeFiles] of TIncludeFile;

    WithInfo: array[0..NumberOfWithStatements-1] of
       record
       ID,
       LabelID: word;
       end;

    FontSize: integer;
    FontName,
    cmd,
    cmdfile,
    cmdprj,
    ErrorMsg: string;

    ST: array[0..20] of TST;
    STP: word;

    LevelOffset,
    ResultSize: array[0..MaximumLevel] of word;

    PointerBend,
    PreviousPointerBend,
    OldPointerBend: TMemTypes;


implementation

end.
