unit StringConversion;

interface

uses System.SysUtils;

type


   TXMLField = record
      DataType: char;
      Data: string;
      end;

function ShortToStr(Value: shortstring): String;
procedure StrToShort(const S: String; var RetVal);
//procedure IncStringLength(var S: string);
procedure DecStringLength(var S: string);
function GetXmlData (Line: string; var N: word): TXMLField;
function GetHashID (S: string): word;

const
   XMLFieldCount = 30;

var
  XMLField: array [1..XMLFieldCount] of TXMLField;

implementation

type
  EShortStringConvertError = class(Exception)
  end;

{==============================================================================}

  function GetHashID (S: string): word;

     begin
     if S = '' then
        result := 0
     else
        begin
        result := length (S);
        if length (S) > 1 then
           begin
           result := result or (ord (S[1]) shl 8);
           result := result or ord (s[2]);
           end
        else
           result := result or (ord (S[1]) shl 8);
        end;
     end;

{==============================================================================}

  function GetXmlData (Line: string; var N: word): TXMLField;

   begin
   result.DataType := #0;
   result.Data := '';

   while (Line[N] <> '<') and  (N <= length (Line)) do
      inc (N);
   inc (N);
   if Line[N] <> '\' then
      exit;
    inc (N);
    result.DataType := Line [N];
    inc (N);
    while (Line[N] <> '>') and (N <= length (Line)) do
       begin
       if Line[N] = '''' {#39} then
          begin
          result.Data := result.Data + Line[N];
          inc (N);
          while Line[N] <> '''' {#39} do
             begin
             result.Data := result.Data + Line[N];
             inc (N);
             end;
          end;
       result.Data := result.Data + Line[N];
       inc (N);
       end;
    if result.DataType = 'D' then
       result.Data := 'D' + result.Data;
    end;

function ShortToStr(Value: shortstring): String;
var
  B: TBytes;
  L: Byte;
begin
  Result := '';
  L := ord(Value[0]);
  SetLength(B, L);
  Move(Value[1], B[0], L);
  Result := TEncoding.Ansi.GetString(B);
end;

procedure StrToShort(const S: String; var RetVal);
var
  L: Integer;
  P: PByte;
  B: TBytes;
begin
  L := Length(S);
  if L > 255 then
    raise EShortStringConvertError.Create
      ('Strings longer than 255 characters cannot be converted');
  SetLength(B, L);
  P := @RetVal;
  P^ := L;
  Inc(P);
  B := TEncoding.Ansi.GetBytes(S);
  Move(B[0], P^, L);
end;

{procedure IncStringLength(var S: string);

begin
  SetLength(S, S.Length + 1);
end;
}
procedure DecStringLength(var S: string);

begin
  SetLength(S, S.Length - 1);
end;

{ procedure DoTest;
  var
  S: String;
  OldS: array[0..17] of Byte;  // Replacing string[17]
  begin
  S := ShortStringToString(Value);
  WriteLn('#1 S=', S);
  S := 'Excellence';
  StringToShortString(S, OldS);
  S := '';
  S := ShortStringToString(OldS);
  WriteLn('#2 S=', S);
  end;

  begin
  try
  DoTest;
  except
  on E: Exception do
  begin
  WriteLn('FAIL - Unexpected Exception');
  WriteLn('  ClassName=', E.ClassName);
  WriteLn('    Message=', E.Message);
  end;
  end;
}
end.
